      subroutine fonfrac(xc,ipi,qp2,xdup,xdubp,xddp,xddbp,xdsp,xdcp
     # ,xdbp,xdbbp,xdgp)
c This routine returns xc*the fragmentation functions
c xc is the fragmentation variable
C qp2 is the scale in GeV^2
c ipi is a flag to select the three sets
c ipi = 1: best fit (formula (8)) of hep-ph/0009101
c ipi = 2: large Ng set (formula (9)) of hep-ph/0009101
c ipi = 3: low Ng set (formula (10)) of hep-ph/0009101
      implicit real*8 (a-h,l-z)
      if (ipi.eq.1) then
        call fra_mar2000(xc,qp2,'up',tdup)
        xdup=tdup*xc
        xdubp=xdup
        call fra_mar2000(xc,qp2,'do',tddp)
        xddp=tddp*xc
        xddbp=xddp
        call fra_mar2000(xc,qp2,'sb',tdsp)
        xdsp=tdsp*xc
        call fra_mar2000(xc,qp2,'cb',tdcp)
        xdcp=tdcp*xc
        call fra_mar2000(xc,qp2,'bb',tdbp)
        xdbp=tdbp*xc
        xdbbp=tdbp*xc
        call fra_mar2000(xc,qp2,'gl',tdgp)
        xdgp=tdgp*xc
      else if (ipi.eq.2) then
        call fra_fev2000(xc,qp2,'up',tdup)
        xdup=tdup*xc
        xdubp=xdup
        call fra_fev2000(xc,qp2,'do',tddp)
        xddp=tddp*xc
        xddbp=xddp
        call fra_fev2000(xc,qp2,'sb',tdsp)
        xdsp=tdsp*xc
        call fra_fev2000(xc,qp2,'cb',tdcp)
        xdcp=tdcp*xc
        call fra_fev2000(xc,qp2,'bb',tdbp)
        xdbp=tdbp*xc
        xdbbp=tdbp*xc
        call fra_fev2000(xc,qp2,'gl',tdgp)
        xdgp=tdgp*xc
      else if (ipi.eq.3) then
        call fra_apr2000(xc,qp2,'up',tdup)
        xdup=tdup*xc
        xdubp=xdup
        call fra_apr2000(xc,qp2,'do',tddp)
        xddp=tddp*xc
        xddbp=xddp
        call fra_apr2000(xc,qp2,'sb',tdsp)
        xdsp=tdsp*xc
        call fra_apr2000(xc,qp2,'cb',tdcp)
        xdcp=tdcp*xc
        call fra_apr2000(xc,qp2,'bb',tdbp)
        xdbp=tdbp*xc
        xdbbp=tdbp*xc
        call fra_apr2000(xc,qp2,'gl',tdgp)
        xdgp=tdgp*xc
      endif
      return
      end
c
c------------------------------------------------------------
c------------- subroutine to compute a point in x and q**2 --
c------------- for the following fragmentation functions:  --
c-------------     gluon,  up   ,down,                     --
c-------------        strange , charm , bottom.            --
c------------- range of validity :                         --
c-------------                    1.e-03 < x < .99         --
c-------------                    2  < q**2 < 11900 GeV^2  --
c------------------------------------------------------------
c-------------        authors :    L. Bourhis
c-------------                     M. Fontannaz
c-------------                     J.Ph. Guillet
c-------------                     M. Werlen
c-------------    q02=2gev2         method p.nason
c-------------    next to leading evolution
c-------------    table pour la fragmentation en hadrons charges
*         i = 1    gluon
*         i = 2    down ( = antidown )
*         i = 3    up ( = antiup )
*         i = 4    strange ( = antistrange )
*         i = 5    charm ( = anticharm )
*         i = 6    bottom ( = antibottom )
* parametrisation of Mars 2000: formula (8) from the paper
c------------------------------------------------------------
      subroutine  fra_mar2000(z,qstar2,strfun,func)
      implicit real*8 (a-h,o-z)
c------------------------------------------------------------
c-------------   z is x and qstar2 is q square  -------------
      character*(*) strfun
c------------------------------------------------------------
c------------ strfun specifies the desired function----------
c------------------------------------------------------------
c------------------------------------------------------------
c        ifun =  1     gluon           'gl'
c                2     down            'do'
c                3     up              'up'
c                4     strange         'sb'
c                5     charm           'cb'
c                6     bottom          'bb'
c------------------------------------------------------------
c-------------  func is the output (parton density value)----
c------------------------------------------------------------
      parameter (ix=76,iq=8,ig1=76,kfun=6)
      parameter (igt=4)
c------------------------------------------------------------
c-----------input tables are given as  33 x points at 7 q**2
c-----------positions
c------------------------------------------------------------
      dimension x(ix),y(iq),f(ix,iq)
      dimension d(ig1)
      dimension xqdum(ix,iq,kfun)
      dimension q2(iq),xco(ix)
      dimension x1a(igt),x2a(igt),ya(igt,igt)
c------------------------------------------------------------
c----------- next the 7 q**2 of the input tables are defined
****                                         q2fin= final scale (gev**2)
****                                         q2fin= final scale (gev**2)
      data q2 /2.,11.9,23.8,119.,238.,1190.,2380.,11900./
c------------------------------------------------------------
c----------------------------------------------------------------
c----------- and now the  76 x positions ------------------------
c----------------------------------------------------------------
 
      data xco   /
     +0.1115d-02,0.1237d-02,0.1371d-02,0.1521d-02,0.1687d-02,0.1871d-02,
     +0.2075d-02,0.2301d-02,0.2552d-02,0.2830d-02,0.3139d-02,0.3481d-02,
     +0.3860d-02,0.4281d-02,0.4748d-02,0.5266d-02,0.5840d-02,0.6476d-02,
     +0.7182d-02,0.7966d-02,0.8834d-02,0.9797d-02,0.1087d-01,0.1205d-01,
     +0.1336d-01,0.1482d-01,0.1644d-01,0.1823d-01,0.2022d-01,0.2242d-01,
     +0.2487d-01,0.2758d-01,0.3058d-01,0.3392d-01,0.3762d-01,0.4172d-01,
     +0.4627d-01,0.5131d-01,0.5690d-01,0.6311d-01,0.6999d-01,0.7762d-01,
     +0.8608d-01,0.9547d-01,0.1059d+00,0.1174d+00,0.1302d+00,0.1444d+00,
     +0.1602d+00,0.1776d+00,0.1970d+00,0.2185d+00,0.2423d+00,0.2687d+00,
     +0.2980d+00,0.3305d+00,0.3666d+00,0.4065d+00,0.4508d+00,0.5000d+00,
     +0.5321d+00,0.5643d+00,0.5964d+00,0.6286d+00,0.6607d+00,0.6929d+00,
     +0.7250d+00,0.7571d+00,0.7893d+00,0.8214d+00,0.8536d+00,0.8857d+00,
     +0.9179d+00,0.9500d+00,0.9700d+00,0.9999d+00/
 
       DATA (XQDUM (I, 1,1),I=1, 76) /

     +0.2703D+03,0.2509D+03,0.2331D+03,0.2165D+03,0.2010D+03,0.1866D+03,
     +0.1733D+03,0.1609D+03,0.1494D+03,0.1387D+03,0.1288D+03,0.1196D+03,
     +0.1110D+03,0.1031D+03,0.9567D+02,0.8879D+02,0.8241D+02,0.7648D+02,
     +0.7097D+02,0.6585D+02,0.6109D+02,0.5667D+02,0.5254D+02,0.4873D+02,
     +0.4519D+02,0.4189D+02,0.3881D+02,0.3596D+02,0.3331D+02,0.3085D+02,
     +0.2855D+02,0.2642D+02,0.2444D+02,0.2259D+02,0.2087D+02,0.1927D+02,
     +0.1778D+02,0.1640D+02,0.1511D+02,0.1391D+02,0.1279D+02,0.1174D+02,
     +0.1077D+02,0.9862D+01,0.9014D+01,0.8227D+01,0.7489D+01,0.6801D+01,
     +0.6155D+01,0.5557D+01,0.4994D+01,0.4468D+01,0.3978D+01,0.3519D+01,
     +0.3090D+01,0.2689D+01,0.2314D+01,0.1966D+01,0.1641D+01,0.1340D+01,
     +0.1170D+01,0.1017D+01,0.8799D+00,0.7559D+00,0.6443D+00,0.5430D+00,
     +0.4517D+00,0.3692D+00,0.2947D+00,0.2282D+00,0.1689D+00,0.1171D+00,
     +0.7241D-01,0.3573D-01,0.1744D-01,0.6696D-05/

       DATA (XQDUM (I, 1,2),I=1, 76) /

     +0.5931D+03,0.5522D+03,0.5143D+03,0.4788D+03,0.4457D+03,0.4149D+03,
     +0.3862D+03,0.3595D+03,0.3345D+03,0.3113D+03,0.2896D+03,0.2695D+03,
     +0.2507D+03,0.2331D+03,0.2167D+03,0.2015D+03,0.1872D+03,0.1740D+03,
     +0.1616D+03,0.1500D+03,0.1393D+03,0.1292D+03,0.1198D+03,0.1111D+03,
     +0.1029D+03,0.9528D+02,0.8814D+02,0.8149D+02,0.7527D+02,0.6947D+02,
     +0.6403D+02,0.5896D+02,0.5423D+02,0.4979D+02,0.4564D+02,0.4177D+02,
     +0.3814D+02,0.3476D+02,0.3159D+02,0.2863D+02,0.2586D+02,0.2328D+02,
     +0.2088D+02,0.1864D+02,0.1655D+02,0.1463D+02,0.1284D+02,0.1119D+02,
     +0.9664D+01,0.8282D+01,0.7018D+01,0.5878D+01,0.4860D+01,0.3958D+01,
     +0.3168D+01,0.2488D+01,0.1912D+01,0.1438D+01,0.1055D+01,0.7549D+00,
     +0.6108D+00,0.4968D+00,0.4069D+00,0.3351D+00,0.2778D+00,0.2312D+00,
     +0.1930D+00,0.1609D+00,0.1333D+00,0.1090D+00,0.8704D-01,0.6676D-01,
     +0.4752D-01,0.2903D-01,0.1766D-01,0.7925D-04/

       DATA (XQDUM (I, 1,3),I=1, 76) /

     +0.2591D+03,0.2413D+03,0.2249D+03,0.2094D+03,0.1950D+03,0.1816D+03,
     +0.1691D+03,0.1575D+03,0.1467D+03,0.1366D+03,0.1272D+03,0.1184D+03,
     +0.1103D+03,0.1026D+03,0.9554D+02,0.8892D+02,0.8276D+02,0.7702D+02,
     +0.7166D+02,0.6666D+02,0.6201D+02,0.5767D+02,0.5361D+02,0.4985D+02,
     +0.4634D+02,0.4305D+02,0.3998D+02,0.3713D+02,0.3446D+02,0.3198D+02,
     +0.2965D+02,0.2748D+02,0.2546D+02,0.2357D+02,0.2181D+02,0.2016D+02,
     +0.1862D+02,0.1718D+02,0.1583D+02,0.1457D+02,0.1339D+02,0.1228D+02,
     +0.1125D+02,0.1028D+02,0.9368D+01,0.8519D+01,0.7720D+01,0.6971D+01,
     +0.6266D+01,0.5609D+01,0.4989D+01,0.4409D+01,0.3867D+01,0.3359D+01,
     +0.2886D+01,0.2445D+01,0.2036D+01,0.1662D+01,0.1319D+01,0.1011D+01,
     +0.8431D+00,0.6967D+00,0.5701D+00,0.4604D+00,0.3664D+00,0.2859D+00,
     +0.2180D+00,0.1614D+00,0.1148D+00,0.7757D-01,0.4864D-01,0.2734D-01,
     +0.1274D-01,0.4093D-02,0.1279D-02,0.3245D-08/

       DATA (XQDUM (I, 1,4),I=1, 76) /

     +0.5931D+03,0.5522D+03,0.5143D+03,0.4788D+03,0.4457D+03,0.4149D+03,
     +0.3862D+03,0.3595D+03,0.3345D+03,0.3113D+03,0.2896D+03,0.2695D+03,
     +0.2507D+03,0.2331D+03,0.2167D+03,0.2015D+03,0.1872D+03,0.1740D+03,
     +0.1616D+03,0.1500D+03,0.1393D+03,0.1292D+03,0.1198D+03,0.1111D+03,
     +0.1029D+03,0.9528D+02,0.8814D+02,0.8149D+02,0.7527D+02,0.6947D+02,
     +0.6403D+02,0.5896D+02,0.5423D+02,0.4979D+02,0.4564D+02,0.4177D+02,
     +0.3814D+02,0.3476D+02,0.3159D+02,0.2863D+02,0.2586D+02,0.2328D+02,
     +0.2088D+02,0.1864D+02,0.1655D+02,0.1463D+02,0.1284D+02,0.1119D+02,
     +0.9664D+01,0.8282D+01,0.7018D+01,0.5878D+01,0.4860D+01,0.3958D+01,
     +0.3168D+01,0.2488D+01,0.1912D+01,0.1438D+01,0.1055D+01,0.7549D+00,
     +0.6108D+00,0.4968D+00,0.4069D+00,0.3351D+00,0.2778D+00,0.2312D+00,
     +0.1930D+00,0.1609D+00,0.1333D+00,0.1090D+00,0.8704D-01,0.6676D-01,
     +0.4752D-01,0.2903D-01,0.1766D-01,0.7925D-04/

       DATA (XQDUM (I, 1,5),I=1, 76) /

     +0.1101D+04,0.1014D+04,0.9343D+03,0.8603D+03,0.7922D+03,0.7295D+03,
     +0.6717D+03,0.6185D+03,0.5694D+03,0.5242D+03,0.4824D+03,0.4440D+03,
     +0.4086D+03,0.3759D+03,0.3458D+03,0.3180D+03,0.2924D+03,0.2688D+03,
     +0.2471D+03,0.2270D+03,0.2085D+03,0.1914D+03,0.1756D+03,0.1611D+03,
     +0.1477D+03,0.1353D+03,0.1239D+03,0.1134D+03,0.1037D+03,0.9472D+02,
     +0.8642D+02,0.7879D+02,0.7176D+02,0.6524D+02,0.5924D+02,0.5369D+02,
     +0.4858D+02,0.4386D+02,0.3951D+02,0.3548D+02,0.3178D+02,0.2837D+02,
     +0.2522D+02,0.2233D+02,0.1967D+02,0.1725D+02,0.1502D+02,0.1299D+02,
     +0.1113D+02,0.9462D+01,0.7948D+01,0.6593D+01,0.5390D+01,0.4330D+01,
     +0.3406D+01,0.2612D+01,0.1942D+01,0.1391D+01,0.9491D+00,0.6080D+00,
     +0.4477D+00,0.3242D+00,0.2308D+00,0.1604D+00,0.1087D+00,0.7113D-01,
     +0.4475D-01,0.2674D-01,0.1492D-01,0.7619D-02,0.3422D-02,0.1274D-02,
     +0.3438D-03,0.4903D-04,0.6665D-05,0.1653D-14/

       DATA (XQDUM (I, 1,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 2,1),I=1, 76) /

     +-.3818D+04,-.3021D+04,-.2373D+04,-.1836D+04,-.1400D+04,-.1047D+04,
     +-.7618D+03,-.5337D+03,-.3522D+03,-.2094D+03,-.9806D+02,-.1281D+02,
     +0.5139D+02,0.9868D+02,0.1323D+03,0.1550D+03,0.1691D+03,0.1764D+03,
     +0.1785D+03,0.1767D+03,0.1719D+03,0.1651D+03,0.1567D+03,0.1475D+03,
     +0.1377D+03,0.1277D+03,0.1177D+03,0.1079D+03,0.9850D+02,0.8954D+02,
     +0.8104D+02,0.7311D+02,0.6574D+02,0.5891D+02,0.5263D+02,0.4690D+02,
     +0.4167D+02,0.3693D+02,0.3264D+02,0.2878D+02,0.2530D+02,0.2219D+02,
     +0.1941D+02,0.1693D+02,0.1473D+02,0.1278D+02,0.1104D+02,0.9512D+01,
     +0.8155D+01,0.6968D+01,0.5919D+01,0.4999D+01,0.4195D+01,0.3491D+01,
     +0.2878D+01,0.2344D+01,0.1882D+01,0.1484D+01,0.1144D+01,0.8548D+00,
     +0.7041D+00,0.5768D+00,0.4694D+00,0.3783D+00,0.3015D+00,0.2365D+00,
     +0.1822D+00,0.1369D+00,0.9941D-01,0.6915D-01,0.4511D-01,0.2679D-01,
     +0.1353D-01,0.4949D-02,0.1782D-02,0.2417D-07/

       DATA (XQDUM (I, 2,2),I=1, 76) /

     +-.1729D+04,-.1328D+04,-.1002D+04,-.7340D+03,-.5175D+03,-.3433D+03,
     +-.2044D+03,-.9458D+02,-.8675D+01,0.5735D+02,0.1073D+03,0.1439D+03,
     +0.1698D+03,0.1872D+03,0.1976D+03,0.2026D+03,0.2033D+03,0.2007D+03,
     +0.1956D+03,0.1887D+03,0.1805D+03,0.1714D+03,0.1617D+03,0.1518D+03,
     +0.1419D+03,0.1320D+03,0.1223D+03,0.1129D+03,0.1040D+03,0.9544D+02,
     +0.8733D+02,0.7970D+02,0.7256D+02,0.6586D+02,0.5962D+02,0.5382D+02,
     +0.4845D+02,0.4349D+02,0.3891D+02,0.3469D+02,0.3082D+02,0.2727D+02,
     +0.2403D+02,0.2106D+02,0.1836D+02,0.1593D+02,0.1372D+02,0.1172D+02,
     +0.9931D+01,0.8344D+01,0.6930D+01,0.5687D+01,0.4606D+01,0.3674D+01,
     +0.2880D+01,0.2214D+01,0.1666D+01,0.1226D+01,0.8793D+00,0.6145D+00,
     +0.4894D+00,0.3915D+00,0.3148D+00,0.2541D+00,0.2058D+00,0.1667D+00,
     +0.1349D+00,0.1086D+00,0.8629D-01,0.6727D-01,0.5072D-01,0.3628D-01,
     +0.2358D-01,0.1261D-01,0.6705D-02,0.6829D-05/

       DATA (XQDUM (I, 2,3),I=1, 76) /

     +-.2090D+04,-.1663D+04,-.1314D+04,-.1024D+04,-.7875D+03,-.5944D+03,
     +-.4377D+03,-.3114D+03,-.2101D+03,-.1297D+03,-.6638D+02,-.1728D+02,
     +0.2026D+02,0.4845D+02,0.6902D+02,0.8344D+02,0.9295D+02,0.9858D+02,
     +0.1012D+03,0.1014D+03,0.9987D+02,0.9699D+02,0.9313D+02,0.8864D+02,
     +0.8373D+02,0.7855D+02,0.7328D+02,0.6804D+02,0.6290D+02,0.5793D+02,
     +0.5316D+02,0.4864D+02,0.4438D+02,0.4037D+02,0.3664D+02,0.3318D+02,
     +0.2997D+02,0.2702D+02,0.2431D+02,0.2182D+02,0.1954D+02,0.1746D+02,
     +0.1556D+02,0.1384D+02,0.1226D+02,0.1084D+02,0.9549D+01,0.8376D+01,
     +0.7311D+01,0.6354D+01,0.5484D+01,0.4700D+01,0.3995D+01,0.3362D+01,
     +0.2793D+01,0.2286D+01,0.1836D+01,0.1442D+01,0.1098D+01,0.8039D+00,
     +0.6504D+00,0.5213D+00,0.4134D+00,0.3232D+00,0.2486D+00,0.1871D+00,
     +0.1373D+00,0.9749D-01,0.6620D-01,0.4247D-01,0.2505D-01,0.1308D-01,
     +0.5538D-02,0.1547D-02,0.4198D-03,0.2333D-09/

       DATA (XQDUM (I, 2,4),I=1, 76) /

     +-.1729D+04,-.1328D+04,-.1002D+04,-.7340D+03,-.5175D+03,-.3433D+03,
     +-.2044D+03,-.9458D+02,-.8675D+01,0.5735D+02,0.1073D+03,0.1439D+03,
     +0.1698D+03,0.1872D+03,0.1976D+03,0.2026D+03,0.2033D+03,0.2007D+03,
     +0.1956D+03,0.1887D+03,0.1805D+03,0.1714D+03,0.1617D+03,0.1518D+03,
     +0.1419D+03,0.1320D+03,0.1223D+03,0.1129D+03,0.1040D+03,0.9544D+02,
     +0.8733D+02,0.7970D+02,0.7256D+02,0.6586D+02,0.5962D+02,0.5382D+02,
     +0.4845D+02,0.4349D+02,0.3891D+02,0.3469D+02,0.3082D+02,0.2727D+02,
     +0.2403D+02,0.2106D+02,0.1836D+02,0.1593D+02,0.1372D+02,0.1172D+02,
     +0.9931D+01,0.8344D+01,0.6930D+01,0.5687D+01,0.4606D+01,0.3674D+01,
     +0.2880D+01,0.2214D+01,0.1666D+01,0.1226D+01,0.8793D+00,0.6145D+00,
     +0.4894D+00,0.3915D+00,0.3148D+00,0.2541D+00,0.2058D+00,0.1667D+00,
     +0.1349D+00,0.1086D+00,0.8629D-01,0.6727D-01,0.5072D-01,0.3628D-01,
     +0.2358D-01,0.1261D-01,0.6705D-02,0.6829D-05/

       DATA (XQDUM (I, 2,5),I=1, 76) /

     +-.1214D+04,-.8605D+03,-.5777D+03,-.3491D+03,-.1683D+03,-.2673D+02,
     +0.8259D+02,0.1654D+03,0.2267D+03,0.2703D+03,0.2999D+03,0.3180D+03,
     +0.3270D+03,0.3290D+03,0.3255D+03,0.3179D+03,0.3071D+03,0.2941D+03,
     +0.2796D+03,0.2640D+03,0.2481D+03,0.2319D+03,0.2158D+03,0.2002D+03,
     +0.1851D+03,0.1705D+03,0.1565D+03,0.1434D+03,0.1310D+03,0.1193D+03,
     +0.1084D+03,0.9831D+02,0.8892D+02,0.8021D+02,0.7217D+02,0.6477D+02,
     +0.5797D+02,0.5174D+02,0.4603D+02,0.4081D+02,0.3605D+02,0.3173D+02,
     +0.2780D+02,0.2423D+02,0.2101D+02,0.1812D+02,0.1551D+02,0.1318D+02,
     +0.1109D+02,0.9248D+01,0.7616D+01,0.6190D+01,0.4954D+01,0.3892D+01,
     +0.2990D+01,0.2238D+01,0.1621D+01,0.1129D+01,0.7485D+00,0.4646D+00,
     +0.3353D+00,0.2382D+00,0.1663D+00,0.1135D+00,0.7549D-01,0.4857D-01,
     +0.3007D-01,0.1771D-01,0.9763D-02,0.4949D-02,0.2221D-02,0.8358D-03,
     +0.2325D-03,0.3507D-04,0.4734D-05,-.6172D-11/

       DATA (XQDUM (I, 2,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 3,1),I=1, 76) /

     +-.3921D+04,-.3019D+04,-.2293D+04,-.1701D+04,-.1227D+04,-.8497D+03,
     +-.5514D+03,-.3182D+03,-.1377D+03,-.5000D+00,0.1021D+03,0.1764D+03,
     +0.2284D+03,0.2627D+03,0.2830D+03,0.2925D+03,0.2938D+03,0.2889D+03,
     +0.2794D+03,0.2668D+03,0.2520D+03,0.2359D+03,0.2191D+03,0.2023D+03,
     +0.1856D+03,0.1694D+03,0.1539D+03,0.1392D+03,0.1254D+03,0.1126D+03,
     +0.1007D+03,0.8986D+02,0.7992D+02,0.7084D+02,0.6263D+02,0.5522D+02,
     +0.4856D+02,0.4259D+02,0.3726D+02,0.3250D+02,0.2828D+02,0.2454D+02,
     +0.2124D+02,0.1832D+02,0.1575D+02,0.1351D+02,0.1154D+02,0.9821D+01,
     +0.8315D+01,0.7014D+01,0.5878D+01,0.4895D+01,0.4048D+01,0.3318D+01,
     +0.2690D+01,0.2154D+01,0.1697D+01,0.1312D+01,0.9887D+00,0.7208D+00,
     +0.5840D+00,0.4703D+00,0.3761D+00,0.2976D+00,0.2326D+00,0.1787D+00,
     +0.1346D+00,0.9869D-01,0.6975D-01,0.4703D-01,0.2957D-01,0.1679D-01,
     +0.7992D-02,0.2681D-02,0.8838D-03,0.4526D-08/

       DATA (XQDUM (I, 3,2),I=1, 76) /

     +-.2064D+04,-.1565D+04,-.1164D+04,-.8357D+03,-.5730D+03,-.3639D+03,
     +-.1988D+03,-.7002D+02,0.2927D+02,0.1042D+03,0.1597D+03,0.1991D+03,
     +0.2258D+03,0.2424D+03,0.2511D+03,0.2535D+03,0.2511D+03,0.2452D+03,
     +0.2366D+03,0.2262D+03,0.2145D+03,0.2020D+03,0.1891D+03,0.1763D+03,
     +0.1635D+03,0.1510D+03,0.1390D+03,0.1275D+03,0.1166D+03,0.1064D+03,
     +0.9671D+02,0.8771D+02,0.7936D+02,0.7158D+02,0.6440D+02,0.5780D+02,
     +0.5171D+02,0.4614D+02,0.4104D+02,0.3638D+02,0.3213D+02,0.2826D+02,
     +0.2475D+02,0.2158D+02,0.1870D+02,0.1613D+02,0.1381D+02,0.1173D+02,
     +0.9878D+01,0.8251D+01,0.6811D+01,0.5556D+01,0.4472D+01,0.3545D+01,
     +0.2761D+01,0.2109D+01,0.1577D+01,0.1152D+01,0.8211D+00,0.5697D+00,
     +0.4516D+00,0.3594D+00,0.2875D+00,0.2307D+00,0.1857D+00,0.1493D+00,
     +0.1199D+00,0.9551D-01,0.7506D-01,0.5775D-01,0.4286D-01,0.3006D-01,
     +0.1904D-01,0.9797D-02,0.5009D-02,0.3307D-05/

       DATA (XQDUM (I, 3,3),I=1, 76) /

     +-.2433D+04,-.1908D+04,-.1483D+04,-.1132D+04,-.8489D+03,-.6202D+03,
     +-.4369D+03,-.2912D+03,-.1761D+03,-.8640D+02,-.1722D+02,0.3503D+02,
     +0.7367D+02,0.1014D+03,0.1205D+03,0.1326D+03,0.1393D+03,0.1418D+03,
     +0.1410D+03,0.1379D+03,0.1331D+03,0.1270D+03,0.1200D+03,0.1127D+03,
     +0.1051D+03,0.9746D+02,0.8992D+02,0.8263D+02,0.7563D+02,0.6900D+02,
     +0.6273D+02,0.5688D+02,0.5145D+02,0.4640D+02,0.4176D+02,0.3750D+02,
     +0.3361D+02,0.3005D+02,0.2682D+02,0.2388D+02,0.2122D+02,0.1881D+02,
     +0.1664D+02,0.1468D+02,0.1291D+02,0.1133D+02,0.9903D+01,0.8620D+01,
     +0.7466D+01,0.6438D+01,0.5514D+01,0.4688D+01,0.3952D+01,0.3297D+01,
     +0.2716D+01,0.2202D+01,0.1752D+01,0.1361D+01,0.1025D+01,0.7411D+00,
     +0.5946D+00,0.4725D+00,0.3715D+00,0.2878D+00,0.2193D+00,0.1634D+00,
     +0.1186D+00,0.8321D-01,0.5577D-01,0.3525D-01,0.2044D-01,0.1045D-01,
     +0.4304D-02,0.1155D-02,0.3011D-03,0.1081D-09/

       DATA (XQDUM (I, 3,4),I=1, 76) /

     +-.2064D+04,-.1565D+04,-.1164D+04,-.8357D+03,-.5730D+03,-.3639D+03,
     +-.1988D+03,-.7002D+02,0.2927D+02,0.1042D+03,0.1597D+03,0.1991D+03,
     +0.2258D+03,0.2424D+03,0.2511D+03,0.2535D+03,0.2511D+03,0.2452D+03,
     +0.2366D+03,0.2262D+03,0.2145D+03,0.2020D+03,0.1891D+03,0.1763D+03,
     +0.1635D+03,0.1510D+03,0.1390D+03,0.1275D+03,0.1166D+03,0.1064D+03,
     +0.9671D+02,0.8771D+02,0.7936D+02,0.7158D+02,0.6440D+02,0.5780D+02,
     +0.5171D+02,0.4614D+02,0.4104D+02,0.3638D+02,0.3213D+02,0.2826D+02,
     +0.2475D+02,0.2158D+02,0.1870D+02,0.1613D+02,0.1381D+02,0.1173D+02,
     +0.9878D+01,0.8251D+01,0.6811D+01,0.5556D+01,0.4472D+01,0.3545D+01,
     +0.2761D+01,0.2109D+01,0.1577D+01,0.1152D+01,0.8211D+00,0.5697D+00,
     +0.4516D+00,0.3594D+00,0.2875D+00,0.2307D+00,0.1857D+00,0.1493D+00,
     +0.1199D+00,0.9551D-01,0.7506D-01,0.5775D-01,0.4286D-01,0.3006D-01,
     +0.1904D-01,0.9797D-02,0.5009D-02,0.3307D-05/

       DATA (XQDUM (I, 3,5),I=1, 76) /

     +-.1548D+04,-.1097D+04,-.7384D+03,-.4500D+03,-.2234D+03,-.4697D+02,
     +0.8831D+02,0.1900D+03,0.2645D+03,0.3170D+03,0.3519D+03,0.3728D+03,
     +0.3826D+03,0.3838D+03,0.3785D+03,0.3682D+03,0.3544D+03,0.3380D+03,
     +0.3200D+03,0.3009D+03,0.2815D+03,0.2620D+03,0.2427D+03,0.2241D+03,
     +0.2062D+03,0.1890D+03,0.1728D+03,0.1575D+03,0.1432D+03,0.1298D+03,
     +0.1174D+03,0.1059D+03,0.9535D+02,0.8559D+02,0.7663D+02,0.6844D+02,
     +0.6095D+02,0.5413D+02,0.4792D+02,0.4227D+02,0.3716D+02,0.3253D+02,
     +0.2836D+02,0.2459D+02,0.2121D+02,0.1819D+02,0.1549D+02,0.1309D+02,
     +0.1095D+02,0.9079D+01,0.7432D+01,0.6003D+01,0.4773D+01,0.3724D+01,
     +0.2841D+01,0.2110D+01,0.1516D+01,0.1047D+01,0.6874D+00,0.4223D+00,
     +0.3027D+00,0.2135D+00,0.1480D+00,0.1003D+00,0.6623D-01,0.4228D-01,
     +0.2596D-01,0.1516D-01,0.8279D-02,0.4154D-02,0.1842D-02,0.6831D-03,
     +0.1863D-03,0.2720D-04,0.3522D-05,-.3077D-11/

       DATA (XQDUM (I, 3,6),I=1, 76) /

     +0.9256D+05,0.7755D+05,0.6509D+05,0.5453D+05,0.4571D+05,0.3831D+05,
     +0.3211D+05,0.2692D+05,0.2256D+05,0.1890D+05,0.1583D+05,0.1327D+05,
     +0.1112D+05,0.9309D+04,0.7795D+04,0.6525D+04,0.5462D+04,0.4572D+04,
     +0.3825D+04,0.3199D+04,0.2675D+04,0.2236D+04,0.1867D+04,0.1560D+04,
     +0.1303D+04,0.1086D+04,0.9053D+03,0.7545D+03,0.6280D+03,0.5226D+03,
     +0.4341D+03,0.3604D+03,0.2989D+03,0.2475D+03,0.2046D+03,0.1689D+03,
     +0.1392D+03,0.1145D+03,0.9392D+02,0.7684D+02,0.6270D+02,0.5099D+02,
     +0.4132D+02,0.3334D+02,0.2676D+02,0.2140D+02,0.1699D+02,0.1340D+02,
     +0.1047D+02,0.8127D+01,0.6232D+01,0.4721D+01,0.3527D+01,0.2591D+01,
     +0.1865D+01,0.1310D+01,0.8926D+00,0.5871D+00,0.3685D+00,0.2176D+00,
     +0.1528D+00,0.1059D+00,0.7247D-01,0.4859D-01,0.3186D-01,0.2025D-01,
     +0.1242D-01,0.7260D-02,0.3979D-02,0.2007D-02,0.8956D-03,0.3341D-03,
     +0.9153D-04,0.1357D-04,0.1942D-05,-.1756D-13/

       DATA (XQDUM (I, 4,1),I=1, 76) /

     +-.2036D+04,-.1242D+04,-.6326D+03,-.1628D+03,0.1884D+03,0.4449D+03,
     +0.6261D+03,0.7475D+03,0.8223D+03,0.8607D+03,0.8714D+03,0.8613D+03,
     +0.8359D+03,0.7997D+03,0.7561D+03,0.7080D+03,0.6575D+03,0.6064D+03,
     +0.5558D+03,0.5065D+03,0.4594D+03,0.4147D+03,0.3727D+03,0.3340D+03,
     +0.2982D+03,0.2652D+03,0.2351D+03,0.2079D+03,0.1833D+03,0.1612D+03,
     +0.1413D+03,0.1236D+03,0.1078D+03,0.9376D+02,0.8136D+02,0.7042D+02,
     +0.6079D+02,0.5235D+02,0.4496D+02,0.3850D+02,0.3288D+02,0.2800D+02,
     +0.2377D+02,0.2010D+02,0.1694D+02,0.1424D+02,0.1190D+02,0.9908D+01,
     +0.8199D+01,0.6755D+01,0.5523D+01,0.4482D+01,0.3606D+01,0.2872D+01,
     +0.2259D+01,0.1750D+01,0.1331D+01,0.9900D+00,0.7152D+00,0.4971D+00,
     +0.3902D+00,0.3041D+00,0.2351D+00,0.1795D+00,0.1352D+00,0.9978D-01,
     +0.7198D-01,0.5034D-01,0.3375D-01,0.2143D-01,0.1255D-01,0.6539D-02,
     +0.2780D-02,0.7897D-03,0.2199D-03,0.1793D-09/

       DATA (XQDUM (I, 4,2),I=1, 76) /

     +-.2282D+04,-.1643D+04,-.1139D+04,-.7353D+03,-.4200D+03,-.1759D+03,
     +0.1034D+02,0.1497D+03,0.2516D+03,0.3232D+03,0.3711D+03,0.4000D+03,
     +0.4144D+03,0.4175D+03,0.4121D+03,0.4004D+03,0.3843D+03,0.3651D+03,
     +0.3440D+03,0.3217D+03,0.2991D+03,0.2766D+03,0.2546D+03,0.2334D+03,
     +0.2133D+03,0.1941D+03,0.1761D+03,0.1593D+03,0.1437D+03,0.1294D+03,
     +0.1161D+03,0.1040D+03,0.9295D+02,0.8282D+02,0.7363D+02,0.6530D+02,
     +0.5775D+02,0.5094D+02,0.4479D+02,0.3925D+02,0.3428D+02,0.2982D+02,
     +0.2583D+02,0.2226D+02,0.1908D+02,0.1627D+02,0.1378D+02,0.1158D+02,
     +0.9640D+01,0.7961D+01,0.6497D+01,0.5238D+01,0.4167D+01,0.3264D+01,
     +0.2512D+01,0.1896D+01,0.1399D+01,0.1010D+01,0.7100D+00,0.4857D+00,
     +0.3815D+00,0.3008D+00,0.2383D+00,0.1891D+00,0.1503D+00,0.1193D+00,
     +0.9423D-01,0.7374D-01,0.5674D-01,0.4258D-01,0.3067D-01,0.2072D-01,
     +0.1249D-01,0.5971D-02,0.2832D-02,0.8144D-06/

       DATA (XQDUM (I, 4,3),I=1, 76) /

     +-.2667D+04,-.2001D+04,-.1471D+04,-.1044D+04,-.7069D+03,-.4423D+03,
     +-.2369D+03,-.7974D+02,0.3879D+02,0.1259D+03,0.1883D+03,0.2307D+03,
     +0.2575D+03,0.2723D+03,0.2779D+03,0.2764D+03,0.2697D+03,0.2593D+03,
     +0.2464D+03,0.2319D+03,0.2164D+03,0.2006D+03,0.1847D+03,0.1693D+03,
     +0.1545D+03,0.1404D+03,0.1270D+03,0.1146D+03,0.1030D+03,0.9243D+02,
     +0.8265D+02,0.7376D+02,0.6569D+02,0.5834D+02,0.5172D+02,0.4577D+02,
     +0.4042D+02,0.3563D+02,0.3135D+02,0.2752D+02,0.2412D+02,0.2109D+02,
     +0.1840D+02,0.1601D+02,0.1389D+02,0.1202D+02,0.1036D+02,0.8898D+01,
     +0.7600D+01,0.6463D+01,0.5456D+01,0.4572D+01,0.3797D+01,0.3120D+01,
     +0.2529D+01,0.2016D+01,0.1575D+01,0.1201D+01,0.8854D+00,0.6252D+00,
     +0.4939D+00,0.3863D+00,0.2987D+00,0.2275D+00,0.1702D+00,0.1244D+00,
     +0.8850D-01,0.6072D-01,0.3970D-01,0.2439D-01,0.1369D-01,0.6724D-02,
     +0.2630D-02,0.6540D-03,0.1579D-03,0.2462D-10/

       DATA (XQDUM (I, 4,4),I=1, 76) /

     +-.2282D+04,-.1643D+04,-.1139D+04,-.7353D+03,-.4200D+03,-.1759D+03,
     +0.1034D+02,0.1497D+03,0.2516D+03,0.3232D+03,0.3711D+03,0.4000D+03,
     +0.4144D+03,0.4175D+03,0.4121D+03,0.4004D+03,0.3843D+03,0.3651D+03,
     +0.3440D+03,0.3217D+03,0.2991D+03,0.2766D+03,0.2546D+03,0.2334D+03,
     +0.2133D+03,0.1941D+03,0.1761D+03,0.1593D+03,0.1437D+03,0.1294D+03,
     +0.1161D+03,0.1040D+03,0.9295D+02,0.8282D+02,0.7363D+02,0.6530D+02,
     +0.5775D+02,0.5094D+02,0.4479D+02,0.3925D+02,0.3428D+02,0.2982D+02,
     +0.2583D+02,0.2226D+02,0.1908D+02,0.1627D+02,0.1378D+02,0.1158D+02,
     +0.9640D+01,0.7961D+01,0.6497D+01,0.5238D+01,0.4167D+01,0.3264D+01,
     +0.2512D+01,0.1896D+01,0.1399D+01,0.1010D+01,0.7100D+00,0.4857D+00,
     +0.3815D+00,0.3008D+00,0.2383D+00,0.1891D+00,0.1503D+00,0.1193D+00,
     +0.9423D-01,0.7374D-01,0.5674D-01,0.4258D-01,0.3067D-01,0.2072D-01,
     +0.1249D-01,0.5971D-02,0.2832D-02,0.8144D-06/

       DATA (XQDUM (I, 4,5),I=1, 76) /

     +-.1763D+04,-.1173D+04,-.7121D+03,-.3487D+03,-.6975D+02,0.1412D+03,
     +0.2974D+03,0.4093D+03,0.4863D+03,0.5353D+03,0.5625D+03,0.5728D+03,
     +0.5701D+03,0.5578D+03,0.5383D+03,0.5140D+03,0.4863D+03,0.4567D+03,
     +0.4261D+03,0.3952D+03,0.3649D+03,0.3354D+03,0.3070D+03,0.2802D+03,
     +0.2549D+03,0.2310D+03,0.2088D+03,0.1883D+03,0.1694D+03,0.1520D+03,
     +0.1360D+03,0.1214D+03,0.1082D+03,0.9614D+02,0.8522D+02,0.7535D+02,
     +0.6644D+02,0.5842D+02,0.5120D+02,0.4472D+02,0.3892D+02,0.3374D+02,
     +0.2911D+02,0.2499D+02,0.2133D+02,0.1811D+02,0.1526D+02,0.1275D+02,
     +0.1055D+02,0.8653D+01,0.7002D+01,0.5587D+01,0.4387D+01,0.3378D+01,
     +0.2541D+01,0.1860D+01,0.1315D+01,0.8931D+00,0.5753D+00,0.3462D+00,
     +0.2448D+00,0.1702D+00,0.1163D+00,0.7764D-01,0.5049D-01,0.3170D-01,
     +0.1913D-01,0.1096D-01,0.5863D-02,0.2873D-02,0.1239D-02,0.4443D-03,
     +0.1157D-03,0.1572D-04,0.1870D-05,-.7434D-12/

       DATA (XQDUM (I, 4,6),I=1, 76) /

     +0.8559D+05,0.7182D+05,0.6036D+05,0.5065D+05,0.4251D+05,0.3569D+05,
     +0.2996D+05,0.2516D+05,0.2112D+05,0.1773D+05,0.1488D+05,0.1249D+05,
     +0.1048D+05,0.8794D+04,0.7377D+04,0.6187D+04,0.5188D+04,0.4351D+04,
     +0.3646D+04,0.3055D+04,0.2559D+04,0.2142D+04,0.1791D+04,0.1499D+04,
     +0.1254D+04,0.1047D+04,0.8735D+03,0.7287D+03,0.6071D+03,0.5056D+03,
     +0.4203D+03,0.3491D+03,0.2897D+03,0.2398D+03,0.1983D+03,0.1636D+03,
     +0.1348D+03,0.1107D+03,0.9077D+02,0.7416D+02,0.6041D+02,0.4903D+02,
     +0.3964D+02,0.3190D+02,0.2553D+02,0.2035D+02,0.1609D+02,0.1264D+02,
     +0.9830D+01,0.7588D+01,0.5784D+01,0.4353D+01,0.3229D+01,0.2353D+01,
     +0.1679D+01,0.1168D+01,0.7870D+00,0.5114D+00,0.3165D+00,0.1839D+00,
     +0.1278D+00,0.8758D-01,0.5920D-01,0.3920D-01,0.2537D-01,0.1590D-01,
     +0.9603D-02,0.5521D-02,0.2970D-02,0.1467D-02,0.6382D-03,0.2308D-03,
     +0.6064D-04,0.8410D-05,0.1112D-05,-.3526D-13/

       DATA (XQDUM (I, 5,1),I=1, 76) /

     +-.7635D+03,-.9657D+02,0.3953D+03,0.7553D+03,0.1006D+04,0.1170D+04,
     +0.1267D+04,0.1313D+04,0.1319D+04,0.1296D+04,0.1252D+04,0.1193D+04,
     +0.1125D+04,0.1050D+04,0.9725D+03,0.8946D+03,0.8180D+03,0.7441D+03,
     +0.6736D+03,0.6070D+03,0.5449D+03,0.4873D+03,0.4340D+03,0.3857D+03,
     +0.3417D+03,0.3016D+03,0.2655D+03,0.2331D+03,0.2041D+03,0.1783D+03,
     +0.1553D+03,0.1350D+03,0.1171D+03,0.1012D+03,0.8730D+02,0.7511D+02,
     +0.6446D+02,0.5518D+02,0.4711D+02,0.4009D+02,0.3403D+02,0.2879D+02,
     +0.2428D+02,0.2041D+02,0.1708D+02,0.1425D+02,0.1183D+02,0.9776D+01,
     +0.8027D+01,0.6559D+01,0.5317D+01,0.4276D+01,0.3408D+01,0.2686D+01,
     +0.2090D+01,0.1600D+01,0.1201D+01,0.8815D+00,0.6271D+00,0.4284D+00,
     +0.3323D+00,0.2559D+00,0.1954D+00,0.1472D+00,0.1094D+00,0.7956D-01,
     +0.5648D-01,0.3882D-01,0.2552D-01,0.1585D-01,0.9050D-02,0.4567D-02,
     +0.1863D-02,0.4980D-03,0.1304D-03,0.5547D-10/

       DATA (XQDUM (I, 5,2),I=1, 76) /

     +-.2042D+04,-.1398D+04,-.8949D+03,-.4985D+03,-.1938D+03,0.3728D+02,
     +0.2090D+03,0.3332D+03,0.4197D+03,0.4762D+03,0.5093D+03,0.5243D+03,
     +0.5255D+03,0.5164D+03,0.4997D+03,0.4778D+03,0.4522D+03,0.4246D+03,
     +0.3959D+03,0.3668D+03,0.3382D+03,0.3103D+03,0.2835D+03,0.2583D+03,
     +0.2344D+03,0.2121D+03,0.1913D+03,0.1721D+03,0.1545D+03,0.1383D+03,
     +0.1236D+03,0.1101D+03,0.9796D+02,0.8689D+02,0.7690D+02,0.6789D+02,
     +0.5979D+02,0.5251D+02,0.4598D+02,0.4013D+02,0.3490D+02,0.3024D+02,
     +0.2608D+02,0.2239D+02,0.1912D+02,0.1624D+02,0.1369D+02,0.1146D+02,
     +0.9504D+01,0.7816D+01,0.6352D+01,0.5100D+01,0.4040D+01,0.3151D+01,
     +0.2414D+01,0.1814D+01,0.1333D+01,0.9572D+00,0.6699D+00,0.4560D+00,
     +0.3570D+00,0.2805D+00,0.2213D+00,0.1750D+00,0.1385D+00,0.1093D+00,
     +0.8588D-01,0.6677D-01,0.5098D-01,0.3791D-01,0.2701D-01,0.1800D-01,
     +0.1065D-01,0.4956D-02,0.2286D-02,0.4831D-06/

       DATA (XQDUM (I, 5,3),I=1, 76) /

     +-.2433D+04,-.1761D+04,-.1233D+04,-.8120D+03,-.4848D+03,-.2328D+03,
     +-.4152D+02,0.1008D+03,0.2042D+03,0.2765D+03,0.3244D+03,0.3531D+03,
     +0.3670D+03,0.3698D+03,0.3643D+03,0.3526D+03,0.3368D+03,0.3181D+03,
     +0.2977D+03,0.2765D+03,0.2551D+03,0.2340D+03,0.2135D+03,0.1940D+03,
     +0.1756D+03,0.1584D+03,0.1423D+03,0.1275D+03,0.1139D+03,0.1016D+03,
     +0.9031D+02,0.8013D+02,0.7097D+02,0.6270D+02,0.5529D+02,0.4867D+02,
     +0.4277D+02,0.3751D+02,0.3284D+02,0.2869D+02,0.2502D+02,0.2177D+02,
     +0.1891D+02,0.1637D+02,0.1414D+02,0.1218D+02,0.1045D+02,0.8931D+01,
     +0.7592D+01,0.6425D+01,0.5398D+01,0.4500D+01,0.3719D+01,0.3038D+01,
     +0.2449D+01,0.1941D+01,0.1507D+01,0.1141D+01,0.8349D+00,0.5847D+00,
     +0.4593D+00,0.3571D+00,0.2746D+00,0.2078D+00,0.1545D+00,0.1121D+00,
     +0.7916D-01,0.5387D-01,0.3490D-01,0.2123D-01,0.1177D-01,0.5697D-02,
     +0.2186D-02,0.5286D-03,0.1241D-03,0.1420D-10/

       DATA (XQDUM (I, 5,4),I=1, 76) /

     +-.2042D+04,-.1398D+04,-.8949D+03,-.4985D+03,-.1938D+03,0.3728D+02,
     +0.2090D+03,0.3332D+03,0.4197D+03,0.4762D+03,0.5093D+03,0.5243D+03,
     +0.5255D+03,0.5164D+03,0.4997D+03,0.4778D+03,0.4522D+03,0.4246D+03,
     +0.3959D+03,0.3668D+03,0.3382D+03,0.3103D+03,0.2835D+03,0.2583D+03,
     +0.2344D+03,0.2121D+03,0.1913D+03,0.1721D+03,0.1545D+03,0.1383D+03,
     +0.1236D+03,0.1101D+03,0.9796D+02,0.8689D+02,0.7690D+02,0.6789D+02,
     +0.5979D+02,0.5251D+02,0.4598D+02,0.4013D+02,0.3490D+02,0.3024D+02,
     +0.2608D+02,0.2239D+02,0.1912D+02,0.1624D+02,0.1369D+02,0.1146D+02,
     +0.9504D+01,0.7816D+01,0.6352D+01,0.5100D+01,0.4040D+01,0.3151D+01,
     +0.2414D+01,0.1814D+01,0.1333D+01,0.9572D+00,0.6699D+00,0.4560D+00,
     +0.3570D+00,0.2805D+00,0.2213D+00,0.1750D+00,0.1385D+00,0.1093D+00,
     +0.8588D-01,0.6677D-01,0.5098D-01,0.3791D-01,0.2701D-01,0.1800D-01,
     +0.1065D-01,0.4956D-02,0.2286D-02,0.4831D-06/

       DATA (XQDUM (I, 5,5),I=1, 76) /

     +-.1523D+04,-.9273D+03,-.4680D+03,-.1118D+03,0.1565D+03,0.3543D+03,
     +0.4959D+03,0.5926D+03,0.6541D+03,0.6879D+03,0.7004D+03,0.6966D+03,
     +0.6808D+03,0.6562D+03,0.6255D+03,0.5908D+03,0.5537D+03,0.5157D+03,
     +0.4775D+03,0.4398D+03,0.4035D+03,0.3686D+03,0.3355D+03,0.3045D+03,
     +0.2756D+03,0.2486D+03,0.2236D+03,0.2007D+03,0.1797D+03,0.1606D+03,
     +0.1431D+03,0.1273D+03,0.1129D+03,0.9994D+02,0.8824D+02,0.7772D+02,
     +0.6827D+02,0.5980D+02,0.5222D+02,0.4544D+02,0.3940D+02,0.3403D+02,
     +0.2925D+02,0.2502D+02,0.2128D+02,0.1800D+02,0.1510D+02,0.1257D+02,
     +0.1036D+02,0.8461D+01,0.6817D+01,0.5415D+01,0.4233D+01,0.3243D+01,
     +0.2428D+01,0.1767D+01,0.1242D+01,0.8381D+00,0.5361D+00,0.3201D+00,
     +0.2251D+00,0.1557D+00,0.1058D+00,0.7024D-01,0.4540D-01,0.2833D-01,
     +0.1698D-01,0.9657D-02,0.5122D-02,0.2487D-02,0.1061D-02,0.3752D-03,
     +0.9596D-04,0.1267D-04,0.1458D-05,-.4374D-12/

       DATA (XQDUM (I, 5,6),I=1, 76) /

     +0.8344D+05,0.7006D+05,0.5892D+05,0.4947D+05,0.4155D+05,0.3491D+05,
     +0.2933D+05,0.2464D+05,0.2070D+05,0.1739D+05,0.1460D+05,0.1226D+05,
     +0.1030D+05,0.8649D+04,0.7260D+04,0.6092D+04,0.5112D+04,0.4289D+04,
     +0.3597D+04,0.3015D+04,0.2527D+04,0.2116D+04,0.1770D+04,0.1482D+04,
     +0.1240D+04,0.1036D+04,0.8644D+03,0.7213D+03,0.6010D+03,0.5005D+03,
     +0.4161D+03,0.3456D+03,0.2867D+03,0.2373D+03,0.1961D+03,0.1618D+03,
     +0.1332D+03,0.1094D+03,0.8958D+02,0.7313D+02,0.5952D+02,0.4826D+02,
     +0.3897D+02,0.3132D+02,0.2503D+02,0.1992D+02,0.1573D+02,0.1232D+02,
     +0.9568D+01,0.7368D+01,0.5602D+01,0.4205D+01,0.3110D+01,0.2259D+01,
     +0.1606D+01,0.1112D+01,0.7464D+00,0.4826D+00,0.2970D+00,0.1715D+00,
     +0.1185D+00,0.8089D-01,0.5441D-01,0.3584D-01,0.2307D-01,0.1437D-01,
     +0.8625D-02,0.4924D-02,0.2628D-02,0.1286D-02,0.5534D-03,0.1975D-03,
     +0.5096D-04,0.6875D-05,0.8826D-06,-.2646D-13/

       DATA (XQDUM (I, 6,1),I=1, 76) /

     +0.2757D+04,0.3012D+04,0.3135D+04,0.3161D+04,0.3112D+04,0.3011D+04,
     +0.2871D+04,0.2708D+04,0.2529D+04,0.2343D+04,0.2155D+04,0.1971D+04,
     +0.1792D+04,0.1622D+04,0.1461D+04,0.1311D+04,0.1172D+04,0.1045D+04,
     +0.9278D+03,0.8213D+03,0.7251D+03,0.6384D+03,0.5602D+03,0.4909D+03,
     +0.4290D+03,0.3738D+03,0.3248D+03,0.2818D+03,0.2438D+03,0.2105D+03,
     +0.1813D+03,0.1558D+03,0.1336D+03,0.1142D+03,0.9739D+02,0.8287D+02,
     +0.7032D+02,0.5953D+02,0.5025D+02,0.4227D+02,0.3546D+02,0.2965D+02,
     +0.2470D+02,0.2050D+02,0.1694D+02,0.1395D+02,0.1142D+02,0.9296D+01,
     +0.7517D+01,0.6046D+01,0.4819D+01,0.3807D+01,0.2977D+01,0.2300D+01,
     +0.1751D+01,0.1309D+01,0.9582D+00,0.6836D+00,0.4713D+00,0.3108D+00,
     +0.2355D+00,0.1769D+00,0.1317D+00,0.9666D-01,0.6981D-01,0.4928D-01,
     +0.3388D-01,0.2248D-01,0.1421D-01,0.8437D-02,0.4570D-02,0.2163D-02,
     +0.8115D-03,0.1920D-03,0.4446D-04,0.5762D-11/

       DATA (XQDUM (I, 6,2),I=1, 76) /

     +-.9977D+03,-.4290D+03,-.2690D+01,0.3165D+03,0.5460D+03,0.7049D+03,
     +0.8085D+03,0.8689D+03,0.8963D+03,0.8985D+03,0.8821D+03,0.8522D+03,
     +0.8129D+03,0.7674D+03,0.7183D+03,0.6674D+03,0.6164D+03,0.5662D+03,
     +0.5176D+03,0.4712D+03,0.4274D+03,0.3863D+03,0.3479D+03,0.3128D+03,
     +0.2804D+03,0.2506D+03,0.2235D+03,0.1989D+03,0.1767D+03,0.1566D+03,
     +0.1385D+03,0.1223D+03,0.1078D+03,0.9471D+02,0.8308D+02,0.7271D+02,
     +0.6348D+02,0.5529D+02,0.4802D+02,0.4156D+02,0.3585D+02,0.3081D+02,
     +0.2637D+02,0.2246D+02,0.1902D+02,0.1603D+02,0.1341D+02,0.1113D+02,
     +0.9158D+01,0.7471D+01,0.6021D+01,0.4794D+01,0.3766D+01,0.2911D+01,
     +0.2211D+01,0.1646D+01,0.1199D+01,0.8529D+00,0.5911D+00,0.3983D+00,
     +0.3097D+00,0.2417D+00,0.1893D+00,0.1485D+00,0.1165D+00,0.9101D-01,
     +0.7067D-01,0.5421D-01,0.4074D-01,0.2974D-01,0.2072D-01,0.1343D-01,
     +0.7653D-02,0.3368D-02,0.1467D-02,0.1649D-06/

       DATA (XQDUM (I, 6,3),I=1, 76) /

     +-.1401D+04,-.8034D+03,-.3504D+03,-.6098D+01,0.2467D+03,0.4274D+03,
     +0.5512D+03,0.6305D+03,0.6755D+03,0.6941D+03,0.6929D+03,0.6772D+03,
     +0.6512D+03,0.6181D+03,0.5804D+03,0.5403D+03,0.4992D+03,0.4583D+03,
     +0.4183D+03,0.3799D+03,0.3436D+03,0.3095D+03,0.2776D+03,0.2484D+03,
     +0.2216D+03,0.1971D+03,0.1748D+03,0.1547D+03,0.1366D+03,0.1204D+03,
     +0.1058D+03,0.9287D+02,0.8139D+02,0.7116D+02,0.6213D+02,0.5415D+02,
     +0.4712D+02,0.4094D+02,0.3551D+02,0.3073D+02,0.2655D+02,0.2290D+02,
     +0.1970D+02,0.1691D+02,0.1447D+02,0.1235D+02,0.1051D+02,0.8895D+01,
     +0.7492D+01,0.6282D+01,0.5227D+01,0.4316D+01,0.3530D+01,0.2855D+01,
     +0.2276D+01,0.1783D+01,0.1367D+01,0.1020D+01,0.7358D+00,0.5067D+00,
     +0.3936D+00,0.3025D+00,0.2298D+00,0.1717D+00,0.1260D+00,0.9019D-01,
     +0.6271D-01,0.4198D-01,0.2670D-01,0.1590D-01,0.8601D-02,0.4042D-02,
     +0.1491D-02,0.3407D-03,0.7549D-04,0.4586D-11/

       DATA (XQDUM (I, 6,4),I=1, 76) /

     +-.9977D+03,-.4290D+03,-.2690D+01,0.3165D+03,0.5460D+03,0.7049D+03,
     +0.8085D+03,0.8689D+03,0.8963D+03,0.8985D+03,0.8821D+03,0.8522D+03,
     +0.8129D+03,0.7674D+03,0.7183D+03,0.6674D+03,0.6164D+03,0.5662D+03,
     +0.5176D+03,0.4712D+03,0.4274D+03,0.3863D+03,0.3479D+03,0.3128D+03,
     +0.2804D+03,0.2506D+03,0.2235D+03,0.1989D+03,0.1767D+03,0.1566D+03,
     +0.1385D+03,0.1223D+03,0.1078D+03,0.9471D+02,0.8308D+02,0.7271D+02,
     +0.6348D+02,0.5529D+02,0.4802D+02,0.4156D+02,0.3585D+02,0.3081D+02,
     +0.2637D+02,0.2246D+02,0.1902D+02,0.1603D+02,0.1341D+02,0.1113D+02,
     +0.9158D+01,0.7471D+01,0.6021D+01,0.4794D+01,0.3766D+01,0.2911D+01,
     +0.2211D+01,0.1646D+01,0.1199D+01,0.8529D+00,0.5911D+00,0.3983D+00,
     +0.3097D+00,0.2417D+00,0.1893D+00,0.1485D+00,0.1165D+00,0.9101D-01,
     +0.7067D-01,0.5421D-01,0.4074D-01,0.2974D-01,0.2072D-01,0.1343D-01,
     +0.7653D-02,0.3368D-02,0.1467D-02,0.1649D-06/

       DATA (XQDUM (I, 6,5),I=1, 76) /

     +-.4776D+03,0.4236D+02,0.4247D+03,0.7034D+03,0.8961D+03,0.1022D+04,
     +0.1095D+04,0.1128D+04,0.1130D+04,0.1109D+04,0.1072D+04,0.1023D+04,
     +0.9671D+03,0.9061D+03,0.8429D+03,0.7793D+03,0.7167D+03,0.6561D+03,
     +0.5981D+03,0.5431D+03,0.4916D+03,0.4435D+03,0.3989D+03,0.3581D+03,
     +0.3206D+03,0.2863D+03,0.2550D+03,0.2268D+03,0.2012D+03,0.1782D+03,
     +0.1574D+03,0.1388D+03,0.1222D+03,0.1072D+03,0.9393D+02,0.8208D+02,
     +0.7155D+02,0.6220D+02,0.5391D+02,0.4655D+02,0.4007D+02,0.3434D+02,
     +0.2931D+02,0.2488D+02,0.2100D+02,0.1762D+02,0.1468D+02,0.1212D+02,
     +0.9909D+01,0.8024D+01,0.6410D+01,0.5046D+01,0.3907D+01,0.2965D+01,
     +0.2196D+01,0.1580D+01,0.1097D+01,0.7310D+00,0.4609D+00,0.2707D+00,
     +0.1884D+00,0.1289D+00,0.8660D-01,0.5678D-01,0.3625D-01,0.2232D-01,
     +0.1319D-01,0.7385D-02,0.3850D-02,0.1833D-02,0.7638D-03,0.2625D-03,
     +0.6461D-04,0.8034D-05,0.8628D-06,-.1469D-12/

       DATA (XQDUM (I, 6,6),I=1, 76) /

     +0.7976D+05,0.6706D+05,0.5648D+05,0.4749D+05,0.3995D+05,0.3361D+05,
     +0.2827D+05,0.2379D+05,0.2001D+05,0.1683D+05,0.1416D+05,0.1191D+05,
     +0.1001D+05,0.8416D+04,0.7073D+04,0.5942D+04,0.4992D+04,0.4192D+04,
     +0.3519D+04,0.2952D+04,0.2475D+04,0.2075D+04,0.1737D+04,0.1455D+04,
     +0.1217D+04,0.1017D+04,0.8488D+03,0.7083D+03,0.5901D+03,0.4913D+03,
     +0.4082D+03,0.3388D+03,0.2809D+03,0.2323D+03,0.1917D+03,0.1580D+03,
     +0.1298D+03,0.1065D+03,0.8703D+02,0.7090D+02,0.5757D+02,0.4656D+02,
     +0.3750D+02,0.3004D+02,0.2393D+02,0.1897D+02,0.1492D+02,0.1165D+02,
     +0.8999D+01,0.6895D+01,0.5214D+01,0.3891D+01,0.2859D+01,0.2062D+01,
     +0.1454D+01,0.9987D+00,0.6637D+00,0.4245D+00,0.2581D+00,0.1469D+00,
     +0.1006D+00,0.6796D-01,0.4524D-01,0.2947D-01,0.1874D-01,0.1153D-01,
     +0.6824D-02,0.3837D-02,0.2012D-02,0.9654D-03,0.4059D-03,0.1407D-03,
     +0.3495D-04,0.4449D-05,0.5369D-06,-.1254D-13/

       DATA (XQDUM (I, 7,1),I=1, 76) /

     +0.4411D+04,0.4454D+04,0.4392D+04,0.4252D+04,0.4057D+04,0.3827D+04,
     +0.3576D+04,0.3314D+04,0.3049D+04,0.2789D+04,0.2536D+04,0.2295D+04,
     +0.2069D+04,0.1857D+04,0.1660D+04,0.1479D+04,0.1314D+04,0.1163D+04,
     +0.1027D+04,0.9043D+03,0.7942D+03,0.6957D+03,0.6076D+03,0.5299D+03,
     +0.4610D+03,0.3999D+03,0.3461D+03,0.2990D+03,0.2576D+03,0.2215D+03,
     +0.1900D+03,0.1626D+03,0.1389D+03,0.1183D+03,0.1005D+03,0.8517D+02,
     +0.7199D+02,0.6069D+02,0.5102D+02,0.4275D+02,0.3571D+02,0.2973D+02,
     +0.2466D+02,0.2037D+02,0.1675D+02,0.1372D+02,0.1118D+02,0.9053D+01,
     +0.7280D+01,0.5821D+01,0.4610D+01,0.3618D+01,0.2810D+01,0.2154D+01,
     +0.1626D+01,0.1206D+01,0.8737D+00,0.6167D+00,0.4202D+00,0.2734D+00,
     +0.2053D+00,0.1528D+00,0.1127D+00,0.8184D-01,0.5848D-01,0.4082D-01,
     +0.2772D-01,0.1814D-01,0.1130D-01,0.6595D-02,0.3502D-02,0.1618D-02,
     +0.5881D-03,0.1329D-03,0.2941D-04,0.2626D-11/

       DATA (XQDUM (I, 7,2),I=1, 76) /

     +-.4025D+03,0.1057D+03,0.4760D+03,0.7427D+03,0.9241D+03,0.1039D+04,
     +0.1103D+04,0.1127D+04,0.1123D+04,0.1096D+04,0.1054D+04,0.1001D+04,
     +0.9420D+03,0.8788D+03,0.8141D+03,0.7496D+03,0.6867D+03,0.6262D+03,
     +0.5687D+03,0.5145D+03,0.4640D+03,0.4172D+03,0.3739D+03,0.3345D+03,
     +0.2985D+03,0.2657D+03,0.2359D+03,0.2092D+03,0.1851D+03,0.1635D+03,
     +0.1440D+03,0.1267D+03,0.1113D+03,0.9748D+02,0.8523D+02,0.7436D+02,
     +0.6471D+02,0.5619D+02,0.4864D+02,0.4198D+02,0.3610D+02,0.3094D+02,
     +0.2640D+02,0.2242D+02,0.1893D+02,0.1591D+02,0.1327D+02,0.1098D+02,
     +0.9005D+01,0.7324D+01,0.5884D+01,0.4670D+01,0.3657D+01,0.2818D+01,
     +0.2133D+01,0.1583D+01,0.1148D+01,0.8143D+00,0.5624D+00,0.3774D+00,
     +0.2928D+00,0.2279D+00,0.1780D+00,0.1391D+00,0.1088D+00,0.8467D-01,
     +0.6546D-01,0.4995D-01,0.3732D-01,0.2705D-01,0.1868D-01,0.1198D-01,
     +0.6729D-02,0.2898D-02,0.1235D-02,0.1090D-06/

       DATA (XQDUM (I, 7,3),I=1, 76) /

     +-.8106D+03,-.2730D+03,0.1244D+03,0.4166D+03,0.6217D+03,0.7589D+03,
     +0.8432D+03,0.8869D+03,0.8998D+03,0.8899D+03,0.8632D+03,0.8250D+03,
     +0.7791D+03,0.7284D+03,0.6754D+03,0.6218D+03,0.5689D+03,0.5178D+03,
     +0.4690D+03,0.4230D+03,0.3800D+03,0.3402D+03,0.3035D+03,0.2702D+03,
     +0.2398D+03,0.2122D+03,0.1873D+03,0.1651D+03,0.1451D+03,0.1274D+03,
     +0.1116D+03,0.9755D+02,0.8517D+02,0.7420D+02,0.6454D+02,0.5606D+02,
     +0.4861D+02,0.4209D+02,0.3638D+02,0.3138D+02,0.2703D+02,0.2323D+02,
     +0.1992D+02,0.1704D+02,0.1454D+02,0.1237D+02,0.1048D+02,0.8849D+01,
     +0.7428D+01,0.6207D+01,0.5147D+01,0.4234D+01,0.3451D+01,0.2779D+01,
     +0.2207D+01,0.1721D+01,0.1313D+01,0.9756D+00,0.6995D+00,0.4786D+00,
     +0.3702D+00,0.2833D+00,0.2143D+00,0.1594D+00,0.1163D+00,0.8283D-01,
     +0.5726D-01,0.3809D-01,0.2405D-01,0.1421D-01,0.7616D-02,0.3538D-02,
     +0.1286D-02,0.2875D-03,0.6230D-04,0.2968D-11/

       DATA (XQDUM (I, 7,4),I=1, 76) /

     +-.4025D+03,0.1057D+03,0.4760D+03,0.7427D+03,0.9241D+03,0.1039D+04,
     +0.1103D+04,0.1127D+04,0.1123D+04,0.1096D+04,0.1054D+04,0.1001D+04,
     +0.9420D+03,0.8788D+03,0.8141D+03,0.7496D+03,0.6867D+03,0.6262D+03,
     +0.5687D+03,0.5145D+03,0.4640D+03,0.4172D+03,0.3739D+03,0.3345D+03,
     +0.2985D+03,0.2657D+03,0.2359D+03,0.2092D+03,0.1851D+03,0.1635D+03,
     +0.1440D+03,0.1267D+03,0.1113D+03,0.9748D+02,0.8523D+02,0.7436D+02,
     +0.6471D+02,0.5619D+02,0.4864D+02,0.4198D+02,0.3610D+02,0.3094D+02,
     +0.2640D+02,0.2242D+02,0.1893D+02,0.1591D+02,0.1327D+02,0.1098D+02,
     +0.9005D+01,0.7324D+01,0.5884D+01,0.4670D+01,0.3657D+01,0.2818D+01,
     +0.2133D+01,0.1583D+01,0.1148D+01,0.8143D+00,0.5624D+00,0.3774D+00,
     +0.2928D+00,0.2279D+00,0.1780D+00,0.1391D+00,0.1088D+00,0.8467D-01,
     +0.6546D-01,0.4995D-01,0.3732D-01,0.2705D-01,0.1868D-01,0.1198D-01,
     +0.6729D-02,0.2898D-02,0.1235D-02,0.1090D-06/

       DATA (XQDUM (I, 7,5),I=1, 76) /

     +0.1180D+03,0.5773D+03,0.9034D+03,0.1130D+04,0.1274D+04,0.1356D+04,
     +0.1389D+04,0.1386D+04,0.1356D+04,0.1306D+04,0.1243D+04,0.1172D+04,
     +0.1096D+04,0.1017D+04,0.9382D+03,0.8610D+03,0.7866D+03,0.7157D+03,
     +0.6487D+03,0.5860D+03,0.5278D+03,0.4740D+03,0.4244D+03,0.3794D+03,
     +0.3384D+03,0.3010D+03,0.2671D+03,0.2367D+03,0.2093D+03,0.1847D+03,
     +0.1626D+03,0.1430D+03,0.1255D+03,0.1098D+03,0.9588D+02,0.8355D+02,
     +0.7261D+02,0.6294D+02,0.5440D+02,0.4685D+02,0.4021D+02,0.3437D+02,
     +0.2925D+02,0.2476D+02,0.2084D+02,0.1744D+02,0.1448D+02,0.1192D+02,
     +0.9717D+01,0.7844D+01,0.6245D+01,0.4900D+01,0.3780D+01,0.2858D+01,
     +0.2108D+01,0.1511D+01,0.1044D+01,0.6921D+00,0.4340D+00,0.2533D+00,
     +0.1755D+00,0.1196D+00,0.8000D-01,0.5221D-01,0.3317D-01,0.2032D-01,
     +0.1194D-01,0.6645D-02,0.3441D-02,0.1625D-02,0.6713D-03,0.2281D-03,
     +0.5533D-04,0.6722D-05,0.7027D-06,-.9648D-13/

       DATA (XQDUM (I, 7,6),I=1, 76) /

     +0.7860D+05,0.6612D+05,0.5572D+05,0.4688D+05,0.3945D+05,0.3321D+05,
     +0.2795D+05,0.2353D+05,0.1981D+05,0.1667D+05,0.1402D+05,0.1180D+05,
     +0.9928D+04,0.8349D+04,0.7019D+04,0.5899D+04,0.4956D+04,0.4164D+04,
     +0.3496D+04,0.2933D+04,0.2460D+04,0.2062D+04,0.1726D+04,0.1446D+04,
     +0.1210D+04,0.1011D+04,0.8437D+03,0.7038D+03,0.5862D+03,0.4880D+03,
     +0.4053D+03,0.3363D+03,0.2787D+03,0.2303D+03,0.1900D+03,0.1565D+03,
     +0.1285D+03,0.1053D+03,0.8600D+02,0.6999D+02,0.5678D+02,0.4587D+02,
     +0.3690D+02,0.2952D+02,0.2349D+02,0.1859D+02,0.1460D+02,0.1137D+02,
     +0.8772D+01,0.6708D+01,0.5061D+01,0.3768D+01,0.2761D+01,0.1986D+01,
     +0.1396D+01,0.9556D+00,0.6327D+00,0.4029D+00,0.2438D+00,0.1380D+00,
     +0.9413D-01,0.6334D-01,0.4199D-01,0.2723D-01,0.1724D-01,0.1055D-01,
     +0.6211D-02,0.3471D-02,0.1808D-02,0.8608D-03,0.3586D-03,0.1229D-03,
     +0.3007D-04,0.3742D-05,0.4411D-06,-.9107D-14/

       DATA (XQDUM (I, 8,1),I=1, 76) /

     +0.8367D+04,0.7875D+04,0.7347D+04,0.6796D+04,0.6244D+04,0.5703D+04,
     +0.5181D+04,0.4685D+04,0.4217D+04,0.3782D+04,0.3378D+04,0.3009D+04,
     +0.2671D+04,0.2364D+04,0.2086D+04,0.1836D+04,0.1612D+04,0.1412D+04,
     +0.1234D+04,0.1075D+04,0.9355D+03,0.8119D+03,0.7027D+03,0.6076D+03,
     +0.5241D+03,0.4508D+03,0.3870D+03,0.3316D+03,0.2835D+03,0.2419D+03,
     +0.2058D+03,0.1748D+03,0.1482D+03,0.1252D+03,0.1056D+03,0.8877D+02,
     +0.7444D+02,0.6226D+02,0.5192D+02,0.4314D+02,0.3574D+02,0.2949D+02,
     +0.2425D+02,0.1985D+02,0.1616D+02,0.1311D+02,0.1057D+02,0.8468D+01,
     +0.6732D+01,0.5318D+01,0.4158D+01,0.3219D+01,0.2464D+01,0.1859D+01,
     +0.1380D+01,0.1005D+01,0.7136D+00,0.4926D+00,0.3274D+00,0.2071D+00,
     +0.1526D+00,0.1114D+00,0.8052D-01,0.5727D-01,0.4002D-01,0.2728D-01,
     +0.1805D-01,0.1149D-01,0.6936D-02,0.3910D-02,0.1992D-02,0.8757D-03,
     +0.2985D-03,0.6148D-04,0.1242D-04,0.6153D-12/

       DATA (XQDUM (I, 8,2),I=1, 76) /

     +0.1185D+04,0.1508D+04,0.1713D+04,0.1829D+04,0.1875D+04,0.1870D+04,
     +0.1826D+04,0.1756D+04,0.1667D+04,0.1566D+04,0.1459D+04,0.1350D+04,
     +0.1241D+04,0.1135D+04,0.1032D+04,0.9354D+03,0.8444D+03,0.7598D+03,
     +0.6814D+03,0.6094D+03,0.5436D+03,0.4838D+03,0.4294D+03,0.3807D+03,
     +0.3367D+03,0.2972D+03,0.2617D+03,0.2302D+03,0.2021D+03,0.1772D+03,
     +0.1550D+03,0.1354D+03,0.1181D+03,0.1028D+03,0.8928D+02,0.7739D+02,
     +0.6692D+02,0.5774D+02,0.4968D+02,0.4261D+02,0.3642D+02,0.3102D+02,
     +0.2631D+02,0.2221D+02,0.1864D+02,0.1557D+02,0.1291D+02,0.1062D+02,
     +0.8654D+01,0.6994D+01,0.5584D+01,0.4403D+01,0.3425D+01,0.2622D+01,
     +0.1971D+01,0.1452D+01,0.1046D+01,0.7366D+00,0.5049D+00,0.3361D+00,
     +0.2594D+00,0.2008D+00,0.1559D+00,0.1211D+00,0.9399D-01,0.7256D-01,
     +0.5557D-01,0.4195D-01,0.3095D-01,0.2210D-01,0.1498D-01,0.9392D-02,
     +0.5120D-02,0.2108D-02,0.8583D-03,0.4547D-07/

       DATA (XQDUM (I, 8,3),I=1, 76) /

     +0.7670D+03,0.1121D+04,0.1353D+04,0.1495D+04,0.1566D+04,0.1584D+04,
     +0.1561D+04,0.1511D+04,0.1440D+04,0.1357D+04,0.1265D+04,0.1171D+04,
     +0.1076D+04,0.9822D+03,0.8920D+03,0.8061D+03,0.7255D+03,0.6505D+03,
     +0.5811D+03,0.5174D+03,0.4593D+03,0.4067D+03,0.3590D+03,0.3164D+03,
     +0.2782D+03,0.2440D+03,0.2135D+03,0.1866D+03,0.1627D+03,0.1417D+03,
     +0.1231D+03,0.1068D+03,0.9259D+02,0.8008D+02,0.6917D+02,0.5966D+02,
     +0.5138D+02,0.4419D+02,0.3794D+02,0.3251D+02,0.2781D+02,0.2375D+02,
     +0.2024D+02,0.1720D+02,0.1457D+02,0.1232D+02,0.1038D+02,0.8699D+01,
     +0.7253D+01,0.6019D+01,0.4956D+01,0.4048D+01,0.3274D+01,0.2616D+01,
     +0.2060D+01,0.1593D+01,0.1203D+01,0.8847D+00,0.6270D+00,0.4234D+00,
     +0.3246D+00,0.2462D+00,0.1844D+00,0.1358D+00,0.9813D-01,0.6908D-01,
     +0.4719D-01,0.3097D-01,0.1928D-01,0.1120D-01,0.5885D-02,0.2670D-02,
     +0.9406D-03,0.2008D-03,0.4153D-04,0.1186D-11/

       DATA (XQDUM (I, 8,4),I=1, 76) /

     +0.1185D+04,0.1508D+04,0.1713D+04,0.1829D+04,0.1875D+04,0.1870D+04,
     +0.1826D+04,0.1756D+04,0.1667D+04,0.1566D+04,0.1459D+04,0.1350D+04,
     +0.1241D+04,0.1135D+04,0.1032D+04,0.9354D+03,0.8444D+03,0.7598D+03,
     +0.6814D+03,0.6094D+03,0.5436D+03,0.4838D+03,0.4294D+03,0.3807D+03,
     +0.3367D+03,0.2972D+03,0.2617D+03,0.2302D+03,0.2021D+03,0.1772D+03,
     +0.1550D+03,0.1354D+03,0.1181D+03,0.1028D+03,0.8928D+02,0.7739D+02,
     +0.6692D+02,0.5774D+02,0.4968D+02,0.4261D+02,0.3642D+02,0.3102D+02,
     +0.2631D+02,0.2221D+02,0.1864D+02,0.1557D+02,0.1291D+02,0.1062D+02,
     +0.8654D+01,0.6994D+01,0.5584D+01,0.4403D+01,0.3425D+01,0.2622D+01,
     +0.1971D+01,0.1452D+01,0.1046D+01,0.7366D+00,0.5049D+00,0.3361D+00,
     +0.2594D+00,0.2008D+00,0.1559D+00,0.1211D+00,0.9399D-01,0.7256D-01,
     +0.5557D-01,0.4195D-01,0.3095D-01,0.2210D-01,0.1498D-01,0.9392D-02,
     +0.5120D-02,0.2108D-02,0.8583D-03,0.4547D-07/

       DATA (XQDUM (I, 8,5),I=1, 76) /

     +0.1706D+04,0.1980D+04,0.2140D+04,0.2215D+04,0.2225D+04,0.2186D+04,
     +0.2112D+04,0.2013D+04,0.1899D+04,0.1776D+04,0.1648D+04,0.1520D+04,
     +0.1394D+04,0.1272D+04,0.1155D+04,0.1046D+04,0.9432D+03,0.8481D+03,
     +0.7604D+03,0.6799D+03,0.6065D+03,0.5397D+03,0.4790D+03,0.4247D+03,
     +0.3758D+03,0.3317D+03,0.2922D+03,0.2571D+03,0.2257D+03,0.1979D+03,
     +0.1731D+03,0.1512D+03,0.1318D+03,0.1147D+03,0.9953D+02,0.8621D+02,
     +0.7448D+02,0.6419D+02,0.5516D+02,0.4723D+02,0.4030D+02,0.3425D+02,
     +0.2898D+02,0.2439D+02,0.2041D+02,0.1698D+02,0.1401D+02,0.1147D+02,
     +0.9287D+01,0.7449D+01,0.5890D+01,0.4589D+01,0.3514D+01,0.2636D+01,
     +0.1928D+01,0.1370D+01,0.9377D+00,0.6149D+00,0.3811D+00,0.2196D+00,
     +0.1508D+00,0.1018D+00,0.6748D-01,0.4362D-01,0.2742D-01,0.1662D-01,
     +0.9650D-02,0.5302D-02,0.2706D-02,0.1258D-02,0.5096D-03,0.1691D-03,
     +0.3975D-04,0.4599D-05,0.4540D-06,-.3975D-13/

       DATA (XQDUM (I, 8,6),I=1, 76) /

     +0.7660D+05,0.6452D+05,0.5443D+05,0.4584D+05,0.3863D+05,0.3255D+05,
     +0.2743D+05,0.2311D+05,0.1947D+05,0.1640D+05,0.1381D+05,0.1163D+05,
     +0.9791D+04,0.8239D+04,0.6930D+04,0.5828D+04,0.4899D+04,0.4117D+04,
     +0.3457D+04,0.2901D+04,0.2434D+04,0.2040D+04,0.1708D+04,0.1430D+04,
     +0.1197D+04,0.9994D+03,0.8336D+03,0.6951D+03,0.5785D+03,0.4812D+03,
     +0.3993D+03,0.3310D+03,0.2739D+03,0.2261D+03,0.1863D+03,0.1532D+03,
     +0.1256D+03,0.1027D+03,0.8372D+02,0.6800D+02,0.5503D+02,0.4435D+02,
     +0.3558D+02,0.2839D+02,0.2251D+02,0.1776D+02,0.1390D+02,0.1079D+02,
     +0.8285D+01,0.6308D+01,0.4737D+01,0.3508D+01,0.2557D+01,0.1828D+01,
     +0.1276D+01,0.8672D+00,0.5695D+00,0.3594D+00,0.2152D+00,0.1204D+00,
     +0.8145D-01,0.5434D-01,0.3571D-01,0.2294D-01,0.1438D-01,0.8707D-02,
     +0.5066D-02,0.2795D-02,0.1435D-02,0.6720D-03,0.2745D-03,0.9187D-04,
     +0.2177D-04,0.2583D-05,0.2898D-06,-.4470D-14/


      data xmin/1.e-03/,xmax/.99/
      data istep/0/
      save
      if(istep.eq.0) then
      do  i=1,ix
        x(i)=log10(xco(i))
      enddo
      do  i=1,iq
        y(i)=log(q2(i))
      enddo
        istep=1
      endif
      if (strfun(1:2) .eq. 'up' ) then
        ifun =3
      else if (strfun(1:2) .eq. 'do') then
        ifun =2
      else if (strfun(1:2) .eq. 'gl') then
        ifun =1
      else if (strfun(1:2) .eq. 'sb') then
        ifun =4
      else if (strfun(1:2) .eq. 'cb') then
        ifun =5
      else if (strfun(1:2) .eq. 'bb') then
        ifun =6
      endif
      do i=1,ix
        do j=1,iq
          f(i,j)=xqdum(i,j,ifun)
        enddo
      enddo
      func=0.
      if(z.gt.xmin.and.z.lt.xmax) then
      a=log10(z)
      b=log(qstar2)
      call locate(x,ix,a,jx)
      call locate(y,iq,b,jq)
      do ijx=1,igt
        if (jx.eq.1) then
          x1a(ijx)=x(jx+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.(ix-1)) then
          x1a(ijx)=x(jx-3+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.ix) then
          x1a(ijx)=x(jx-4+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-2+ijq)
            endif
          enddo
        else
          x1a(ijx)=x(jx-2+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-2+ijq)
            endif
          enddo
        endif
      enddo
      call dpolin2(x1a,x2a,ya,4,4,a,b,yy,dy)
      func = yy
      endif
      end
c
c------------------------------------------------------------
c------------- subroutine to compute a point in x and q**2 --
c------------- for the following fragmentation functions:  --
c-------------     gluon,  up   ,down,                     --
c-------------        strange , charm , bottom.            --
c------------- range of validity :                         --
c-------------                    1.e-03 < x < .99         --
c-------------                    2  < q**2 < 11900 GeV^2  --
c------------------------------------------------------------
c-------------        authors :    L. Bourhis
c-------------                     M. Fontannaz
c-------------                     J.Ph. Guillet
c-------------                     M. Werlen
c-------------    q02=2gev2         method p.nason
c-------------    next to leading evolution
c-------------    table pour la fragmentation en hadrons charges
*         i = 1    gluon
*         i = 2    down ( = antidown )
*         i = 3    up ( = antiup )
*         i = 4    strange ( = antistrange )
*         i = 5    charm ( = anticharm )
*         i = 6    bottom ( = antibottom )
* parametrisation of Fev 2000: formula (9) from the paper
c------------------------------------------------------------
      subroutine  fra_fev2000(z,qstar2,strfun,func)
      implicit real*8 (a-h,o-z)
c------------------------------------------------------------
c-------------   z is x and qstar2 is q square  -------------
      character*(*) strfun
c------------------------------------------------------------
c------------ strfun specifies the desired function----------
c------------------------------------------------------------
c------------------------------------------------------------
c        ifun =  1     gluon           'gl'
c                2     down            'do'
c                3     up              'up'
c                4     strange         'sb'
c                5     charm           'cb'
c                6     bottom          'bb'
c                7     top             'tb'
c------------------------------------------------------------
c-------------  func is the output (parton density value)----
c------------------------------------------------------------
      parameter (ix=76,iq=8,ig1=76,kfun=6)
      parameter (igt=4)
c------------------------------------------------------------
c-----------input tables are given as  33 x points at 7 q**2
c-----------positions
c------------------------------------------------------------
      dimension x(ix),y(iq),f(ix,iq)
      dimension d(ig1)
      dimension xqdum(ix,iq,kfun)
      dimension q2(iq),xco(ix)
      dimension x1a(igt),x2a(igt),ya(igt,igt)
c------------------------------------------------------------
c----------- next the 7 q**2 of the input tables are defined
****                                         q2fin= final scale (gev**2)
****                                         q2fin= final scale (gev**2)
      data q2 /2.,11.9,23.8,119.,238.,1190.,2380.,11900./
c------------------------------------------------------------
c----------------------------------------------------------------
c----------- and now the  76 x positions ------------------------
c----------------------------------------------------------------
 
      data xco   /
     +0.1115d-02,0.1237d-02,0.1371d-02,0.1521d-02,0.1687d-02,0.1871d-02,
     +0.2075d-02,0.2301d-02,0.2552d-02,0.2830d-02,0.3139d-02,0.3481d-02,
     +0.3860d-02,0.4281d-02,0.4748d-02,0.5266d-02,0.5840d-02,0.6476d-02,
     +0.7182d-02,0.7966d-02,0.8834d-02,0.9797d-02,0.1087d-01,0.1205d-01,
     +0.1336d-01,0.1482d-01,0.1644d-01,0.1823d-01,0.2022d-01,0.2242d-01,
     +0.2487d-01,0.2758d-01,0.3058d-01,0.3392d-01,0.3762d-01,0.4172d-01,
     +0.4627d-01,0.5131d-01,0.5690d-01,0.6311d-01,0.6999d-01,0.7762d-01,
     +0.8608d-01,0.9547d-01,0.1059d+00,0.1174d+00,0.1302d+00,0.1444d+00,
     +0.1602d+00,0.1776d+00,0.1970d+00,0.2185d+00,0.2423d+00,0.2687d+00,
     +0.2980d+00,0.3305d+00,0.3666d+00,0.4065d+00,0.4508d+00,0.5000d+00,
     +0.5321d+00,0.5643d+00,0.5964d+00,0.6286d+00,0.6607d+00,0.6929d+00,
     +0.7250d+00,0.7571d+00,0.7893d+00,0.8214d+00,0.8536d+00,0.8857d+00,
     +0.9179d+00,0.9500d+00,0.9700d+00,0.9999d+00/
 
       DATA (XQDUM (I, 1,1),I=1, 76) /

     +0.5243D+01,0.5242D+01,0.5240D+01,0.5239D+01,0.5237D+01,0.5236D+01,
     +0.5234D+01,0.5231D+01,0.5229D+01,0.5226D+01,0.5223D+01,0.5220D+01,
     +0.5216D+01,0.5212D+01,0.5208D+01,0.5203D+01,0.5197D+01,0.5191D+01,
     +0.5184D+01,0.5177D+01,0.5168D+01,0.5159D+01,0.5148D+01,0.5137D+01,
     +0.5124D+01,0.5110D+01,0.5095D+01,0.5078D+01,0.5059D+01,0.5038D+01,
     +0.5014D+01,0.4988D+01,0.4960D+01,0.4928D+01,0.4893D+01,0.4855D+01,
     +0.4812D+01,0.4765D+01,0.4713D+01,0.4656D+01,0.4593D+01,0.4523D+01,
     +0.4447D+01,0.4362D+01,0.4270D+01,0.4168D+01,0.4057D+01,0.3935D+01,
     +0.3802D+01,0.3657D+01,0.3499D+01,0.3327D+01,0.3142D+01,0.2942D+01,
     +0.2727D+01,0.2498D+01,0.2254D+01,0.1998D+01,0.1730D+01,0.1454D+01,
     +0.1286D+01,0.1127D+01,0.9777D+00,0.8381D+00,0.7088D+00,0.5893D+00,
     +0.4802D+00,0.3815D+00,0.2931D+00,0.2158D+00,0.1493D+00,0.9437D-01,
     +0.5111D-01,0.2039D-01,0.7912D-02,0.2031D-06/

       DATA (XQDUM (I, 1,2),I=1, 76) /

     +0.9714D+03,0.8953D+03,0.8257D+03,0.7609D+03,0.7013D+03,0.6463D+03,
     +0.5956D+03,0.5489D+03,0.5057D+03,0.4660D+03,0.4292D+03,0.3953D+03,
     +0.3641D+03,0.3352D+03,0.3086D+03,0.2840D+03,0.2613D+03,0.2404D+03,
     +0.2211D+03,0.2032D+03,0.1867D+03,0.1716D+03,0.1575D+03,0.1446D+03,
     +0.1326D+03,0.1216D+03,0.1113D+03,0.1019D+03,0.9320D+02,0.8518D+02,
     +0.7773D+02,0.7088D+02,0.6455D+02,0.5868D+02,0.5327D+02,0.4827D+02,
     +0.4366D+02,0.3940D+02,0.3547D+02,0.3183D+02,0.2849D+02,0.2540D+02,
     +0.2257D+02,0.1996D+02,0.1756D+02,0.1538D+02,0.1338D+02,0.1155D+02,
     +0.9897D+01,0.8412D+01,0.7072D+01,0.5880D+01,0.4828D+01,0.3908D+01,
     +0.3112D+01,0.2435D+01,0.1867D+01,0.1403D+01,0.1031D+01,0.7418D+00,
     +0.6028D+00,0.4927D+00,0.4055D+00,0.3356D+00,0.2794D+00,0.2333D+00,
     +0.1951D+00,0.1628D+00,0.1348D+00,0.1101D+00,0.8773D-01,0.6708D-01,
     +0.4758D-01,0.2894D-01,0.1756D-01,0.7766D-04/

       DATA (XQDUM (I, 1,3),I=1, 76) /

     +0.4088D+03,0.3769D+03,0.3477D+03,0.3206D+03,0.2956D+03,0.2725D+03,
     +0.2513D+03,0.2317D+03,0.2137D+03,0.1970D+03,0.1816D+03,0.1674D+03,
     +0.1544D+03,0.1423D+03,0.1311D+03,0.1209D+03,0.1114D+03,0.1027D+03,
     +0.9459D+02,0.8714D+02,0.8027D+02,0.7394D+02,0.6807D+02,0.6269D+02,
     +0.5773D+02,0.5312D+02,0.4887D+02,0.4496D+02,0.4134D+02,0.3801D+02,
     +0.3492D+02,0.3208D+02,0.2946D+02,0.2703D+02,0.2479D+02,0.2272D+02,
     +0.2080D+02,0.1903D+02,0.1740D+02,0.1589D+02,0.1449D+02,0.1319D+02,
     +0.1199D+02,0.1088D+02,0.9854D+01,0.8905D+01,0.8021D+01,0.7201D+01,
     +0.6438D+01,0.5735D+01,0.5079D+01,0.4470D+01,0.3906D+01,0.3383D+01,
     +0.2898D+01,0.2450D+01,0.2037D+01,0.1660D+01,0.1318D+01,0.1009D+01,
     +0.8416D+00,0.6954D+00,0.5692D+00,0.4598D+00,0.3659D+00,0.2856D+00,
     +0.2178D+00,0.1613D+00,0.1147D+00,0.7750D-01,0.4858D-01,0.2729D-01,
     +0.1271D-01,0.4074D-02,0.1271D-02,0.3152D-08/

       DATA (XQDUM (I, 1,4),I=1, 76) /

     +0.9714D+03,0.8953D+03,0.8257D+03,0.7609D+03,0.7013D+03,0.6463D+03,
     +0.5956D+03,0.5489D+03,0.5057D+03,0.4660D+03,0.4292D+03,0.3953D+03,
     +0.3641D+03,0.3352D+03,0.3086D+03,0.2840D+03,0.2613D+03,0.2404D+03,
     +0.2211D+03,0.2032D+03,0.1867D+03,0.1716D+03,0.1575D+03,0.1446D+03,
     +0.1326D+03,0.1216D+03,0.1113D+03,0.1019D+03,0.9320D+02,0.8518D+02,
     +0.7773D+02,0.7088D+02,0.6455D+02,0.5868D+02,0.5327D+02,0.4827D+02,
     +0.4366D+02,0.3940D+02,0.3547D+02,0.3183D+02,0.2849D+02,0.2540D+02,
     +0.2257D+02,0.1996D+02,0.1756D+02,0.1538D+02,0.1338D+02,0.1155D+02,
     +0.9897D+01,0.8412D+01,0.7072D+01,0.5880D+01,0.4828D+01,0.3908D+01,
     +0.3112D+01,0.2435D+01,0.1867D+01,0.1403D+01,0.1031D+01,0.7418D+00,
     +0.6028D+00,0.4927D+00,0.4055D+00,0.3356D+00,0.2794D+00,0.2333D+00,
     +0.1951D+00,0.1628D+00,0.1348D+00,0.1101D+00,0.8773D-01,0.6708D-01,
     +0.4758D-01,0.2894D-01,0.1756D-01,0.7766D-04/

       DATA (XQDUM (I, 1,5),I=1, 76) /

     +0.2122D+04,0.1928D+04,0.1753D+04,0.1592D+04,0.1446D+04,0.1314D+04,
     +0.1193D+04,0.1084D+04,0.9843D+03,0.8940D+03,0.8116D+03,0.7369D+03,
     +0.6690D+03,0.6072D+03,0.5510D+03,0.4999D+03,0.4535D+03,0.4113D+03,
     +0.3729D+03,0.3380D+03,0.3062D+03,0.2774D+03,0.2511D+03,0.2273D+03,
     +0.2057D+03,0.1859D+03,0.1679D+03,0.1517D+03,0.1368D+03,0.1234D+03,
     +0.1111D+03,0.9996D+02,0.8986D+02,0.8064D+02,0.7227D+02,0.6467D+02,
     +0.5777D+02,0.5150D+02,0.4581D+02,0.4064D+02,0.3595D+02,0.3170D+02,
     +0.2786D+02,0.2438D+02,0.2123D+02,0.1840D+02,0.1585D+02,0.1356D+02,
     +0.1150D+02,0.9684D+01,0.8060D+01,0.6629D+01,0.5377D+01,0.4289D+01,
     +0.3353D+01,0.2559D+01,0.1896D+01,0.1356D+01,0.9259D+00,0.5954D+00,
     +0.4402D+00,0.3205D+00,0.2297D+00,0.1610D+00,0.1102D+00,0.7303D-01,
     +0.4662D-01,0.2834D-01,0.1614D-01,0.8458D-02,0.3921D-02,0.1521D-02,
     +0.4345D-03,0.6760D-04,0.1008D-04,0.7170D-14/

       DATA (XQDUM (I, 1,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 2,1),I=1, 76) /

     +-.3969D+04,-.3252D+04,-.2657D+04,-.2157D+04,-.1741D+04,-.1397D+04,
     +-.1112D+04,-.8767D+03,-.6835D+03,-.5257D+03,-.3969D+03,-.2929D+03,
     +-.2093D+03,-.1424D+03,-.8946D+02,-.4799D+02,-.1595D+02,0.8401D+01,
     +0.2655D+02,0.3969D+02,0.4879D+02,0.5469D+02,0.5809D+02,0.5951D+02,
     +0.5945D+02,0.5826D+02,0.5625D+02,0.5368D+02,0.5071D+02,0.4752D+02,
     +0.4421D+02,0.4089D+02,0.3762D+02,0.3445D+02,0.3142D+02,0.2855D+02,
     +0.2586D+02,0.2336D+02,0.2105D+02,0.1891D+02,0.1696D+02,0.1518D+02,
     +0.1357D+02,0.1210D+02,0.1077D+02,0.9572D+01,0.8488D+01,0.7508D+01,
     +0.6620D+01,0.5823D+01,0.5097D+01,0.4438D+01,0.3841D+01,0.3297D+01,
     +0.2800D+01,0.2347D+01,0.1935D+01,0.1562D+01,0.1225D+01,0.9262D+00,
     +0.7647D+00,0.6252D+00,0.5058D+00,0.4033D+00,0.3164D+00,0.2430D+00,
     +0.1821D+00,0.1321D+00,0.9174D-01,0.6030D-01,0.3656D-01,0.1970D-01,
     +0.8674D-02,0.2559D-02,0.7333D-03,0.7792D-09/

       DATA (XQDUM (I, 2,2),I=1, 76) /

     +-.1253D+04,-.9462D+03,-.6965D+03,-.4907D+03,-.3243D+03,-.1906D+03,
     +-.8403D+02,-.1225D+00,0.6518D+02,0.1149D+03,0.1520D+03,0.1787D+03,
     +0.1968D+03,0.2082D+03,0.2140D+03,0.2155D+03,0.2136D+03,0.2090D+03,
     +0.2025D+03,0.1945D+03,0.1855D+03,0.1759D+03,0.1657D+03,0.1556D+03,
     +0.1453D+03,0.1352D+03,0.1254D+03,0.1159D+03,0.1067D+03,0.9803D+02,
     +0.8975D+02,0.8196D+02,0.7464D+02,0.6775D+02,0.6133D+02,0.5536D+02,
     +0.4981D+02,0.4468D+02,0.3994D+02,0.3556D+02,0.3155D+02,0.2787D+02,
     +0.2450D+02,0.2143D+02,0.1864D+02,0.1612D+02,0.1384D+02,0.1180D+02,
     +0.9964D+01,0.8346D+01,0.6910D+01,0.5655D+01,0.4568D+01,0.3635D+01,
     +0.2844D+01,0.2185D+01,0.1643D+01,0.1210D+01,0.8703D+00,0.6104D+00,
     +0.4875D+00,0.3910D+00,0.3152D+00,0.2549D+00,0.2068D+00,0.1677D+00,
     +0.1358D+00,0.1092D+00,0.8674D-01,0.6753D-01,0.5084D-01,0.3629D-01,
     +0.2353D-01,0.1255D-01,0.6659D-02,0.6689D-05/

       DATA (XQDUM (I, 2,3),I=1, 76) /

     +-.1844D+04,-.1491D+04,-.1198D+04,-.9525D+03,-.7495D+03,-.5819D+03,
     +-.4442D+03,-.3316D+03,-.2397D+03,-.1655D+03,-.1057D+03,-.5824D+02,
     +-.2087D+02,0.8240D+01,0.3049D+02,0.4712D+02,0.5917D+02,0.6750D+02,
     +0.7287D+02,0.7587D+02,0.7700D+02,0.7667D+02,0.7521D+02,0.7294D+02,
     +0.7005D+02,0.6673D+02,0.6312D+02,0.5937D+02,0.5555D+02,0.5175D+02,
     +0.4799D+02,0.4435D+02,0.4086D+02,0.3750D+02,0.3432D+02,0.3133D+02,
     +0.2852D+02,0.2589D+02,0.2344D+02,0.2117D+02,0.1906D+02,0.1712D+02,
     +0.1533D+02,0.1369D+02,0.1218D+02,0.1080D+02,0.9539D+01,0.8387D+01,
     +0.7334D+01,0.6384D+01,0.5516D+01,0.4731D+01,0.4023D+01,0.3386D+01,
     +0.2813D+01,0.2301D+01,0.1847D+01,0.1449D+01,0.1102D+01,0.8059D+00,
     +0.6515D+00,0.5216D+00,0.4132D+00,0.3227D+00,0.2480D+00,0.1864D+00,
     +0.1367D+00,0.9691D-01,0.6573D-01,0.4211D-01,0.2482D-01,0.1294D-01,
     +0.5474D-02,0.1528D-02,0.4149D-03,0.2317D-09/

       DATA (XQDUM (I, 2,4),I=1, 76) /

     +-.1253D+04,-.9462D+03,-.6965D+03,-.4907D+03,-.3243D+03,-.1906D+03,
     +-.8403D+02,-.1225D+00,0.6518D+02,0.1149D+03,0.1520D+03,0.1787D+03,
     +0.1968D+03,0.2082D+03,0.2140D+03,0.2155D+03,0.2136D+03,0.2090D+03,
     +0.2025D+03,0.1945D+03,0.1855D+03,0.1759D+03,0.1657D+03,0.1556D+03,
     +0.1453D+03,0.1352D+03,0.1254D+03,0.1159D+03,0.1067D+03,0.9803D+02,
     +0.8975D+02,0.8196D+02,0.7464D+02,0.6775D+02,0.6133D+02,0.5536D+02,
     +0.4981D+02,0.4468D+02,0.3994D+02,0.3556D+02,0.3155D+02,0.2787D+02,
     +0.2450D+02,0.2143D+02,0.1864D+02,0.1612D+02,0.1384D+02,0.1180D+02,
     +0.9964D+01,0.8346D+01,0.6910D+01,0.5655D+01,0.4568D+01,0.3635D+01,
     +0.2844D+01,0.2185D+01,0.1643D+01,0.1210D+01,0.8703D+00,0.6104D+00,
     +0.4875D+00,0.3910D+00,0.3152D+00,0.2549D+00,0.2068D+00,0.1677D+00,
     +0.1358D+00,0.1092D+00,0.8674D-01,0.6753D-01,0.5084D-01,0.3629D-01,
     +0.2353D-01,0.1255D-01,0.6659D-02,0.6689D-05/

       DATA (XQDUM (I, 2,5),I=1, 76) /

     +-.1207D+03,0.6884D+02,0.2137D+03,0.3243D+03,0.4053D+03,0.4623D+03,
     +0.4999D+03,0.5219D+03,0.5315D+03,0.5314D+03,0.5236D+03,0.5100D+03,
     +0.4921D+03,0.4710D+03,0.4479D+03,0.4234D+03,0.3982D+03,0.3729D+03,
     +0.3477D+03,0.3231D+03,0.2993D+03,0.2763D+03,0.2543D+03,0.2336D+03,
     +0.2141D+03,0.1956D+03,0.1783D+03,0.1622D+03,0.1472D+03,0.1333D+03,
     +0.1204D+03,0.1086D+03,0.9771D+02,0.8767D+02,0.7848D+02,0.7008D+02,
     +0.6240D+02,0.5541D+02,0.4905D+02,0.4326D+02,0.3803D+02,0.3329D+02,
     +0.2901D+02,0.2516D+02,0.2170D+02,0.1862D+02,0.1585D+02,0.1340D+02,
     +0.1122D+02,0.9312D+01,0.7635D+01,0.6179D+01,0.4926D+01,0.3857D+01,
     +0.2956D+01,0.2208D+01,0.1598D+01,0.1114D+01,0.7397D+00,0.4609D+00,
     +0.3337D+00,0.2379D+00,0.1668D+00,0.1143D+00,0.7644D-01,0.4941D-01,
     +0.3073D-01,0.1816D-01,0.1003D-01,0.5074D-02,0.2258D-02,0.8329D-03,
     +0.2218D-03,0.3052D-04,0.3791D-05,-.9040D-12/

       DATA (XQDUM (I, 2,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 3,1),I=1, 76) /

     +-.4353D+04,-.3510D+04,-.2817D+04,-.2240D+04,-.1766D+04,-.1378D+04,
     +-.1061D+04,-.8034D+03,-.5951D+03,-.4281D+03,-.2945D+03,-.1892D+03,
     +-.1068D+03,-.4309D+02,0.5393D+01,0.4150D+02,0.6763D+02,0.8579D+02,
     +0.9767D+02,0.1046D+03,0.1077D+03,0.1079D+03,0.1058D+03,0.1022D+03,
     +0.9745D+02,0.9193D+02,0.8597D+02,0.7981D+02,0.7360D+02,0.6750D+02,
     +0.6157D+02,0.5593D+02,0.5060D+02,0.4560D+02,0.4095D+02,0.3667D+02,
     +0.3274D+02,0.2916D+02,0.2591D+02,0.2296D+02,0.2030D+02,0.1792D+02,
     +0.1578D+02,0.1387D+02,0.1216D+02,0.1065D+02,0.9299D+01,0.8095D+01,
     +0.7021D+01,0.6072D+01,0.5223D+01,0.4467D+01,0.3794D+01,0.3194D+01,
     +0.2658D+01,0.2182D+01,0.1758D+01,0.1386D+01,0.1059D+01,0.7782D+00,
     +0.6306D+00,0.5059D+00,0.4013D+00,0.3136D+00,0.2409D+00,0.1809D+00,
     +0.1324D+00,0.9355D-01,0.6315D-01,0.4019D-01,0.2346D-01,0.1208D-01,
     +0.5012D-02,0.1357D-02,0.3566D-03,0.1746D-09/

       DATA (XQDUM (I, 3,2),I=1, 76) /

     +-.1708D+04,-.1299D+04,-.9673D+03,-.6949D+03,-.4753D+03,-.2991D+03,
     +-.1590D+03,-.4879D+02,0.3689D+02,0.1022D+03,0.1510D+03,0.1863D+03,
     +0.2105D+03,0.2260D+03,0.2345D+03,0.2375D+03,0.2361D+03,0.2315D+03,
     +0.2243D+03,0.2153D+03,0.2051D+03,0.1941D+03,0.1825D+03,0.1709D+03,
     +0.1592D+03,0.1477D+03,0.1365D+03,0.1257D+03,0.1154D+03,0.1056D+03,
     +0.9632D+02,0.8762D+02,0.7948D+02,0.7186D+02,0.6479D+02,0.5824D+02,
     +0.5219D+02,0.4662D+02,0.4149D+02,0.3679D+02,0.3249D+02,0.2857D+02,
     +0.2501D+02,0.2178D+02,0.1885D+02,0.1623D+02,0.1387D+02,0.1176D+02,
     +0.9885D+01,0.8237D+01,0.6785D+01,0.5522D+01,0.4436D+01,0.3511D+01,
     +0.2731D+01,0.2085D+01,0.1559D+01,0.1140D+01,0.8143D+00,0.5668D+00,
     +0.4504D+00,0.3593D+00,0.2880D+00,0.2315D+00,0.1865D+00,0.1501D+00,
     +0.1205D+00,0.9599D-01,0.7537D-01,0.5792D-01,0.4292D-01,0.3005D-01,
     +0.1899D-01,0.9748D-02,0.4974D-02,0.3239D-05/

       DATA (XQDUM (I, 3,3),I=1, 76) /

     +-.2307D+04,-.1851D+04,-.1476D+04,-.1163D+04,-.9060D+03,-.6955D+03,
     +-.5236D+03,-.3842D+03,-.2715D+03,-.1813D+03,-.1095D+03,-.5307D+02,
     +-.9250D+01,0.2432D+02,0.4948D+02,0.6781D+02,0.8063D+02,0.8904D+02,
     +0.9396D+02,0.9615D+02,0.9621D+02,0.9465D+02,0.9187D+02,0.8824D+02,
     +0.8400D+02,0.7934D+02,0.7446D+02,0.6951D+02,0.6456D+02,0.5971D+02,
     +0.5499D+02,0.5048D+02,0.4619D+02,0.4212D+02,0.3830D+02,0.3473D+02,
     +0.3141D+02,0.2833D+02,0.2549D+02,0.2287D+02,0.2047D+02,0.1827D+02,
     +0.1626D+02,0.1442D+02,0.1274D+02,0.1123D+02,0.9853D+01,0.8605D+01,
     +0.7474D+01,0.6460D+01,0.5541D+01,0.4717D+01,0.3981D+01,0.3322D+01,
     +0.2737D+01,0.2219D+01,0.1764D+01,0.1369D+01,0.1030D+01,0.7432D+00,
     +0.5957D+00,0.4728D+00,0.3713D+00,0.2872D+00,0.2186D+00,0.1626D+00,
     +0.1179D+00,0.8263D-01,0.5531D-01,0.3491D-01,0.2022D-01,0.1033D-01,
     +0.4250D-02,0.1140D-02,0.2975D-03,0.1075D-09/

       DATA (XQDUM (I, 3,4),I=1, 76) /

     +-.1708D+04,-.1299D+04,-.9673D+03,-.6949D+03,-.4753D+03,-.2991D+03,
     +-.1590D+03,-.4879D+02,0.3689D+02,0.1022D+03,0.1510D+03,0.1863D+03,
     +0.2105D+03,0.2260D+03,0.2345D+03,0.2375D+03,0.2361D+03,0.2315D+03,
     +0.2243D+03,0.2153D+03,0.2051D+03,0.1941D+03,0.1825D+03,0.1709D+03,
     +0.1592D+03,0.1477D+03,0.1365D+03,0.1257D+03,0.1154D+03,0.1056D+03,
     +0.9632D+02,0.8762D+02,0.7948D+02,0.7186D+02,0.6479D+02,0.5824D+02,
     +0.5219D+02,0.4662D+02,0.4149D+02,0.3679D+02,0.3249D+02,0.2857D+02,
     +0.2501D+02,0.2178D+02,0.1885D+02,0.1623D+02,0.1387D+02,0.1176D+02,
     +0.9885D+01,0.8237D+01,0.6785D+01,0.5522D+01,0.4436D+01,0.3511D+01,
     +0.2731D+01,0.2085D+01,0.1559D+01,0.1140D+01,0.8143D+00,0.5668D+00,
     +0.4504D+00,0.3593D+00,0.2880D+00,0.2315D+00,0.1865D+00,0.1501D+00,
     +0.1205D+00,0.9599D-01,0.7537D-01,0.5792D-01,0.4292D-01,0.3005D-01,
     +0.1899D-01,0.9748D-02,0.4974D-02,0.3239D-05/

       DATA (XQDUM (I, 3,5),I=1, 76) /

     +-.5814D+03,-.2897D+03,-.6274D+02,0.1148D+03,0.2493D+03,0.3490D+03,
     +0.4205D+03,0.4690D+03,0.4993D+03,0.5149D+03,0.5190D+03,0.5142D+03,
     +0.5027D+03,0.4860D+03,0.4656D+03,0.4428D+03,0.4183D+03,0.3930D+03,
     +0.3674D+03,0.3420D+03,0.3170D+03,0.2929D+03,0.2695D+03,0.2475D+03,
     +0.2266D+03,0.2068D+03,0.1882D+03,0.1710D+03,0.1549D+03,0.1400D+03,
     +0.1262D+03,0.1135D+03,0.1019D+03,0.9118D+02,0.8139D+02,0.7247D+02,
     +0.6434D+02,0.5695D+02,0.5025D+02,0.4417D+02,0.3869D+02,0.3375D+02,
     +0.2930D+02,0.2531D+02,0.2174D+02,0.1858D+02,0.1575D+02,0.1325D+02,
     +0.1104D+02,0.9122D+01,0.7440D+01,0.5988D+01,0.4746D+01,0.3694D+01,
     +0.2812D+01,0.2085D+01,0.1498D+01,0.1035D+01,0.6809D+00,0.4197D+00,
     +0.3017D+00,0.2135D+00,0.1486D+00,0.1010D+00,0.6698D-01,0.4291D-01,
     +0.2642D-01,0.1545D-01,0.8430D-02,0.4208D-02,0.1843D-02,0.6664D-03,
     +0.1728D-03,0.2281D-04,0.2703D-05,-.5255D-12/

       DATA (XQDUM (I, 3,6),I=1, 76) /

     +0.9254D+05,0.7753D+05,0.6507D+05,0.5451D+05,0.4569D+05,0.3829D+05,
     +0.3209D+05,0.2690D+05,0.2254D+05,0.1889D+05,0.1582D+05,0.1326D+05,
     +0.1111D+05,0.9301D+04,0.7787D+04,0.6519D+04,0.5456D+04,0.4567D+04,
     +0.3821D+04,0.3195D+04,0.2671D+04,0.2233D+04,0.1864D+04,0.1558D+04,
     +0.1301D+04,0.1085D+04,0.9040D+03,0.7534D+03,0.6270D+03,0.5218D+03,
     +0.4334D+03,0.3598D+03,0.2985D+03,0.2471D+03,0.2043D+03,0.1687D+03,
     +0.1390D+03,0.1143D+03,0.9380D+02,0.7674D+02,0.6262D+02,0.5093D+02,
     +0.4128D+02,0.3331D+02,0.2674D+02,0.2138D+02,0.1698D+02,0.1339D+02,
     +0.1047D+02,0.8125D+01,0.6231D+01,0.4721D+01,0.3527D+01,0.2591D+01,
     +0.1865D+01,0.1310D+01,0.8930D+00,0.5874D+00,0.3687D+00,0.2177D+00,
     +0.1528D+00,0.1060D+00,0.7246D-01,0.4857D-01,0.3183D-01,0.2023D-01,
     +0.1240D-01,0.7243D-02,0.3966D-02,0.1998D-02,0.8904D-03,0.3315D-03,
     +0.9057D-04,0.1337D-04,0.1910D-05,-.1222D-13/

       DATA (XQDUM (I, 4,1),I=1, 76) /

     +-.3212D+04,-.2400D+04,-.1753D+04,-.1231D+04,-.8180D+03,-.4944D+03,
     +-.2435D+03,-.5193D+02,0.9196D+02,0.1971D+03,0.2714D+03,0.3211D+03,
     +0.3515D+03,0.3670D+03,0.3710D+03,0.3663D+03,0.3553D+03,0.3398D+03,
     +0.3213D+03,0.3008D+03,0.2794D+03,0.2576D+03,0.2360D+03,0.2152D+03,
     +0.1952D+03,0.1762D+03,0.1584D+03,0.1419D+03,0.1266D+03,0.1127D+03,
     +0.9988D+02,0.8831D+02,0.7788D+02,0.6845D+02,0.6002D+02,0.5250D+02,
     +0.4581D+02,0.3988D+02,0.3463D+02,0.3000D+02,0.2593D+02,0.2236D+02,
     +0.1923D+02,0.1650D+02,0.1412D+02,0.1205D+02,0.1025D+02,0.8683D+01,
     +0.7322D+01,0.6151D+01,0.5132D+01,0.4252D+01,0.3494D+01,0.2841D+01,
     +0.2279D+01,0.1799D+01,0.1391D+01,0.1049D+01,0.7640D+00,0.5319D+00,
     +0.4161D+00,0.3219D+00,0.2461D+00,0.1851D+00,0.1366D+00,0.9830D-01,
     +0.6872D-01,0.4623D-01,0.2954D-01,0.1768D-01,0.9607D-02,0.4537D-02,
     +0.1684D-02,0.3881D-03,0.8708D-04,0.1538D-10/

       DATA (XQDUM (I, 4,2),I=1, 76) /

     +-.2277D+04,-.1701D+04,-.1240D+04,-.8651D+03,-.5669D+03,-.3311D+03,
     +-.1467D+03,-.4492D+01,0.1037D+03,0.1838D+03,0.2416D+03,0.2812D+03,
     +0.3065D+03,0.3204D+03,0.3255D+03,0.3238D+03,0.3170D+03,0.3064D+03,
     +0.2931D+03,0.2780D+03,0.2617D+03,0.2449D+03,0.2278D+03,0.2110D+03,
     +0.1946D+03,0.1787D+03,0.1635D+03,0.1491D+03,0.1355D+03,0.1228D+03,
     +0.1110D+03,0.1000D+03,0.8988D+02,0.8051D+02,0.7192D+02,0.6406D+02,
     +0.5687D+02,0.5033D+02,0.4439D+02,0.3900D+02,0.3413D+02,0.2974D+02,
     +0.2579D+02,0.2224D+02,0.1907D+02,0.1627D+02,0.1377D+02,0.1156D+02,
     +0.9618D+01,0.7934D+01,0.6467D+01,0.5208D+01,0.4139D+01,0.3239D+01,
     +0.2491D+01,0.1879D+01,0.1387D+01,0.1002D+01,0.7060D+00,0.4843D+00,
     +0.3811D+00,0.3009D+00,0.2387D+00,0.1896D+00,0.1509D+00,0.1197D+00,
     +0.9459D-01,0.7399D-01,0.5688D-01,0.4264D-01,0.3067D-01,0.2070D-01,
     +0.1245D-01,0.5940D-02,0.2812D-02,0.7976D-06/

       DATA (XQDUM (I, 4,3),I=1, 76) /

     +-.2893D+04,-.2268D+04,-.1762D+04,-.1345D+04,-.1008D+04,-.7369D+03,
     +-.5198D+03,-.3473D+03,-.2113D+03,-.1054D+03,-.2389D+02,0.3760D+02,
     +0.8301D+02,0.1156D+03,0.1379D+03,0.1520D+03,0.1598D+03,0.1627D+03,
     +0.1618D+03,0.1581D+03,0.1524D+03,0.1453D+03,0.1372D+03,0.1286D+03,
     +0.1198D+03,0.1109D+03,0.1021D+03,0.9368D+02,0.8557D+02,0.7790D+02,
     +0.7066D+02,0.6391D+02,0.5765D+02,0.5184D+02,0.4650D+02,0.4161D+02,
     +0.3714D+02,0.3308D+02,0.2938D+02,0.2603D+02,0.2301D+02,0.2028D+02,
     +0.1782D+02,0.1561D+02,0.1363D+02,0.1186D+02,0.1028D+02,0.8861D+01,
     +0.7596D+01,0.6480D+01,0.5484D+01,0.4603D+01,0.3828D+01,0.3147D+01,
     +0.2552D+01,0.2034D+01,0.1588D+01,0.1209D+01,0.8898D+00,0.6271D+00,
     +0.4947D+00,0.3863D+00,0.2983D+00,0.2268D+00,0.1695D+00,0.1237D+00,
     +0.8786D-01,0.6019D-01,0.3930D-01,0.2412D-01,0.1351D-01,0.6634D-02,
     +0.2593D-02,0.6450D-03,0.1559D-03,0.2447D-10/

       DATA (XQDUM (I, 4,4),I=1, 76) /

     +-.2277D+04,-.1701D+04,-.1240D+04,-.8651D+03,-.5669D+03,-.3311D+03,
     +-.1467D+03,-.4492D+01,0.1037D+03,0.1838D+03,0.2416D+03,0.2812D+03,
     +0.3065D+03,0.3204D+03,0.3255D+03,0.3238D+03,0.3170D+03,0.3064D+03,
     +0.2931D+03,0.2780D+03,0.2617D+03,0.2449D+03,0.2278D+03,0.2110D+03,
     +0.1946D+03,0.1787D+03,0.1635D+03,0.1491D+03,0.1355D+03,0.1228D+03,
     +0.1110D+03,0.1000D+03,0.8988D+02,0.8051D+02,0.7192D+02,0.6406D+02,
     +0.5687D+02,0.5033D+02,0.4439D+02,0.3900D+02,0.3413D+02,0.2974D+02,
     +0.2579D+02,0.2224D+02,0.1907D+02,0.1627D+02,0.1377D+02,0.1156D+02,
     +0.9618D+01,0.7934D+01,0.6467D+01,0.5208D+01,0.4139D+01,0.3239D+01,
     +0.2491D+01,0.1879D+01,0.1387D+01,0.1002D+01,0.7060D+00,0.4843D+00,
     +0.3811D+00,0.3009D+00,0.2387D+00,0.1896D+00,0.1509D+00,0.1197D+00,
     +0.9459D-01,0.7399D-01,0.5688D-01,0.4264D-01,0.3067D-01,0.2070D-01,
     +0.1245D-01,0.5940D-02,0.2812D-02,0.7976D-06/

       DATA (XQDUM (I, 4,5),I=1, 76) /

     +-.1164D+04,-.7047D+03,-.3470D+03,-.6646D+02,0.1473D+03,0.3072D+03,
     +0.4234D+03,0.5046D+03,0.5578D+03,0.5888D+03,0.6023D+03,0.6024D+03,
     +0.5922D+03,0.5744D+03,0.5511D+03,0.5239D+03,0.4944D+03,0.4635D+03,
     +0.4320D+03,0.4007D+03,0.3700D+03,0.3403D+03,0.3117D+03,0.2848D+03,
     +0.2593D+03,0.2353D+03,0.2130D+03,0.1923D+03,0.1731D+03,0.1555D+03,
     +0.1393D+03,0.1245D+03,0.1110D+03,0.9866D+02,0.8747D+02,0.7733D+02,
     +0.6817D+02,0.5991D+02,0.5247D+02,0.4578D+02,0.3979D+02,0.3444D+02,
     +0.2967D+02,0.2542D+02,0.2165D+02,0.1834D+02,0.1541D+02,0.1285D+02,
     +0.1060D+02,0.8672D+01,0.6999D+01,0.5571D+01,0.4365D+01,0.3355D+01,
     +0.2521D+01,0.1843D+01,0.1303D+01,0.8857D+00,0.5716D+00,0.3449D+00,
     +0.2444D+00,0.1704D+00,0.1168D+00,0.7815D-01,0.5093D-01,0.3204D-01,
     +0.1935D-01,0.1107D-01,0.5897D-02,0.2864D-02,0.1214D-02,0.4218D-03,
     +0.1037D-03,0.1264D-04,0.1373D-05,-.1546D-12/

       DATA (XQDUM (I, 4,6),I=1, 76) /

     +0.8527D+05,0.7151D+05,0.6007D+05,0.5038D+05,0.4227D+05,0.3547D+05,
     +0.2976D+05,0.2498D+05,0.2095D+05,0.1758D+05,0.1475D+05,0.1237D+05,
     +0.1038D+05,0.8706D+04,0.7300D+04,0.6120D+04,0.5130D+04,0.4300D+04,
     +0.3603D+04,0.3017D+04,0.2526D+04,0.2115D+04,0.1768D+04,0.1479D+04,
     +0.1237D+04,0.1033D+04,0.8618D+03,0.7189D+03,0.5990D+03,0.4989D+03,
     +0.4147D+03,0.3446D+03,0.2860D+03,0.2368D+03,0.1959D+03,0.1617D+03,
     +0.1332D+03,0.1095D+03,0.8984D+02,0.7345D+02,0.5987D+02,0.4863D+02,
     +0.3935D+02,0.3169D+02,0.2538D+02,0.2025D+02,0.1603D+02,0.1260D+02,
     +0.9810D+01,0.7579D+01,0.5783D+01,0.4357D+01,0.3235D+01,0.2359D+01,
     +0.1684D+01,0.1172D+01,0.7903D+00,0.5135D+00,0.3177D+00,0.1844D+00,
     +0.1280D+00,0.8761D-01,0.5912D-01,0.3906D-01,0.2521D-01,0.1575D-01,
     +0.9475D-02,0.5421D-02,0.2899D-02,0.1421D-02,0.6124D-03,0.2188D-03,
     +0.5652D-04,0.7665D-05,0.9997D-06,-.2953D-13/

       DATA (XQDUM (I, 5,1),I=1, 76) /

     +-.2316D+04,-.1583D+04,-.1010D+04,-.5591D+03,-.2133D+03,0.4804D+02,
     +0.2414D+03,0.3800D+03,0.4755D+03,0.5367D+03,0.5712D+03,0.5850D+03,
     +0.5832D+03,0.5698D+03,0.5480D+03,0.5205D+03,0.4892D+03,0.4559D+03,
     +0.4216D+03,0.3872D+03,0.3537D+03,0.3214D+03,0.2905D+03,0.2617D+03,
     +0.2348D+03,0.2097D+03,0.1867D+03,0.1657D+03,0.1466D+03,0.1294D+03,
     +0.1138D+03,0.9988D+02,0.8743D+02,0.7630D+02,0.6643D+02,0.5770D+02,
     +0.4999D+02,0.4322D+02,0.3728D+02,0.3206D+02,0.2752D+02,0.2356D+02,
     +0.2011D+02,0.1712D+02,0.1453D+02,0.1231D+02,0.1038D+02,0.8714D+01,
     +0.7280D+01,0.6057D+01,0.5002D+01,0.4100D+01,0.3332D+01,0.2677D+01,
     +0.2121D+01,0.1652D+01,0.1258D+01,0.9338D+00,0.6686D+00,0.4566D+00,
     +0.3526D+00,0.2693D+00,0.2031D+00,0.1506D+00,0.1096D+00,0.7763D-01,
     +0.5338D-01,0.3527D-01,0.2210D-01,0.1293D-01,0.6847D-02,0.3134D-02,
     +0.1117D-02,0.2434D-03,0.5170D-04,0.7368D-11/

       DATA (XQDUM (I, 5,2),I=1, 76) /

     +-.2225D+04,-.1623D+04,-.1145D+04,-.7596D+03,-.4562D+03,-.2193D+03,
     +-.3661D+02,0.1018D+03,0.2047D+03,0.2787D+03,0.3297D+03,0.3623D+03,
     +0.3805D+03,0.3876D+03,0.3861D+03,0.3781D+03,0.3654D+03,0.3493D+03,
     +0.3310D+03,0.3113D+03,0.2909D+03,0.2703D+03,0.2498D+03,0.2301D+03,
     +0.2110D+03,0.1927D+03,0.1754D+03,0.1592D+03,0.1441D+03,0.1300D+03,
     +0.1170D+03,0.1050D+03,0.9396D+02,0.8383D+02,0.7459D+02,0.6618D+02,
     +0.5854D+02,0.5162D+02,0.4536D+02,0.3970D+02,0.3462D+02,0.3005D+02,
     +0.2597D+02,0.2232D+02,0.1907D+02,0.1621D+02,0.1367D+02,0.1143D+02,
     +0.9477D+01,0.7788D+01,0.6324D+01,0.5072D+01,0.4014D+01,0.3128D+01,
     +0.2395D+01,0.1799D+01,0.1323D+01,0.9509D+00,0.6666D+00,0.4548D+00,
     +0.3566D+00,0.2806D+00,0.2217D+00,0.1755D+00,0.1390D+00,0.1097D+00,
     +0.8618D-01,0.6696D-01,0.5108D-01,0.3795D-01,0.2700D-01,0.1797D-01,
     +0.1062D-01,0.4929D-02,0.2269D-02,0.4731D-06/

       DATA (XQDUM (I, 5,3),I=1, 76) /

     +-.2847D+04,-.2195D+04,-.1671D+04,-.1244D+04,-.9013D+03,-.6284D+03,
     +-.4126D+03,-.2436D+03,-.1125D+03,-.1258D+02,0.6248D+02,0.1172D+03,
     +0.1558D+03,0.1817D+03,0.1976D+03,0.2056D+03,0.2077D+03,0.2052D+03,
     +0.1994D+03,0.1913D+03,0.1815D+03,0.1707D+03,0.1593D+03,0.1478D+03,
     +0.1364D+03,0.1252D+03,0.1144D+03,0.1042D+03,0.9451D+02,0.8549D+02,
     +0.7706D+02,0.6929D+02,0.6215D+02,0.5558D+02,0.4959D+02,0.4415D+02,
     +0.3921D+02,0.3475D+02,0.3072D+02,0.2709D+02,0.2383D+02,0.2091D+02,
     +0.1829D+02,0.1595D+02,0.1386D+02,0.1201D+02,0.1036D+02,0.8893D+01,
     +0.7588D+01,0.6443D+01,0.5426D+01,0.4532D+01,0.3750D+01,0.3067D+01,
     +0.2472D+01,0.1959D+01,0.1519D+01,0.1148D+01,0.8392D+00,0.5864D+00,
     +0.4600D+00,0.3571D+00,0.2741D+00,0.2071D+00,0.1537D+00,0.1114D+00,
     +0.7855D-01,0.5338D-01,0.3453D-01,0.2097D-01,0.1161D-01,0.5618D-02,
     +0.2154D-02,0.5212D-03,0.1225D-03,0.1411D-10/

       DATA (XQDUM (I, 5,4),I=1, 76) /

     +-.2225D+04,-.1623D+04,-.1145D+04,-.7596D+03,-.4562D+03,-.2193D+03,
     +-.3661D+02,0.1018D+03,0.2047D+03,0.2787D+03,0.3297D+03,0.3623D+03,
     +0.3805D+03,0.3876D+03,0.3861D+03,0.3781D+03,0.3654D+03,0.3493D+03,
     +0.3310D+03,0.3113D+03,0.2909D+03,0.2703D+03,0.2498D+03,0.2301D+03,
     +0.2110D+03,0.1927D+03,0.1754D+03,0.1592D+03,0.1441D+03,0.1300D+03,
     +0.1170D+03,0.1050D+03,0.9396D+02,0.8383D+02,0.7459D+02,0.6618D+02,
     +0.5854D+02,0.5162D+02,0.4536D+02,0.3970D+02,0.3462D+02,0.3005D+02,
     +0.2597D+02,0.2232D+02,0.1907D+02,0.1621D+02,0.1367D+02,0.1143D+02,
     +0.9477D+01,0.7788D+01,0.6324D+01,0.5072D+01,0.4014D+01,0.3128D+01,
     +0.2395D+01,0.1799D+01,0.1323D+01,0.9509D+00,0.6666D+00,0.4548D+00,
     +0.3566D+00,0.2806D+00,0.2217D+00,0.1755D+00,0.1390D+00,0.1097D+00,
     +0.8618D-01,0.6696D-01,0.5108D-01,0.3795D-01,0.2700D-01,0.1797D-01,
     +0.1062D-01,0.4929D-02,0.2269D-02,0.4731D-06/

       DATA (XQDUM (I, 5,5),I=1, 76) /

     +-.1117D+04,-.6313D+03,-.2563D+03,0.3479D+02,0.2539D+03,0.4152D+03,
     +0.5300D+03,0.6075D+03,0.6557D+03,0.6806D+03,0.6876D+03,0.6808D+03,
     +0.6638D+03,0.6393D+03,0.6095D+03,0.5762D+03,0.5409D+03,0.5047D+03,
     +0.4683D+03,0.4325D+03,0.3978D+03,0.3644D+03,0.3326D+03,0.3027D+03,
     +0.2747D+03,0.2485D+03,0.2241D+03,0.2017D+03,0.1810D+03,0.1621D+03,
     +0.1447D+03,0.1289D+03,0.1146D+03,0.1015D+03,0.8975D+02,0.7911D+02,
     +0.6952D+02,0.6091D+02,0.5319D+02,0.4627D+02,0.4009D+02,0.3459D+02,
     +0.2970D+02,0.2537D+02,0.2154D+02,0.1818D+02,0.1523D+02,0.1265D+02,
     +0.1040D+02,0.8475D+01,0.6813D+01,0.5401D+01,0.4213D+01,0.3223D+01,
     +0.2410D+01,0.1752D+01,0.1232D+01,0.8319D+00,0.5331D+00,0.3191D+00,
     +0.2249D+00,0.1560D+00,0.1063D+00,0.7066D-01,0.4576D-01,0.2859D-01,
     +0.1714D-01,0.9727D-02,0.5134D-02,0.2468D-02,0.1033D-02,0.3537D-03,
     +0.8527D-04,0.1009D-04,0.1062D-05,-.9674D-13/

       DATA (XQDUM (I, 5,6),I=1, 76) /

     +0.8295D+05,0.6960D+05,0.5849D+05,0.4908D+05,0.4120D+05,0.3459D+05,
     +0.2904D+05,0.2438D+05,0.2047D+05,0.1719D+05,0.1442D+05,0.1211D+05,
     +0.1016D+05,0.8528D+04,0.7155D+04,0.6002D+04,0.5034D+04,0.4222D+04,
     +0.3539D+04,0.2965D+04,0.2484D+04,0.2080D+04,0.1740D+04,0.1457D+04,
     +0.1218D+04,0.1018D+04,0.8493D+03,0.7087D+03,0.5906D+03,0.4920D+03,
     +0.4090D+03,0.3398D+03,0.2820D+03,0.2335D+03,0.1931D+03,0.1594D+03,
     +0.1313D+03,0.1079D+03,0.8844D+02,0.7226D+02,0.5886D+02,0.4777D+02,
     +0.3862D+02,0.3107D+02,0.2486D+02,0.1980D+02,0.1565D+02,0.1228D+02,
     +0.9546D+01,0.7360D+01,0.5603D+01,0.4210D+01,0.3117D+01,0.2266D+01,
     +0.1612D+01,0.1118D+01,0.7502D+00,0.4850D+00,0.2983D+00,0.1720D+00,
     +0.1188D+00,0.8089D-01,0.5430D-01,0.3567D-01,0.2288D-01,0.1420D-01,
     +0.8481D-02,0.4814D-02,0.2551D-02,0.1237D-02,0.5266D-03,0.1853D-03,
     +0.4690D-04,0.6168D-05,0.7796D-06,-.2283D-13/

       DATA (XQDUM (I, 6,1),I=1, 76) /

     +0.3195D+03,0.7669D+03,0.1080D+04,0.1293D+04,0.1423D+04,0.1491D+04,
     +0.1510D+04,0.1492D+04,0.1448D+04,0.1385D+04,0.1310D+04,0.1226D+04,
     +0.1139D+04,0.1050D+04,0.9622D+03,0.8767D+03,0.7949D+03,0.7176D+03,
     +0.6451D+03,0.5776D+03,0.5154D+03,0.4584D+03,0.4062D+03,0.3592D+03,
     +0.3168D+03,0.2784D+03,0.2440D+03,0.2134D+03,0.1861D+03,0.1619D+03,
     +0.1405D+03,0.1217D+03,0.1052D+03,0.9061D+02,0.7790D+02,0.6682D+02,
     +0.5717D+02,0.4881D+02,0.4156D+02,0.3529D+02,0.2989D+02,0.2524D+02,
     +0.2126D+02,0.1784D+02,0.1492D+02,0.1244D+02,0.1032D+02,0.8526D+01,
     +0.6998D+01,0.5716D+01,0.4629D+01,0.3716D+01,0.2954D+01,0.2319D+01,
     +0.1792D+01,0.1358D+01,0.1005D+01,0.7229D+00,0.5000D+00,0.3285D+00,
     +0.2472D+00,0.1839D+00,0.1350D+00,0.9734D-01,0.6875D-01,0.4722D-01,
     +0.3141D-01,0.2002D-01,0.1205D-01,0.6743D-02,0.3390D-02,0.1459D-02,
     +0.4809D-03,0.9393D-04,0.1804D-04,0.1907D-11/

       DATA (XQDUM (I, 6,2),I=1, 76) /

     +-.1644D+04,-.1060D+04,-.6063D+03,-.2522D+03,0.1674D+02,0.2176D+03,
     +0.3638D+03,0.4663D+03,0.5345D+03,0.5754D+03,0.5953D+03,0.5990D+03,
     +0.5905D+03,0.5731D+03,0.5494D+03,0.5213D+03,0.4905D+03,0.4582D+03,
     +0.4255D+03,0.3929D+03,0.3612D+03,0.3307D+03,0.3014D+03,0.2740D+03,
     +0.2483D+03,0.2242D+03,0.2019D+03,0.1814D+03,0.1625D+03,0.1453D+03,
     +0.1295D+03,0.1152D+03,0.1022D+03,0.9044D+02,0.7982D+02,0.7026D+02,
     +0.6166D+02,0.5396D+02,0.4705D+02,0.4088D+02,0.3538D+02,0.3049D+02,
     +0.2615D+02,0.2232D+02,0.1893D+02,0.1597D+02,0.1336D+02,0.1110D+02,
     +0.9127D+01,0.7443D+01,0.5996D+01,0.4771D+01,0.3745D+01,0.2894D+01,
     +0.2197D+01,0.1635D+01,0.1191D+01,0.8484D+00,0.5889D+00,0.3976D+00,
     +0.3096D+00,0.2419D+00,0.1897D+00,0.1488D+00,0.1168D+00,0.9127D-01,
     +0.7086D-01,0.5432D-01,0.4080D-01,0.2976D-01,0.2070D-01,0.1340D-01,
     +0.7625D-02,0.3348D-02,0.1456D-02,0.1615D-06/

       DATA (XQDUM (I, 6,3),I=1, 76) /

     +-.2278D+04,-.1642D+04,-.1142D+04,-.7448D+03,-.4359D+03,-.1982D+03,
     +-.1802D+02,0.1158D+03,0.2128D+03,0.2803D+03,0.3248D+03,0.3511D+03,
     +0.3636D+03,0.3654D+03,0.3594D+03,0.3476D+03,0.3319D+03,0.3135D+03,
     +0.2936D+03,0.2728D+03,0.2519D+03,0.2313D+03,0.2113D+03,0.1923D+03,
     +0.1743D+03,0.1574D+03,0.1417D+03,0.1272D+03,0.1138D+03,0.1016D+03,
     +0.9051D+02,0.8043D+02,0.7134D+02,0.6312D+02,0.5573D+02,0.4911D+02,
     +0.4319D+02,0.3790D+02,0.3320D+02,0.2900D+02,0.2528D+02,0.2198D+02,
     +0.1906D+02,0.1647D+02,0.1419D+02,0.1219D+02,0.1042D+02,0.8861D+01,
     +0.7493D+01,0.6303D+01,0.5258D+01,0.4350D+01,0.3563D+01,0.2883D+01,
     +0.2298D+01,0.1800D+01,0.1378D+01,0.1028D+01,0.7394D+00,0.5079D+00,
     +0.3940D+00,0.3023D+00,0.2293D+00,0.1711D+00,0.1253D+00,0.8955D-01,
     +0.6217D-01,0.4156D-01,0.2639D-01,0.1570D-01,0.8483D-02,0.3984D-02,
     +0.1469D-02,0.3359D-03,0.7452D-04,0.4558D-11/

       DATA (XQDUM (I, 6,4),I=1, 76) /

     +-.1644D+04,-.1060D+04,-.6063D+03,-.2522D+03,0.1674D+02,0.2176D+03,
     +0.3638D+03,0.4663D+03,0.5345D+03,0.5754D+03,0.5953D+03,0.5990D+03,
     +0.5905D+03,0.5731D+03,0.5494D+03,0.5213D+03,0.4905D+03,0.4582D+03,
     +0.4255D+03,0.3929D+03,0.3612D+03,0.3307D+03,0.3014D+03,0.2740D+03,
     +0.2483D+03,0.2242D+03,0.2019D+03,0.1814D+03,0.1625D+03,0.1453D+03,
     +0.1295D+03,0.1152D+03,0.1022D+03,0.9044D+02,0.7982D+02,0.7026D+02,
     +0.6166D+02,0.5396D+02,0.4705D+02,0.4088D+02,0.3538D+02,0.3049D+02,
     +0.2615D+02,0.2232D+02,0.1893D+02,0.1597D+02,0.1336D+02,0.1110D+02,
     +0.9127D+01,0.7443D+01,0.5996D+01,0.4771D+01,0.3745D+01,0.2894D+01,
     +0.2197D+01,0.1635D+01,0.1191D+01,0.8484D+00,0.5889D+00,0.3976D+00,
     +0.3096D+00,0.2419D+00,0.1897D+00,0.1488D+00,0.1168D+00,0.9127D-01,
     +0.7086D-01,0.5432D-01,0.4080D-01,0.2976D-01,0.2070D-01,0.1340D-01,
     +0.7625D-02,0.3348D-02,0.1456D-02,0.1615D-06/

       DATA (XQDUM (I, 6,5),I=1, 76) /

     +-.5466D+03,-.7789D+02,0.2723D+03,0.5329D+03,0.7181D+03,0.8439D+03,
     +0.9227D+03,0.9648D+03,0.9786D+03,0.9710D+03,0.9472D+03,0.9119D+03,
     +0.8686D+03,0.8200D+03,0.7683D+03,0.7152D+03,0.6621D+03,0.6100D+03,
     +0.5595D+03,0.5111D+03,0.4652D+03,0.4221D+03,0.3817D+03,0.3445D+03,
     +0.3100D+03,0.2781D+03,0.2489D+03,0.2223D+03,0.1980D+03,0.1760D+03,
     +0.1561D+03,0.1381D+03,0.1219D+03,0.1073D+03,0.9420D+02,0.8249D+02,
     +0.7202D+02,0.6269D+02,0.5439D+02,0.4701D+02,0.4047D+02,0.3469D+02,
     +0.2959D+02,0.2511D+02,0.2117D+02,0.1775D+02,0.1476D+02,0.1217D+02,
     +0.9934D+01,0.8031D+01,0.6404D+01,0.5033D+01,0.3891D+01,0.2949D+01,
     +0.2182D+01,0.1569D+01,0.1090D+01,0.7266D+00,0.4588D+00,0.2702D+00,
     +0.1883D+00,0.1291D+00,0.8691D-01,0.5708D-01,0.3648D-01,0.2247D-01,
     +0.1326D-01,0.7405D-02,0.3836D-02,0.1805D-02,0.7372D-03,0.2447D-03,
     +0.5666D-04,0.6308D-05,0.6219D-06,-.3629D-13/

       DATA (XQDUM (I, 6,6),I=1, 76) /

     +0.7883D+05,0.6622D+05,0.5572D+05,0.4681D+05,0.3934D+05,0.3307D+05,
     +0.2780D+05,0.2337D+05,0.1964D+05,0.1651D+05,0.1387D+05,0.1166D+05,
     +0.9798D+04,0.8231D+04,0.6913D+04,0.5805D+04,0.4874D+04,0.4092D+04,
     +0.3433D+04,0.2879D+04,0.2414D+04,0.2023D+04,0.1693D+04,0.1418D+04,
     +0.1187D+04,0.9916D+03,0.8277D+03,0.6908D+03,0.5757D+03,0.4796D+03,
     +0.3986D+03,0.3311D+03,0.2747D+03,0.2273D+03,0.1878D+03,0.1549D+03,
     +0.1274D+03,0.1046D+03,0.8559D+02,0.6981D+02,0.5676D+02,0.4597D+02,
     +0.3707D+02,0.2975D+02,0.2373D+02,0.1884D+02,0.1484D+02,0.1160D+02,
     +0.8978D+01,0.6891D+01,0.5218D+01,0.3899D+01,0.2869D+01,0.2071D+01,
     +0.1462D+01,0.1005D+01,0.6681D+00,0.4272D+00,0.2594D+00,0.1474D+00,
     +0.1007D+00,0.6789D-01,0.4506D-01,0.2925D-01,0.1852D-01,0.1134D-01,
     +0.6671D-02,0.3724D-02,0.1936D-02,0.9192D-03,0.3814D-03,0.1300D-03,
     +0.3159D-04,0.3909D-05,0.4642D-06,-.1123D-13/

       DATA (XQDUM (I, 7,1),I=1, 76) /

     +0.1606D+04,0.1898D+04,0.2074D+04,0.2162D+04,0.2182D+04,0.2151D+04,
     +0.2084D+04,0.1990D+04,0.1879D+04,0.1758D+04,0.1630D+04,0.1502D+04,
     +0.1375D+04,0.1253D+04,0.1135D+04,0.1024D+04,0.9200D+03,0.8237D+03,
     +0.7348D+03,0.6532D+03,0.5791D+03,0.5118D+03,0.4508D+03,0.3965D+03,
     +0.3477D+03,0.3040D+03,0.2651D+03,0.2307D+03,0.2003D+03,0.1735D+03,
     +0.1499D+03,0.1292D+03,0.1112D+03,0.9537D+02,0.8164D+02,0.6972D+02,
     +0.5940D+02,0.5048D+02,0.4280D+02,0.3617D+02,0.3050D+02,0.2564D+02,
     +0.2148D+02,0.1794D+02,0.1492D+02,0.1237D+02,0.1021D+02,0.8379D+01,
     +0.6833D+01,0.5544D+01,0.4457D+01,0.3552D+01,0.2800D+01,0.2179D+01,
     +0.1668D+01,0.1252D+01,0.9168D+00,0.6515D+00,0.4447D+00,0.2879D+00,
     +0.2146D+00,0.1581D+00,0.1149D+00,0.8194D-01,0.5723D-01,0.3885D-01,
     +0.2552D-01,0.1604D-01,0.9515D-02,0.5237D-02,0.2583D-02,0.1086D-02,
     +0.3481D-03,0.6543D-04,0.1216D-04,0.1168D-11/

       DATA (XQDUM (I, 7,2),I=1, 76) /

     +-.1250D+04,-.6986D+03,-.2776D+03,0.4502D+02,0.2842D+03,0.4572D+03,
     +0.5775D+03,0.6561D+03,0.7024D+03,0.7234D+03,0.7253D+03,0.7129D+03,
     +0.6900D+03,0.6597D+03,0.6245D+03,0.5862D+03,0.5465D+03,0.5064D+03,
     +0.4668D+03,0.4282D+03,0.3912D+03,0.3561D+03,0.3229D+03,0.2922D+03,
     +0.2635D+03,0.2369D+03,0.2125D+03,0.1902D+03,0.1697D+03,0.1512D+03,
     +0.1343D+03,0.1190D+03,0.1053D+03,0.9286D+02,0.8170D+02,0.7169D+02,
     +0.6273D+02,0.5473D+02,0.4759D+02,0.4123D+02,0.3558D+02,0.3058D+02,
     +0.2616D+02,0.2225D+02,0.1882D+02,0.1583D+02,0.1321D+02,0.1094D+02,
     +0.8973D+01,0.7296D+01,0.5860D+01,0.4649D+01,0.3638D+01,0.2802D+01,
     +0.2120D+01,0.1573D+01,0.1142D+01,0.8104D+00,0.5604D+00,0.3768D+00,
     +0.2927D+00,0.2280D+00,0.1783D+00,0.1395D+00,0.1091D+00,0.8490D-01,
     +0.6562D-01,0.5005D-01,0.3736D-01,0.2706D-01,0.1866D-01,0.1195D-01,
     +0.6704D-02,0.2882D-02,0.1226D-02,0.1067D-06/

       DATA (XQDUM (I, 7,3),I=1, 76) /

     +-.1888D+04,-.1285D+04,-.8172D+03,-.4507D+03,-.1712D+03,0.3897D+02,
     +0.1935D+03,0.3038D+03,0.3792D+03,0.4271D+03,0.4537D+03,0.4641D+03,
     +0.4622D+03,0.4513D+03,0.4340D+03,0.4122D+03,0.3877D+03,0.3615D+03,
     +0.3348D+03,0.3081D+03,0.2820D+03,0.2569D+03,0.2330D+03,0.2107D+03,
     +0.1898D+03,0.1704D+03,0.1526D+03,0.1363D+03,0.1214D+03,0.1079D+03,
     +0.9566D+02,0.8465D+02,0.7478D+02,0.6590D+02,0.5796D+02,0.5089D+02,
     +0.4459D+02,0.3899D+02,0.3403D+02,0.2963D+02,0.2574D+02,0.2230D+02,
     +0.1928D+02,0.1661D+02,0.1426D+02,0.1221D+02,0.1040D+02,0.8817D+01,
     +0.7431D+01,0.6230D+01,0.5179D+01,0.4269D+01,0.3483D+01,0.2807D+01,
     +0.2229D+01,0.1738D+01,0.1324D+01,0.9823D+00,0.7029D+00,0.4798D+00,
     +0.3705D+00,0.2831D+00,0.2137D+00,0.1587D+00,0.1157D+00,0.8221D-01,
     +0.5675D-01,0.3769D-01,0.2377D-01,0.1403D-01,0.7510D-02,0.3487D-02,
     +0.1267D-02,0.2834D-03,0.6150D-04,0.2950D-11/

       DATA (XQDUM (I, 7,4),I=1, 76) /

     +-.1250D+04,-.6986D+03,-.2776D+03,0.4502D+02,0.2842D+03,0.4572D+03,
     +0.5775D+03,0.6561D+03,0.7024D+03,0.7234D+03,0.7253D+03,0.7129D+03,
     +0.6900D+03,0.6597D+03,0.6245D+03,0.5862D+03,0.5465D+03,0.5064D+03,
     +0.4668D+03,0.4282D+03,0.3912D+03,0.3561D+03,0.3229D+03,0.2922D+03,
     +0.2635D+03,0.2369D+03,0.2125D+03,0.1902D+03,0.1697D+03,0.1512D+03,
     +0.1343D+03,0.1190D+03,0.1053D+03,0.9286D+02,0.8170D+02,0.7169D+02,
     +0.6273D+02,0.5473D+02,0.4759D+02,0.4123D+02,0.3558D+02,0.3058D+02,
     +0.2616D+02,0.2225D+02,0.1882D+02,0.1583D+02,0.1321D+02,0.1094D+02,
     +0.8973D+01,0.7296D+01,0.5860D+01,0.4649D+01,0.3638D+01,0.2802D+01,
     +0.2120D+01,0.1573D+01,0.1142D+01,0.8104D+00,0.5604D+00,0.3768D+00,
     +0.2927D+00,0.2280D+00,0.1783D+00,0.1395D+00,0.1091D+00,0.8490D-01,
     +0.6562D-01,0.5005D-01,0.3736D-01,0.2706D-01,0.1866D-01,0.1195D-01,
     +0.6704D-02,0.2882D-02,0.1226D-02,0.1067D-06/

       DATA (XQDUM (I, 7,5),I=1, 76) /

     +-.1569D+03,0.2789D+03,0.5971D+03,0.8265D+03,0.9822D+03,0.1080D+04,
     +0.1133D+04,0.1152D+04,0.1144D+04,0.1117D+04,0.1075D+04,0.1024D+04,
     +0.9661D+03,0.9046D+03,0.8416D+03,0.7785D+03,0.7165D+03,0.6567D+03,
     +0.5994D+03,0.5451D+03,0.4941D+03,0.4466D+03,0.4023D+03,0.3617D+03,
     +0.3244D+03,0.2901D+03,0.2588D+03,0.2304D+03,0.2046D+03,0.1814D+03,
     +0.1604D+03,0.1415D+03,0.1246D+03,0.1094D+03,0.9577D+02,0.8365D+02,
     +0.7285D+02,0.6326D+02,0.5474D+02,0.4719D+02,0.4052D+02,0.3465D+02,
     +0.2948D+02,0.2495D+02,0.2098D+02,0.1755D+02,0.1455D+02,0.1197D+02,
     +0.9738D+01,0.7849D+01,0.6239D+01,0.4888D+01,0.3766D+01,0.2843D+01,
     +0.2096D+01,0.1501D+01,0.1038D+01,0.6882D+00,0.4322D+00,0.2529D+00,
     +0.1755D+00,0.1198D+00,0.8027D-01,0.5247D-01,0.3336D-01,0.2044D-01,
     +0.1199D-01,0.6653D-02,0.3422D-02,0.1597D-02,0.6461D-03,0.2119D-03,
     +0.4832D-04,0.5256D-05,0.5053D-06,-.2475D-13/

       DATA (XQDUM (I, 7,6),I=1, 76) /

     +0.7748D+05,0.6512D+05,0.5482D+05,0.4607D+05,0.3874D+05,0.3258D+05,
     +0.2740D+05,0.2305D+05,0.1938D+05,0.1630D+05,0.1370D+05,0.1152D+05,
     +0.9684D+04,0.8138D+04,0.6838D+04,0.5744D+04,0.4824D+04,0.4051D+04,
     +0.3400D+04,0.2852D+04,0.2392D+04,0.2005D+04,0.1678D+04,0.1406D+04,
     +0.1176D+04,0.9830D+03,0.8206D+03,0.6848D+03,0.5707D+03,0.4753D+03,
     +0.3950D+03,0.3280D+03,0.2720D+03,0.2250D+03,0.1858D+03,0.1532D+03,
     +0.1259D+03,0.1033D+03,0.8448D+02,0.6885D+02,0.5593D+02,0.4525D+02,
     +0.3646D+02,0.2922D+02,0.2328D+02,0.1846D+02,0.1452D+02,0.1133D+02,
     +0.8753D+01,0.6705D+01,0.5067D+01,0.3777D+01,0.2772D+01,0.1996D+01,
     +0.1405D+01,0.9620D+00,0.6370D+00,0.4055D+00,0.2451D+00,0.1384D+00,
     +0.9423D-01,0.6324D-01,0.4179D-01,0.2700D-01,0.1702D-01,0.1036D-01,
     +0.6060D-02,0.3361D-02,0.1735D-02,0.8169D-03,0.3357D-03,0.1131D-03,
     +0.2705D-04,0.3271D-05,0.3794D-06,-.8228D-14/

       DATA (XQDUM (I, 8,1),I=1, 76) /

     +0.4765D+04,0.4649D+04,0.4467D+04,0.4238D+04,0.3979D+04,0.3704D+04,
     +0.3422D+04,0.3142D+04,0.2868D+04,0.2605D+04,0.2354D+04,0.2120D+04,
     +0.1901D+04,0.1699D+04,0.1513D+04,0.1344D+04,0.1190D+04,0.1051D+04,
     +0.9252D+03,0.8126D+03,0.7120D+03,0.6224D+03,0.5425D+03,0.4722D+03,
     +0.4101D+03,0.3551D+03,0.3068D+03,0.2647D+03,0.2277D+03,0.1956D+03,
     +0.1675D+03,0.1432D+03,0.1222D+03,0.1039D+03,0.8821D+02,0.7470D+02,
     +0.6310D+02,0.5317D+02,0.4468D+02,0.3742D+02,0.3126D+02,0.2603D+02,
     +0.2160D+02,0.1785D+02,0.1469D+02,0.1205D+02,0.9828D+01,0.7968D+01,
     +0.6415D+01,0.5134D+01,0.4068D+01,0.3192D+01,0.2475D+01,0.1892D+01,
     +0.1421D+01,0.1045D+01,0.7483D+00,0.5189D+00,0.3448D+00,0.2166D+00,
     +0.1582D+00,0.1142D+00,0.8123D-01,0.5668D-01,0.3869D-01,0.2563D-01,
     +0.1641D-01,0.1003D-01,0.5770D-02,0.3069D-02,0.1456D-02,0.5854D-03,
     +0.1774D-03,0.3105D-04,0.5450D-05,0.4247D-12/

       DATA (XQDUM (I, 8,2),I=1, 76) /

     +-.1171D+03,0.3146D+03,0.6259D+03,0.8468D+03,0.9935D+03,0.1082D+04,
     +0.1127D+04,0.1138D+04,0.1123D+04,0.1090D+04,0.1044D+04,0.9887D+03,
     +0.9283D+03,0.8651D+03,0.8009D+03,0.7374D+03,0.6757D+03,0.6165D+03,
     +0.5604D+03,0.5075D+03,0.4582D+03,0.4125D+03,0.3702D+03,0.3316D+03,
     +0.2964D+03,0.2642D+03,0.2349D+03,0.2085D+03,0.1847D+03,0.1633D+03,
     +0.1440D+03,0.1268D+03,0.1114D+03,0.9758D+02,0.8530D+02,0.7439D+02,
     +0.6469D+02,0.5610D+02,0.4849D+02,0.4176D+02,0.3583D+02,0.3061D+02,
     +0.2604D+02,0.2202D+02,0.1852D+02,0.1549D+02,0.1285D+02,0.1058D+02,
     +0.8623D+01,0.6969D+01,0.5563D+01,0.4385D+01,0.3409D+01,0.2609D+01,
     +0.1961D+01,0.1445D+01,0.1041D+01,0.7335D+00,0.5034D+00,0.3357D+00,
     +0.2593D+00,0.2009D+00,0.1561D+00,0.1213D+00,0.9421D-01,0.7273D-01,
     +0.5569D-01,0.4202D-01,0.3097D-01,0.2210D-01,0.1497D-01,0.9370D-02,
     +0.5100D-02,0.2096D-02,0.8515D-03,0.4452D-07/

       DATA (XQDUM (I, 8,3),I=1, 76) /

     +-.7646D+03,-.2804D+03,0.7899D+02,0.3446D+03,0.5324D+03,0.6593D+03,
     +0.7387D+03,0.7816D+03,0.7967D+03,0.7909D+03,0.7698D+03,0.7381D+03,
     +0.6991D+03,0.6556D+03,0.6096D+03,0.5628D+03,0.5165D+03,0.4715D+03,
     +0.4284D+03,0.3875D+03,0.3492D+03,0.3137D+03,0.2807D+03,0.2508D+03,
     +0.2234D+03,0.1984D+03,0.1757D+03,0.1554D+03,0.1372D+03,0.1208D+03,
     +0.1062D+03,0.9322D+02,0.8168D+02,0.7141D+02,0.6234D+02,0.5433D+02,
     +0.4725D+02,0.4103D+02,0.3556D+02,0.3075D+02,0.2653D+02,0.2284D+02,
     +0.1961D+02,0.1678D+02,0.1431D+02,0.1217D+02,0.1030D+02,0.8675D+01,
     +0.7261D+01,0.6046D+01,0.4990D+01,0.4083D+01,0.3306D+01,0.2644D+01,
     +0.2081D+01,0.1608D+01,0.1213D+01,0.8906D+00,0.6298D+00,0.4242D+00,
     +0.3247D+00,0.2458D+00,0.1838D+00,0.1352D+00,0.9750D-01,0.6853D-01,
     +0.4674D-01,0.3064D-01,0.1904D-01,0.1105D-01,0.5801D-02,0.2630D-02,
     +0.9265D-03,0.1979D-03,0.4100D-04,0.1179D-11/

       DATA (XQDUM (I, 8,4),I=1, 76) /

     +-.1171D+03,0.3146D+03,0.6259D+03,0.8468D+03,0.9935D+03,0.1082D+04,
     +0.1127D+04,0.1138D+04,0.1123D+04,0.1090D+04,0.1044D+04,0.9887D+03,
     +0.9283D+03,0.8651D+03,0.8009D+03,0.7374D+03,0.6757D+03,0.6165D+03,
     +0.5604D+03,0.5075D+03,0.4582D+03,0.4125D+03,0.3702D+03,0.3316D+03,
     +0.2964D+03,0.2642D+03,0.2349D+03,0.2085D+03,0.1847D+03,0.1633D+03,
     +0.1440D+03,0.1268D+03,0.1114D+03,0.9758D+02,0.8530D+02,0.7439D+02,
     +0.6469D+02,0.5610D+02,0.4849D+02,0.4176D+02,0.3583D+02,0.3061D+02,
     +0.2604D+02,0.2202D+02,0.1852D+02,0.1549D+02,0.1285D+02,0.1058D+02,
     +0.8623D+01,0.6969D+01,0.5563D+01,0.4385D+01,0.3409D+01,0.2609D+01,
     +0.1961D+01,0.1445D+01,0.1041D+01,0.7335D+00,0.5034D+00,0.3357D+00,
     +0.2593D+00,0.2009D+00,0.1561D+00,0.1213D+00,0.9421D-01,0.7273D-01,
     +0.5569D-01,0.4202D-01,0.3097D-01,0.2210D-01,0.1497D-01,0.9370D-02,
     +0.5100D-02,0.2096D-02,0.8515D-03,0.4452D-07/

       DATA (XQDUM (I, 8,5),I=1, 76) /

     +0.9663D+03,0.1283D+04,0.1492D+04,0.1620D+04,0.1684D+04,0.1698D+04,
     +0.1676D+04,0.1627D+04,0.1559D+04,0.1478D+04,0.1388D+04,0.1295D+04,
     +0.1200D+04,0.1106D+04,0.1014D+04,0.9261D+03,0.8425D+03,0.7638D+03,
     +0.6902D+03,0.6218D+03,0.5587D+03,0.5007D+03,0.4475D+03,0.3994D+03,
     +0.3556D+03,0.3157D+03,0.2798D+03,0.2475D+03,0.2184D+03,0.1925D+03,
     +0.1691D+03,0.1484D+03,0.1299D+03,0.1134D+03,0.9876D+02,0.8580D+02,
     +0.7432D+02,0.6419D+02,0.5526D+02,0.4738D+02,0.4048D+02,0.3443D+02,
     +0.2914D+02,0.2453D+02,0.2051D+02,0.1706D+02,0.1407D+02,0.1150D+02,
     +0.9303D+01,0.7452D+01,0.5885D+01,0.4579D+01,0.3502D+01,0.2624D+01,
     +0.1918D+01,0.1362D+01,0.9325D+00,0.6119D+00,0.3798D+00,0.2193D+00,
     +0.1508D+00,0.1020D+00,0.6769D-01,0.4380D-01,0.2755D-01,0.1669D-01,
     +0.9675D-02,0.5295D-02,0.2682D-02,0.1231D-02,0.4879D-03,0.1562D-03,
     +0.3447D-04,0.3571D-05,0.3257D-06,-.1096D-13/

       DATA (XQDUM (I, 8,6),I=1, 76) /

     +0.7506D+05,0.6314D+05,0.5321D+05,0.4477D+05,0.3768D+05,0.3172D+05,
     +0.2670D+05,0.2248D+05,0.1892D+05,0.1593D+05,0.1340D+05,0.1127D+05,
     +0.9487D+04,0.7978D+04,0.6708D+04,0.5638D+04,0.4738D+04,0.3980D+04,
     +0.3342D+04,0.2804D+04,0.2352D+04,0.1972D+04,0.1651D+04,0.1383D+04,
     +0.1157D+04,0.9670D+03,0.8070D+03,0.6733D+03,0.5608D+03,0.4667D+03,
     +0.3877D+03,0.3216D+03,0.2665D+03,0.2202D+03,0.1817D+03,0.1495D+03,
     +0.1228D+03,0.1005D+03,0.8210D+02,0.6678D+02,0.5414D+02,0.4371D+02,
     +0.3512D+02,0.2808D+02,0.2231D+02,0.1763D+02,0.1382D+02,0.1075D+02,
     +0.8271D+01,0.6308D+01,0.4745D+01,0.3520D+01,0.2569D+01,0.1839D+01,
     +0.1285D+01,0.8737D+00,0.5738D+00,0.3619D+00,0.2164D+00,0.1207D+00,
     +0.8148D-01,0.5420D-01,0.3549D-01,0.2271D-01,0.1416D-01,0.8525D-02,
     +0.4926D-02,0.2695D-02,0.1371D-02,0.6343D-03,0.2554D-03,0.8394D-04,
     +0.1943D-04,0.2240D-05,0.2474D-06,-.4097D-14/



      data xmin/1.e-03/,xmax/.99/
      data istep/0/
      save
      if(istep.eq.0) then
      do  i=1,ix
        x(i)=log10(xco(i))
      enddo
      do  i=1,iq
        y(i)=log(q2(i))
      enddo
        istep=1
      endif
      if (strfun(1:2) .eq. 'up' ) then
        ifun =3
      else if (strfun(1:2) .eq. 'do') then
        ifun =2
      else if (strfun(1:2) .eq. 'gl') then
        ifun =1
      else if (strfun(1:2) .eq. 'sb') then
        ifun =4
      else if (strfun(1:2) .eq. 'cb') then
        ifun =5
      else if (strfun(1:2) .eq. 'bb') then
        ifun =6
      endif
      do i=1,ix
        do j=1,iq
          f(i,j)=xqdum(i,j,ifun)
        enddo
      enddo
      func=0.
      if(z.gt.xmin.and.z.lt.xmax) then
      a=log10(z)
      b=log(qstar2)
      call locate(x,ix,a,jx)
      call locate(y,iq,b,jq)
      do ijx=1,igt
        if (jx.eq.1) then
          x1a(ijx)=x(jx+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.(ix-1)) then
          x1a(ijx)=x(jx-3+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.ix) then
          x1a(ijx)=x(jx-4+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-2+ijq)
            endif
          enddo
        else
          x1a(ijx)=x(jx-2+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-2+ijq)
            endif
          enddo
        endif
      enddo
      call dpolin2(x1a,x2a,ya,4,4,a,b,yy,dy)
      func = yy
      endif
      end
c
c------------------------------------------------------------
c------------- subroutine to compute a point in x and q**2 --
c------------- for the following fragmentation functions:  --
c-------------     gluon,  up   ,down,                     --
c-------------        strange , charm , bottom.            --
c------------- range of validity :                         --
c-------------                    1.e-03 < x < .99         --
c-------------                    2  < q**2 < 11900 GeV^2  --
c------------------------------------------------------------
c-------------        authors :    L. Bourhis
c-------------                     M. Fontannaz
c-------------                     J.Ph. Guillet
c-------------                     M. Werlen
c-------------    q02=2gev2         method p.nason
c-------------    next to leading evolution
c-------------    table pour la fragmentation en hadrons charges
*         i = 1    gluon
*         i = 2    down ( = antidown )
*         i = 3    up ( = antiup )
*         i = 4    strange ( = antistrange )
*         i = 5    charm ( = anticharm )
*         i = 6    bottom ( = antibottom )
* parametrisation of April 2000: formula (10) from the paper
c------------------------------------------------------------
      subroutine  fra_apr2000(z,qstar2,strfun,func)
      implicit real*8 (a-h,o-z)
c------------------------------------------------------------
c-------------   z is x and qstar2 is q square  -------------
      character*(*) strfun
c------------------------------------------------------------
c------------ strfun specifies the desired function----------
c------------------------------------------------------------
c------------------------------------------------------------
c        ifun =  1     gluon           'gl'
c                2     down            'do'
c                3     up              'up'
c                4     strange         'sb'
c                5     charm           'cb'
c                6     bottom          'bb'
c                7     top             'tb'
c------------------------------------------------------------
c-------------  func is the output (parton density value)----
c------------------------------------------------------------
      parameter (ix=76,iq=8,ig1=76,kfun=6)
      parameter (igt=4)
c------------------------------------------------------------
c-----------input tables are given as  33 x points at 7 q**2
c-----------positions
c------------------------------------------------------------
      dimension x(ix),y(iq),f(ix,iq)
      dimension d(ig1)
      dimension xqdum(ix,iq,kfun)
      dimension q2(iq),xco(ix)
      dimension x1a(igt),x2a(igt),ya(igt,igt)
c------------------------------------------------------------
c----------- next the 7 q**2 of the input tables are defined
****                                         q2fin= final scale (gev**2)
****                                         q2fin= final scale (gev**2)
      data q2 /2.,11.9,23.8,119.,238.,1190.,2380.,11900./
c------------------------------------------------------------
c----------------------------------------------------------------
c----------- and now the  76 x positions ------------------------
c----------------------------------------------------------------
 
      data xco   /
     +0.1115d-02,0.1237d-02,0.1371d-02,0.1521d-02,0.1687d-02,0.1871d-02,
     +0.2075d-02,0.2301d-02,0.2552d-02,0.2830d-02,0.3139d-02,0.3481d-02,
     +0.3860d-02,0.4281d-02,0.4748d-02,0.5266d-02,0.5840d-02,0.6476d-02,
     +0.7182d-02,0.7966d-02,0.8834d-02,0.9797d-02,0.1087d-01,0.1205d-01,
     +0.1336d-01,0.1482d-01,0.1644d-01,0.1823d-01,0.2022d-01,0.2242d-01,
     +0.2487d-01,0.2758d-01,0.3058d-01,0.3392d-01,0.3762d-01,0.4172d-01,
     +0.4627d-01,0.5131d-01,0.5690d-01,0.6311d-01,0.6999d-01,0.7762d-01,
     +0.8608d-01,0.9547d-01,0.1059d+00,0.1174d+00,0.1302d+00,0.1444d+00,
     +0.1602d+00,0.1776d+00,0.1970d+00,0.2185d+00,0.2423d+00,0.2687d+00,
     +0.2980d+00,0.3305d+00,0.3666d+00,0.4065d+00,0.4508d+00,0.5000d+00,
     +0.5321d+00,0.5643d+00,0.5964d+00,0.6286d+00,0.6607d+00,0.6929d+00,
     +0.7250d+00,0.7571d+00,0.7893d+00,0.8214d+00,0.8536d+00,0.8857d+00,
     +0.9179d+00,0.9500d+00,0.9700d+00,0.9999d+00/
 
       DATA (XQDUM (I, 1,1),I=1, 76) /

     +0.3586D+04,0.3169D+04,0.2804D+04,0.2477D+04,0.2190D+04,0.1936D+04,
     +0.1711D+04,0.1512D+04,0.1337D+04,0.1182D+04,0.1044D+04,0.9230D+03,
     +0.8159D+03,0.7210D+03,0.6371D+03,0.5630D+03,0.4975D+03,0.4396D+03,
     +0.3884D+03,0.3431D+03,0.3031D+03,0.2677D+03,0.2363D+03,0.2088D+03,
     +0.1844D+03,0.1627D+03,0.1436D+03,0.1267D+03,0.1118D+03,0.9865D+02,
     +0.8697D+02,0.7668D+02,0.6760D+02,0.5955D+02,0.5244D+02,0.4616D+02,
     +0.4062D+02,0.3572D+02,0.3139D+02,0.2757D+02,0.2419D+02,0.2121D+02,
     +0.1858D+02,0.1625D+02,0.1420D+02,0.1239D+02,0.1079D+02,0.9385D+01,
     +0.8138D+01,0.7046D+01,0.6078D+01,0.5227D+01,0.4478D+01,0.3819D+01,
     +0.3238D+01,0.2728D+01,0.2279D+01,0.1886D+01,0.1541D+01,0.1238D+01,
     +0.1074D+01,0.9313D+00,0.8064D+00,0.6959D+00,0.5981D+00,0.5105D+00,
     +0.4322D+00,0.3617D+00,0.2977D+00,0.2399D+00,0.1871D+00,0.1391D+00,
     +0.9513D-01,0.5506D-01,0.3190D-01,0.9150D-04/

       DATA (XQDUM (I, 1,2),I=1, 76) /

     +0.4336D+03,0.4063D+03,0.3808D+03,0.3568D+03,0.3342D+03,0.3131D+03,
     +0.2933D+03,0.2748D+03,0.2573D+03,0.2410D+03,0.2256D+03,0.2112D+03,
     +0.1977D+03,0.1851D+03,0.1732D+03,0.1620D+03,0.1515D+03,0.1417D+03,
     +0.1324D+03,0.1237D+03,0.1156D+03,0.1079D+03,0.1007D+03,0.9395D+02,
     +0.8760D+02,0.8161D+02,0.7597D+02,0.7068D+02,0.6569D+02,0.6102D+02,
     +0.5659D+02,0.5244D+02,0.4853D+02,0.4484D+02,0.4136D+02,0.3808D+02,
     +0.3499D+02,0.3208D+02,0.2934D+02,0.2675D+02,0.2432D+02,0.2203D+02,
     +0.1987D+02,0.1784D+02,0.1594D+02,0.1417D+02,0.1250D+02,0.1096D+02,
     +0.9518D+01,0.8200D+01,0.6984D+01,0.5878D+01,0.4881D+01,0.3991D+01,
     +0.3205D+01,0.2524D+01,0.1942D+01,0.1460D+01,0.1069D+01,0.7624D+00,
     +0.6148D+00,0.4981D+00,0.4063D+00,0.3333D+00,0.2753D+00,0.2285D+00,
     +0.1903D+00,0.1585D+00,0.1313D+00,0.1075D+00,0.8601D-01,0.6614D-01,
     +0.4725D-01,0.2900D-01,0.1772D-01,0.8218D-04/

       DATA (XQDUM (I, 1,3),I=1, 76) /

     +0.1941D+03,0.1819D+03,0.1706D+03,0.1599D+03,0.1498D+03,0.1404D+03,
     +0.1316D+03,0.1233D+03,0.1156D+03,0.1083D+03,0.1015D+03,0.9507D+02,
     +0.8907D+02,0.8344D+02,0.7815D+02,0.7320D+02,0.6855D+02,0.6419D+02,
     +0.6010D+02,0.5625D+02,0.5265D+02,0.4927D+02,0.4608D+02,0.4311D+02,
     +0.4031D+02,0.3768D+02,0.3520D+02,0.3289D+02,0.3070D+02,0.2866D+02,
     +0.2673D+02,0.2492D+02,0.2322D+02,0.2162D+02,0.2011D+02,0.1869D+02,
     +0.1735D+02,0.1610D+02,0.1491D+02,0.1379D+02,0.1274D+02,0.1174D+02,
     +0.1080D+02,0.9916D+01,0.9077D+01,0.8288D+01,0.7540D+01,0.6833D+01,
     +0.6162D+01,0.5533D+01,0.4936D+01,0.4373D+01,0.3843D+01,0.3345D+01,
     +0.2878D+01,0.2441D+01,0.2035D+01,0.1661D+01,0.1320D+01,0.1011D+01,
     +0.8433D+00,0.6968D+00,0.5702D+00,0.4605D+00,0.3665D+00,0.2861D+00,
     +0.2183D+00,0.1617D+00,0.1152D+00,0.7796D-01,0.4900D-01,0.2764D-01,
     +0.1294D-01,0.4192D-02,0.1322D-02,0.3730D-08/

       DATA (XQDUM (I, 1,4),I=1, 76) /

     +0.4336D+03,0.4063D+03,0.3808D+03,0.3568D+03,0.3342D+03,0.3131D+03,
     +0.2933D+03,0.2748D+03,0.2573D+03,0.2410D+03,0.2256D+03,0.2112D+03,
     +0.1977D+03,0.1851D+03,0.1732D+03,0.1620D+03,0.1515D+03,0.1417D+03,
     +0.1324D+03,0.1237D+03,0.1156D+03,0.1079D+03,0.1007D+03,0.9395D+02,
     +0.8760D+02,0.8161D+02,0.7597D+02,0.7068D+02,0.6569D+02,0.6102D+02,
     +0.5659D+02,0.5244D+02,0.4853D+02,0.4484D+02,0.4136D+02,0.3808D+02,
     +0.3499D+02,0.3208D+02,0.2934D+02,0.2675D+02,0.2432D+02,0.2203D+02,
     +0.1987D+02,0.1784D+02,0.1594D+02,0.1417D+02,0.1250D+02,0.1096D+02,
     +0.9518D+01,0.8200D+01,0.6984D+01,0.5878D+01,0.4881D+01,0.3991D+01,
     +0.3205D+01,0.2524D+01,0.1942D+01,0.1460D+01,0.1069D+01,0.7624D+00,
     +0.6148D+00,0.4981D+00,0.4063D+00,0.3333D+00,0.2753D+00,0.2285D+00,
     +0.1903D+00,0.1585D+00,0.1313D+00,0.1075D+00,0.8601D-01,0.6614D-01,
     +0.4725D-01,0.2900D-01,0.1772D-01,0.8218D-04/

       DATA (XQDUM (I, 1,5),I=1, 76) /

     +0.6526D+03,0.6077D+03,0.5662D+03,0.5272D+03,0.4909D+03,0.4572D+03,
     +0.4257D+03,0.3963D+03,0.3690D+03,0.3435D+03,0.3196D+03,0.2975D+03,
     +0.2768D+03,0.2575D+03,0.2395D+03,0.2227D+03,0.2071D+03,0.1925D+03,
     +0.1789D+03,0.1661D+03,0.1543D+03,0.1432D+03,0.1328D+03,0.1232D+03,
     +0.1142D+03,0.1058D+03,0.9791D+02,0.9058D+02,0.8371D+02,0.7731D+02,
     +0.7131D+02,0.6571D+02,0.6048D+02,0.5557D+02,0.5099D+02,0.4670D+02,
     +0.4269D+02,0.3893D+02,0.3543D+02,0.3214D+02,0.2907D+02,0.2620D+02,
     +0.2352D+02,0.2102D+02,0.1868D+02,0.1652D+02,0.1451D+02,0.1265D+02,
     +0.1093D+02,0.9357D+01,0.7914D+01,0.6606D+01,0.5431D+01,0.4383D+01,
     +0.3460D+01,0.2660D+01,0.1980D+01,0.1417D+01,0.9642D+00,0.6140D+00,
     +0.4496D+00,0.3235D+00,0.2284D+00,0.1573D+00,0.1054D+00,0.6807D-01,
     +0.4217D-01,0.2475D-01,0.1351D-01,0.6726D-02,0.2925D-02,0.1045D-02,
     +0.2666D-03,0.3485D-04,0.4325D-05,0.3798D-15/

       DATA (XQDUM (I, 1,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 2,1),I=1, 76) /

     +0.1029D+04,0.1298D+04,0.1471D+04,0.1572D+04,0.1617D+04,0.1618D+04,
     +0.1588D+04,0.1534D+04,0.1463D+04,0.1382D+04,0.1294D+04,0.1203D+04,
     +0.1111D+04,0.1021D+04,0.9336D+03,0.8499D+03,0.7707D+03,0.6965D+03,
     +0.6273D+03,0.5631D+03,0.5042D+03,0.4502D+03,0.4008D+03,0.3563D+03,
     +0.3159D+03,0.2794D+03,0.2465D+03,0.2172D+03,0.1909D+03,0.1675D+03,
     +0.1466D+03,0.1282D+03,0.1118D+03,0.9732D+02,0.8455D+02,0.7332D+02,
     +0.6345D+02,0.5480D+02,0.4723D+02,0.4061D+02,0.3484D+02,0.2983D+02,
     +0.2547D+02,0.2169D+02,0.1841D+02,0.1560D+02,0.1316D+02,0.1107D+02,
     +0.9265D+01,0.7733D+01,0.6416D+01,0.5296D+01,0.4345D+01,0.3540D+01,
     +0.2859D+01,0.2286D+01,0.1805D+01,0.1405D+01,0.1073D+01,0.7987D+00,
     +0.6588D+00,0.5420D+00,0.4444D+00,0.3621D+00,0.2928D+00,0.2340D+00,
     +0.1845D+00,0.1427D+00,0.1075D+00,0.7818D-01,0.5401D-01,0.3458D-01,
     +0.1939D-01,0.8360D-02,0.3582D-02,0.3644D-06/

       DATA (XQDUM (I, 2,2),I=1, 76) /

     +-.8111D+03,-.4890D+03,-.2404D+03,-.4746D+02,0.9802D+02,0.2056D+03,
     +0.2827D+03,0.3357D+03,0.3697D+03,0.3886D+03,0.3961D+03,0.3947D+03,
     +0.3867D+03,0.3740D+03,0.3578D+03,0.3394D+03,0.3197D+03,0.2993D+03,
     +0.2788D+03,0.2585D+03,0.2387D+03,0.2198D+03,0.2016D+03,0.1846D+03,
     +0.1686D+03,0.1536D+03,0.1397D+03,0.1268D+03,0.1149D+03,0.1040D+03,
     +0.9392D+02,0.8471D+02,0.7630D+02,0.6859D+02,0.6156D+02,0.5516D+02,
     +0.4933D+02,0.4403D+02,0.3920D+02,0.3481D+02,0.3083D+02,0.2721D+02,
     +0.2393D+02,0.2095D+02,0.1826D+02,0.1583D+02,0.1364D+02,0.1167D+02,
     +0.9896D+01,0.8327D+01,0.6927D+01,0.5695D+01,0.4621D+01,0.3692D+01,
     +0.2898D+01,0.2230D+01,0.1678D+01,0.1234D+01,0.8840D+00,0.6162D+00,
     +0.4897D+00,0.3909D+00,0.3136D+00,0.2526D+00,0.2043D+00,0.1653D+00,
     +0.1338D+00,0.1076D+00,0.8559D-01,0.6680D-01,0.5044D-01,0.3615D-01,
     +0.2355D-01,0.1263D-01,0.6737D-02,0.7088D-05/

       DATA (XQDUM (I, 2,3),I=1, 76) /

     +-.1075D+04,-.7360D+03,-.4717D+03,-.2638D+03,-.1044D+03,0.1619D+02,
     +0.1056D+03,0.1701D+03,0.2148D+03,0.2440D+03,0.2609D+03,0.2685D+03,
     +0.2689D+03,0.2640D+03,0.2553D+03,0.2438D+03,0.2306D+03,0.2164D+03,
     +0.2016D+03,0.1867D+03,0.1720D+03,0.1578D+03,0.1442D+03,0.1314D+03,
     +0.1194D+03,0.1081D+03,0.9765D+02,0.8806D+02,0.7924D+02,0.7121D+02,
     +0.6387D+02,0.5722D+02,0.5121D+02,0.4576D+02,0.4085D+02,0.3643D+02,
     +0.3246D+02,0.2890D+02,0.2570D+02,0.2283D+02,0.2026D+02,0.1796D+02,
     +0.1589D+02,0.1404D+02,0.1238D+02,0.1090D+02,0.9563D+01,0.8365D+01,
     +0.7285D+01,0.6321D+01,0.5450D+01,0.4668D+01,0.3967D+01,0.3338D+01,
     +0.2775D+01,0.2272D+01,0.1826D+01,0.1435D+01,0.1094D+01,0.8021D+00,
     +0.6495D+00,0.5210D+00,0.4136D+00,0.3237D+00,0.2493D+00,0.1880D+00,
     +0.1382D+00,0.9831D-01,0.6693D-01,0.4306D-01,0.2550D-01,0.1338D-01,
     +0.5698D-02,0.1605D-02,0.4388D-03,0.1877D-09/

       DATA (XQDUM (I, 2,4),I=1, 76) /

     +-.8111D+03,-.4890D+03,-.2404D+03,-.4746D+02,0.9802D+02,0.2056D+03,
     +0.2827D+03,0.3357D+03,0.3697D+03,0.3886D+03,0.3961D+03,0.3947D+03,
     +0.3867D+03,0.3740D+03,0.3578D+03,0.3394D+03,0.3197D+03,0.2993D+03,
     +0.2788D+03,0.2585D+03,0.2387D+03,0.2198D+03,0.2016D+03,0.1846D+03,
     +0.1686D+03,0.1536D+03,0.1397D+03,0.1268D+03,0.1149D+03,0.1040D+03,
     +0.9392D+02,0.8471D+02,0.7630D+02,0.6859D+02,0.6156D+02,0.5516D+02,
     +0.4933D+02,0.4403D+02,0.3920D+02,0.3481D+02,0.3083D+02,0.2721D+02,
     +0.2393D+02,0.2095D+02,0.1826D+02,0.1583D+02,0.1364D+02,0.1167D+02,
     +0.9896D+01,0.8327D+01,0.6927D+01,0.5695D+01,0.4621D+01,0.3692D+01,
     +0.2898D+01,0.2230D+01,0.1678D+01,0.1234D+01,0.8840D+00,0.6162D+00,
     +0.4897D+00,0.3909D+00,0.3136D+00,0.2526D+00,0.2043D+00,0.1653D+00,
     +0.1338D+00,0.1076D+00,0.8559D-01,0.6680D-01,0.5044D-01,0.3615D-01,
     +0.2355D-01,0.1263D-01,0.6737D-02,0.7088D-05/

       DATA (XQDUM (I, 2,5),I=1, 76) /

     +-.5826D+03,-.2790D+03,-.4734D+02,0.1299D+03,0.2609D+03,0.3551D+03,
     +0.4199D+03,0.4616D+03,0.4851D+03,0.4944D+03,0.4930D+03,0.4834D+03,
     +0.4679D+03,0.4482D+03,0.4257D+03,0.4014D+03,0.3763D+03,0.3510D+03,
     +0.3259D+03,0.3014D+03,0.2778D+03,0.2553D+03,0.2339D+03,0.2139D+03,
     +0.1952D+03,0.1777D+03,0.1614D+03,0.1464D+03,0.1326D+03,0.1199D+03,
     +0.1082D+03,0.9756D+02,0.8781D+02,0.7887D+02,0.7073D+02,0.6331D+02,
     +0.5656D+02,0.5041D+02,0.4483D+02,0.3975D+02,0.3514D+02,0.3096D+02,
     +0.2717D+02,0.2374D+02,0.2063D+02,0.1784D+02,0.1532D+02,0.1306D+02,
     +0.1102D+02,0.9224D+01,0.7621D+01,0.6212D+01,0.4985D+01,0.3925D+01,
     +0.3020D+01,0.2262D+01,0.1638D+01,0.1140D+01,0.7527D+00,0.4649D+00,
     +0.3342D+00,0.2362D+00,0.1641D+00,0.1114D+00,0.7372D-01,0.4720D-01,
     +0.2912D-01,0.1712D-01,0.9465D-02,0.4846D-02,0.2226D-02,0.8786D-03,
     +0.2688D-03,0.4924D-04,0.8381D-05,-.8808D-10/

       DATA (XQDUM (I, 2,6),I=1, 76) /

     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00,
     +0.0000D+00,0.0000D+00,0.0000D+00,0.0000D+00/

       DATA (XQDUM (I, 3,1),I=1, 76) /

     +0.1743D+04,0.2006D+04,0.2158D+04,0.2229D+04,0.2236D+04,0.2195D+04,
     +0.2120D+04,0.2022D+04,0.1907D+04,0.1783D+04,0.1655D+04,0.1526D+04,
     +0.1400D+04,0.1277D+04,0.1159D+04,0.1049D+04,0.9450D+03,0.8488D+03,
     +0.7599D+03,0.6783D+03,0.6038D+03,0.5361D+03,0.4746D+03,0.4195D+03,
     +0.3700D+03,0.3254D+03,0.2855D+03,0.2501D+03,0.2186D+03,0.1907D+03,
     +0.1660D+03,0.1442D+03,0.1251D+03,0.1082D+03,0.9344D+02,0.8052D+02,
     +0.6924D+02,0.5941D+02,0.5087D+02,0.4344D+02,0.3701D+02,0.3145D+02,
     +0.2665D+02,0.2252D+02,0.1896D+02,0.1593D+02,0.1333D+02,0.1111D+02,
     +0.9209D+01,0.7610D+01,0.6248D+01,0.5100D+01,0.4135D+01,0.3326D+01,
     +0.2650D+01,0.2088D+01,0.1623D+01,0.1241D+01,0.9294D+00,0.6769D+00,
     +0.5501D+00,0.4456D+00,0.3595D+00,0.2880D+00,0.2287D+00,0.1793D+00,
     +0.1384D+00,0.1046D+00,0.7669D-01,0.5414D-01,0.3609D-01,0.2211D-01,
     +0.1170D-01,0.4626D-02,0.1815D-02,0.6949D-07/

       DATA (XQDUM (I, 3,2),I=1, 76) /

     +-.6282D+03,-.2731D+03,-.5498D+01,0.1961D+03,0.3423D+03,0.4448D+03,
     +0.5127D+03,0.5537D+03,0.5739D+03,0.5781D+03,0.5704D+03,0.5539D+03,
     +0.5313D+03,0.5045D+03,0.4750D+03,0.4441D+03,0.4129D+03,0.3819D+03,
     +0.3517D+03,0.3226D+03,0.2950D+03,0.2689D+03,0.2444D+03,0.2217D+03,
     +0.2007D+03,0.1813D+03,0.1634D+03,0.1471D+03,0.1322D+03,0.1187D+03,
     +0.1063D+03,0.9512D+02,0.8501D+02,0.7583D+02,0.6755D+02,0.6007D+02,
     +0.5333D+02,0.4725D+02,0.4177D+02,0.3683D+02,0.3239D+02,0.2839D+02,
     +0.2479D+02,0.2156D+02,0.1866D+02,0.1608D+02,0.1376D+02,0.1170D+02,
     +0.9855D+01,0.8239D+01,0.6809D+01,0.5562D+01,0.4483D+01,0.3558D+01,
     +0.2775D+01,0.2122D+01,0.1586D+01,0.1159D+01,0.8244D+00,0.5707D+00,
     +0.4516D+00,0.3587D+00,0.2864D+00,0.2295D+00,0.1844D+00,0.1482D+00,
     +0.1189D+00,0.9479D-01,0.7454D-01,0.5741D-01,0.4267D-01,0.2998D-01,
     +0.1902D-01,0.9818D-02,0.5035D-02,0.3433D-05/

       DATA (XQDUM (I, 3,3),I=1, 76) /

     +-.8996D+03,-.5270D+03,-.2432D+03,-.2620D+02,0.1344D+03,0.2504D+03,
     +0.3310D+03,0.3839D+03,0.4152D+03,0.4299D+03,0.4321D+03,0.4248D+03,
     +0.4109D+03,0.3922D+03,0.3703D+03,0.3467D+03,0.3221D+03,0.2975D+03,
     +0.2732D+03,0.2497D+03,0.2273D+03,0.2061D+03,0.1863D+03,0.1679D+03,
     +0.1510D+03,0.1354D+03,0.1211D+03,0.1082D+03,0.9644D+02,0.8587D+02,
     +0.7631D+02,0.6775D+02,0.6009D+02,0.5321D+02,0.4708D+02,0.4161D+02,
     +0.3675D+02,0.3243D+02,0.2859D+02,0.2517D+02,0.2214D+02,0.1946D+02,
     +0.1707D+02,0.1496D+02,0.1308D+02,0.1142D+02,0.9936D+01,0.8619D+01,
     +0.7445D+01,0.6407D+01,0.5479D+01,0.4654D+01,0.3922D+01,0.3272D+01,
     +0.2696D+01,0.2188D+01,0.1741D+01,0.1354D+01,0.1021D+01,0.7393D+00,
     +0.5939D+00,0.4724D+00,0.3719D+00,0.2884D+00,0.2201D+00,0.1643D+00,
     +0.1195D+00,0.8403D-01,0.5647D-01,0.3580D-01,0.2084D-01,0.1071D-01,
     +0.4438D-02,0.1201D-02,0.3152D-03,0.8496D-10/

       DATA (XQDUM (I, 3,4),I=1, 76) /

     +-.6282D+03,-.2731D+03,-.5498D+01,0.1961D+03,0.3423D+03,0.4448D+03,
     +0.5127D+03,0.5537D+03,0.5739D+03,0.5781D+03,0.5704D+03,0.5539D+03,
     +0.5313D+03,0.5045D+03,0.4750D+03,0.4441D+03,0.4129D+03,0.3819D+03,
     +0.3517D+03,0.3226D+03,0.2950D+03,0.2689D+03,0.2444D+03,0.2217D+03,
     +0.2007D+03,0.1813D+03,0.1634D+03,0.1471D+03,0.1322D+03,0.1187D+03,
     +0.1063D+03,0.9512D+02,0.8501D+02,0.7583D+02,0.6755D+02,0.6007D+02,
     +0.5333D+02,0.4725D+02,0.4177D+02,0.3683D+02,0.3239D+02,0.2839D+02,
     +0.2479D+02,0.2156D+02,0.1866D+02,0.1608D+02,0.1376D+02,0.1170D+02,
     +0.9855D+01,0.8239D+01,0.6809D+01,0.5562D+01,0.4483D+01,0.3558D+01,
     +0.2775D+01,0.2122D+01,0.1586D+01,0.1159D+01,0.8244D+00,0.5707D+00,
     +0.4516D+00,0.3587D+00,0.2864D+00,0.2295D+00,0.1844D+00,0.1482D+00,
     +0.1189D+00,0.9479D-01,0.7454D-01,0.5741D-01,0.4267D-01,0.2998D-01,
     +0.1902D-01,0.9818D-02,0.5035D-02,0.3433D-05/

       DATA (XQDUM (I, 3,5),I=1, 76) /

     +-.3969D+03,-.6058D+02,0.1898D+03,0.3754D+03,0.5069D+03,0.5958D+03,
     +0.6513D+03,0.6808D+03,0.6903D+03,0.6848D+03,0.6680D+03,0.6433D+03,
     +0.6131D+03,0.5792D+03,0.5433D+03,0.5065D+03,0.4697D+03,0.4337D+03,
     +0.3989D+03,0.3656D+03,0.3340D+03,0.3044D+03,0.2766D+03,0.2509D+03,
     +0.2272D+03,0.2052D+03,0.1850D+03,0.1666D+03,0.1497D+03,0.1344D+03,
     +0.1205D+03,0.1078D+03,0.9636D+02,0.8596D+02,0.7655D+02,0.6807D+02,
     +0.6040D+02,0.5348D+02,0.4725D+02,0.4162D+02,0.3656D+02,0.3201D+02,
     +0.2791D+02,0.2423D+02,0.2093D+02,0.1799D+02,0.1535D+02,0.1300D+02,
     +0.1090D+02,0.9064D+01,0.7440D+01,0.6023D+01,0.4800D+01,0.3752D+01,
     +0.2866D+01,0.2129D+01,0.1529D+01,0.1055D+01,0.6902D+00,0.4220D+00,
     +0.3014D+00,0.2117D+00,0.1461D+00,0.9855D-01,0.6481D-01,0.4124D-01,
     +0.2528D-01,0.1477D-01,0.8114D-02,0.4128D-02,0.1883D-02,0.7367D-03,
     +0.2223D-03,0.3957D-04,0.6462D-05,-.4313D-10/

       DATA (XQDUM (I, 3,6),I=1, 76) /

     +0.9267D+05,0.7766D+05,0.6518D+05,0.5461D+05,0.4578D+05,0.3837D+05,
     +0.3216D+05,0.2696D+05,0.2259D+05,0.1894D+05,0.1586D+05,0.1329D+05,
     +0.1114D+05,0.9328D+04,0.7811D+04,0.6539D+04,0.5474D+04,0.4582D+04,
     +0.3833D+04,0.3206D+04,0.2681D+04,0.2241D+04,0.1870D+04,0.1563D+04,
     +0.1305D+04,0.1089D+04,0.9072D+03,0.7560D+03,0.6292D+03,0.5235D+03,
     +0.4349D+03,0.3610D+03,0.2994D+03,0.2479D+03,0.2049D+03,0.1692D+03,
     +0.1394D+03,0.1146D+03,0.9403D+02,0.7692D+02,0.6276D+02,0.5103D+02,
     +0.4135D+02,0.3336D+02,0.2678D+02,0.2141D+02,0.1700D+02,0.1340D+02,
     +0.1047D+02,0.8127D+01,0.6231D+01,0.4720D+01,0.3526D+01,0.2590D+01,
     +0.1864D+01,0.1309D+01,0.8922D+00,0.5869D+00,0.3684D+00,0.2176D+00,
     +0.1528D+00,0.1060D+00,0.7249D-01,0.4861D-01,0.3188D-01,0.2028D-01,
     +0.1244D-01,0.7279D-02,0.3993D-02,0.2017D-02,0.9019D-03,0.3375D-03,
     +0.9293D-04,0.1391D-04,0.2014D-05,-.1010D-12/

       DATA (XQDUM (I, 4,1),I=1, 76) /

     +0.5295D+04,0.5200D+04,0.5021D+04,0.4782D+04,0.4505D+04,0.4206D+04,
     +0.3896D+04,0.3585D+04,0.3279D+04,0.2984D+04,0.2703D+04,0.2438D+04,
     +0.2191D+04,0.1962D+04,0.1751D+04,0.1558D+04,0.1382D+04,0.1223D+04,
     +0.1080D+04,0.9506D+03,0.8351D+03,0.7319D+03,0.6397D+03,0.5585D+03,
     +0.4866D+03,0.4227D+03,0.3665D+03,0.3173D+03,0.2740D+03,0.2363D+03,
     +0.2032D+03,0.1744D+03,0.1495D+03,0.1278D+03,0.1090D+03,0.9275D+02,
     +0.7875D+02,0.6672D+02,0.5638D+02,0.4751D+02,0.3992D+02,0.3345D+02,
     +0.2794D+02,0.2326D+02,0.1929D+02,0.1595D+02,0.1312D+02,0.1075D+02,
     +0.8749D+01,0.7093D+01,0.5707D+01,0.4559D+01,0.3614D+01,0.2837D+01,
     +0.2202D+01,0.1686D+01,0.1270D+01,0.9390D+00,0.6768D+00,0.4720D+00,
     +0.3726D+00,0.2928D+00,0.2289D+00,0.1773D+00,0.1359D+00,0.1026D+00,
     +0.7598D-01,0.5486D-01,0.3823D-01,0.2545D-01,0.1583D-01,0.8905D-02,
     +0.4211D-02,0.1410D-02,0.4666D-03,0.2738D-08/

       DATA (XQDUM (I, 4,2),I=1, 76) /

     +0.2887D+03,0.6313D+03,0.8690D+03,0.1028D+04,0.1124D+04,0.1172D+04,
     +0.1183D+04,0.1167D+04,0.1131D+04,0.1081D+04,0.1022D+04,0.9578D+03,
     +0.8908D+03,0.8231D+03,0.7563D+03,0.6916D+03,0.6297D+03,0.5714D+03,
     +0.5167D+03,0.4657D+03,0.4188D+03,0.3756D+03,0.3361D+03,0.3003D+03,
     +0.2679D+03,0.2384D+03,0.2118D+03,0.1880D+03,0.1666D+03,0.1475D+03,
     +0.1303D+03,0.1150D+03,0.1014D+03,0.8929D+02,0.7849D+02,0.6890D+02,
     +0.6037D+02,0.5281D+02,0.4610D+02,0.4014D+02,0.3486D+02,0.3018D+02,
     +0.2604D+02,0.2237D+02,0.1913D+02,0.1628D+02,0.1377D+02,0.1156D+02,
     +0.9627D+01,0.7952D+01,0.6493D+01,0.5240D+01,0.4172D+01,0.3271D+01,
     +0.2520D+01,0.1902D+01,0.1404D+01,0.1013D+01,0.7116D+00,0.4860D+00,
     +0.3812D+00,0.3001D+00,0.2374D+00,0.1882D+00,0.1495D+00,0.1185D+00,
     +0.9365D-01,0.7331D-01,0.5644D-01,0.4240D-01,0.3057D-01,0.2069D-01,
     +0.1249D-01,0.5988D-02,0.2848D-02,0.8459D-06/

       DATA (XQDUM (I, 4,3),I=1, 76) /

     +0.2373D+01,0.3636D+03,0.6186D+03,0.7943D+03,0.9056D+03,0.9676D+03,
     +0.9921D+03,0.9886D+03,0.9646D+03,0.9262D+03,0.8777D+03,0.8233D+03,
     +0.7655D+03,0.7064D+03,0.6477D+03,0.5906D+03,0.5360D+03,0.4843D+03,
     +0.4359D+03,0.3909D+03,0.3495D+03,0.3116D+03,0.2769D+03,0.2457D+03,
     +0.2175D+03,0.1920D+03,0.1692D+03,0.1490D+03,0.1309D+03,0.1148D+03,
     +0.1006D+03,0.8801D+02,0.7694D+02,0.6716D+02,0.5857D+02,0.5104D+02,
     +0.4443D+02,0.3864D+02,0.3358D+02,0.2914D+02,0.2527D+02,0.2189D+02,
     +0.1894D+02,0.1635D+02,0.1409D+02,0.1213D+02,0.1041D+02,0.8900D+01,
     +0.7578D+01,0.6429D+01,0.5418D+01,0.4535D+01,0.3765D+01,0.3092D+01,
     +0.2507D+01,0.2001D+01,0.1565D+01,0.1194D+01,0.8819D+00,0.6239D+00,
     +0.4936D+00,0.3865D+00,0.2994D+00,0.2283D+00,0.1712D+00,0.1254D+00,
     +0.8936D-01,0.6146D-01,0.4030D-01,0.2484D-01,0.1399D-01,0.6909D-02,
     +0.2718D-02,0.6815D-03,0.1656D-03,0.1909D-10/

       DATA (XQDUM (I, 4,4),I=1, 76) /

     +0.2887D+03,0.6313D+03,0.8690D+03,0.1028D+04,0.1124D+04,0.1172D+04,
     +0.1183D+04,0.1167D+04,0.1131D+04,0.1081D+04,0.1022D+04,0.9578D+03,
     +0.8908D+03,0.8231D+03,0.7563D+03,0.6916D+03,0.6297D+03,0.5714D+03,
     +0.5167D+03,0.4657D+03,0.4188D+03,0.3756D+03,0.3361D+03,0.3003D+03,
     +0.2679D+03,0.2384D+03,0.2118D+03,0.1880D+03,0.1666D+03,0.1475D+03,
     +0.1303D+03,0.1150D+03,0.1014D+03,0.8929D+02,0.7849D+02,0.6890D+02,
     +0.6037D+02,0.5281D+02,0.4610D+02,0.4014D+02,0.3486D+02,0.3018D+02,
     +0.2604D+02,0.2237D+02,0.1913D+02,0.1628D+02,0.1377D+02,0.1156D+02,
     +0.9627D+01,0.7952D+01,0.6493D+01,0.5240D+01,0.4172D+01,0.3271D+01,
     +0.2520D+01,0.1902D+01,0.1404D+01,0.1013D+01,0.7116D+00,0.4860D+00,
     +0.3812D+00,0.3001D+00,0.2374D+00,0.1882D+00,0.1495D+00,0.1185D+00,
     +0.9365D-01,0.7331D-01,0.5644D-01,0.4240D-01,0.3057D-01,0.2069D-01,
     +0.1249D-01,0.5988D-02,0.2848D-02,0.8459D-06/

       DATA (XQDUM (I, 4,5),I=1, 76) /

     +0.5252D+03,0.8484D+03,0.1068D+04,0.1211D+04,0.1292D+04,0.1326D+04,
     +0.1324D+04,0.1296D+04,0.1249D+04,0.1189D+04,0.1121D+04,0.1048D+04,
     +0.9735D+03,0.8985D+03,0.8251D+03,0.7543D+03,0.6869D+03,0.6234D+03,
     +0.5640D+03,0.5087D+03,0.4578D+03,0.4110D+03,0.3681D+03,0.3293D+03,
     +0.2941D+03,0.2620D+03,0.2331D+03,0.2072D+03,0.1838D+03,0.1629D+03,
     +0.1441D+03,0.1274D+03,0.1124D+03,0.9907D+02,0.8716D+02,0.7656D+02,
     +0.6712D+02,0.5874D+02,0.5128D+02,0.4465D+02,0.3876D+02,0.3354D+02,
     +0.2891D+02,0.2481D+02,0.2118D+02,0.1799D+02,0.1518D+02,0.1270D+02,
     +0.1053D+02,0.8646D+01,0.7009D+01,0.5603D+01,0.4406D+01,0.3397D+01,
     +0.2558D+01,0.1872D+01,0.1323D+01,0.8970D+00,0.5763D+00,0.3453D+00,
     +0.2434D+00,0.1687D+00,0.1149D+00,0.7645D-01,0.4959D-01,0.3110D-01,
     +0.1879D-01,0.1081D-01,0.5839D-02,0.2916D-02,0.1301D-02,0.4953D-03,
     +0.1436D-03,0.2383D-04,0.3569D-05,-.1015D-10/

       DATA (XQDUM (I, 4,6),I=1, 76) /

     +0.8687D+05,0.7293D+05,0.6133D+05,0.5149D+05,0.4324D+05,0.3632D+05,
     +0.3051D+05,0.2562D+05,0.2152D+05,0.1807D+05,0.1517D+05,0.1274D+05,
     +0.1069D+05,0.8972D+04,0.7527D+04,0.6313D+04,0.5294D+04,0.4439D+04,
     +0.3720D+04,0.3116D+04,0.2610D+04,0.2184D+04,0.1826D+04,0.1528D+04,
     +0.1277D+04,0.1066D+04,0.8891D+03,0.7413D+03,0.6173D+03,0.5138D+03,
     +0.4268D+03,0.3543D+03,0.2937D+03,0.2430D+03,0.2007D+03,0.1655D+03,
     +0.1362D+03,0.1118D+03,0.9158D+02,0.7476D+02,0.6085D+02,0.4934D+02,
     +0.3986D+02,0.3205D+02,0.2563D+02,0.2040D+02,0.1613D+02,0.1265D+02,
     +0.9834D+01,0.7585D+01,0.5778D+01,0.4346D+01,0.3222D+01,0.2347D+01,
     +0.1674D+01,0.1164D+01,0.7846D+00,0.5099D+00,0.3158D+00,0.1837D+00,
     +0.1277D+00,0.8769D-01,0.5938D-01,0.3940D-01,0.2556D-01,0.1607D-01,
     +0.9747D-02,0.5633D-02,0.3051D-02,0.1520D-02,0.6700D-03,0.2469D-03,
     +0.6676D-04,0.9748D-05,0.1362D-05,-.1217D-12/

       DATA (XQDUM (I, 5,1),I=1, 76) /

     +0.7248D+04,0.6914D+04,0.6524D+04,0.6094D+04,0.5648D+04,0.5199D+04,
     +0.4757D+04,0.4329D+04,0.3921D+04,0.3537D+04,0.3177D+04,0.2845D+04,
     +0.2539D+04,0.2258D+04,0.2003D+04,0.1772D+04,0.1563D+04,0.1376D+04,
     +0.1208D+04,0.1058D+04,0.9252D+03,0.8070D+03,0.7021D+03,0.6102D+03,
     +0.5293D+03,0.4578D+03,0.3951D+03,0.3406D+03,0.2929D+03,0.2515D+03,
     +0.2153D+03,0.1841D+03,0.1571D+03,0.1337D+03,0.1135D+03,0.9619D+02,
     +0.8131D+02,0.6857D+02,0.5768D+02,0.4837D+02,0.4045D+02,0.3373D+02,
     +0.2803D+02,0.2321D+02,0.1914D+02,0.1574D+02,0.1287D+02,0.1048D+02,
     +0.8475D+01,0.6824D+01,0.5451D+01,0.4321D+01,0.3397D+01,0.2643D+01,
     +0.2032D+01,0.1540D+01,0.1147D+01,0.8375D+00,0.5952D+00,0.4085D+00,
     +0.3189D+00,0.2478D+00,0.1915D+00,0.1465D+00,0.1109D+00,0.8249D-01,
     +0.6017D-01,0.4271D-01,0.2921D-01,0.1903D-01,0.1153D-01,0.6286D-02,
     +0.2851D-02,0.8976D-03,0.2790D-03,0.8174D-09/

       DATA (XQDUM (I, 5,2),I=1, 76) /

     +0.9979D+03,0.1277D+04,0.1455D+04,0.1556D+04,0.1597D+04,0.1593D+04,
     +0.1558D+04,0.1498D+04,0.1423D+04,0.1338D+04,0.1248D+04,0.1155D+04,
     +0.1063D+04,0.9723D+03,0.8855D+03,0.8032D+03,0.7259D+03,0.6540D+03,
     +0.5875D+03,0.5262D+03,0.4703D+03,0.4194D+03,0.3731D+03,0.3317D+03,
     +0.2943D+03,0.2605D+03,0.2303D+03,0.2034D+03,0.1793D+03,0.1580D+03,
     +0.1390D+03,0.1221D+03,0.1072D+03,0.9390D+02,0.8217D+02,0.7181D+02,
     +0.6265D+02,0.5456D+02,0.4742D+02,0.4111D+02,0.3555D+02,0.3064D+02,
     +0.2633D+02,0.2253D+02,0.1918D+02,0.1626D+02,0.1369D+02,0.1145D+02,
     +0.9492D+01,0.7807D+01,0.6348D+01,0.5100D+01,0.4044D+01,0.3156D+01,
     +0.2420D+01,0.1819D+01,0.1337D+01,0.9600D+00,0.6711D+00,0.4561D+00,
     +0.3566D+00,0.2798D+00,0.2206D+00,0.1742D+00,0.1378D+00,0.1087D+00,
     +0.8540D-01,0.6641D-01,0.5074D-01,0.3777D-01,0.2693D-01,0.1798D-01,
     +0.1066D-01,0.4971D-02,0.2300D-02,0.5018D-06/

       DATA (XQDUM (I, 5,3),I=1, 76) /

     +0.7060D+03,0.1005D+04,0.1199D+04,0.1317D+04,0.1374D+04,0.1386D+04,
     +0.1364D+04,0.1318D+04,0.1255D+04,0.1181D+04,0.1101D+04,0.1018D+04,
     +0.9355D+03,0.8541D+03,0.7756D+03,0.7011D+03,0.6311D+03,0.5661D+03,
     +0.5059D+03,0.4507D+03,0.4005D+03,0.3549D+03,0.3136D+03,0.2768D+03,
     +0.2437D+03,0.2141D+03,0.1877D+03,0.1644D+03,0.1437D+03,0.1255D+03,
     +0.1094D+03,0.9525D+02,0.8288D+02,0.7200D+02,0.6249D+02,0.5420D+02,
     +0.4695D+02,0.4065D+02,0.3516D+02,0.3037D+02,0.2621D+02,0.2260D+02,
     +0.1946D+02,0.1672D+02,0.1434D+02,0.1229D+02,0.1049D+02,0.8930D+01,
     +0.7567D+01,0.6389D+01,0.5358D+01,0.4462D+01,0.3685D+01,0.3011D+01,
     +0.2428D+01,0.1926D+01,0.1497D+01,0.1134D+01,0.8317D+00,0.5836D+00,
     +0.4591D+00,0.3575D+00,0.2753D+00,0.2087D+00,0.1554D+00,0.1130D+00,
     +0.7998D-01,0.5457D-01,0.3545D-01,0.2163D-01,0.1204D-01,0.5858D-02,
     +0.2261D-02,0.5511D-03,0.1302D-03,0.1097D-10/

       DATA (XQDUM (I, 5,4),I=1, 76) /

     +0.9979D+03,0.1277D+04,0.1455D+04,0.1556D+04,0.1597D+04,0.1593D+04,
     +0.1558D+04,0.1498D+04,0.1423D+04,0.1338D+04,0.1248D+04,0.1155D+04,
     +0.1063D+04,0.9723D+03,0.8855D+03,0.8032D+03,0.7259D+03,0.6540D+03,
     +0.5875D+03,0.5262D+03,0.4703D+03,0.4194D+03,0.3731D+03,0.3317D+03,
     +0.2943D+03,0.2605D+03,0.2303D+03,0.2034D+03,0.1793D+03,0.1580D+03,
     +0.1390D+03,0.1221D+03,0.1072D+03,0.9390D+02,0.8217D+02,0.7181D+02,
     +0.6265D+02,0.5456D+02,0.4742D+02,0.4111D+02,0.3555D+02,0.3064D+02,
     +0.2633D+02,0.2253D+02,0.1918D+02,0.1626D+02,0.1369D+02,0.1145D+02,
     +0.9492D+01,0.7807D+01,0.6348D+01,0.5100D+01,0.4044D+01,0.3156D+01,
     +0.2420D+01,0.1819D+01,0.1337D+01,0.9600D+00,0.6711D+00,0.4561D+00,
     +0.3566D+00,0.2798D+00,0.2206D+00,0.1742D+00,0.1378D+00,0.1087D+00,
     +0.8540D-01,0.6641D-01,0.5074D-01,0.3777D-01,0.2693D-01,0.1798D-01,
     +0.1066D-01,0.4971D-02,0.2300D-02,0.5018D-06/

       DATA (XQDUM (I, 5,5),I=1, 76) /

     +0.1236D+04,0.1496D+04,0.1655D+04,0.1740D+04,0.1766D+04,0.1748D+04,
     +0.1699D+04,0.1628D+04,0.1542D+04,0.1447D+04,0.1347D+04,0.1246D+04,
     +0.1146D+04,0.1048D+04,0.9545D+03,0.8660D+03,0.7832D+03,0.7061D+03,
     +0.6348D+03,0.5692D+03,0.5093D+03,0.4548D+03,0.4051D+03,0.3606D+03,
     +0.3204D+03,0.2841D+03,0.2515D+03,0.2224D+03,0.1964D+03,0.1733D+03,
     +0.1526D+03,0.1343D+03,0.1180D+03,0.1036D+03,0.9071D+02,0.7935D+02,
     +0.6927D+02,0.6037D+02,0.5249D+02,0.4551D+02,0.3935D+02,0.3391D+02,
     +0.2911D+02,0.2488D+02,0.2116D+02,0.1790D+02,0.1503D+02,0.1253D+02,
     +0.1034D+02,0.8456D+01,0.6824D+01,0.5429D+01,0.4249D+01,0.3260D+01,
     +0.2442D+01,0.1777D+01,0.1249D+01,0.8412D+00,0.5367D+00,0.3191D+00,
     +0.2238D+00,0.1543D+00,0.1046D+00,0.6921D-01,0.4465D-01,0.2784D-01,
     +0.1672D-01,0.9556D-02,0.5125D-02,0.2539D-02,0.1122D-02,0.4220D-03,
     +0.1203D-03,0.1941D-04,0.2810D-05,-.5914D-11/

       DATA (XQDUM (I, 5,6),I=1, 76) /

     +0.8520D+05,0.7158D+05,0.6024D+05,0.5061D+05,0.4254D+05,0.3576D+05,
     +0.3005D+05,0.2526D+05,0.2123D+05,0.1784D+05,0.1499D+05,0.1259D+05,
     +0.1058D+05,0.8882D+04,0.7456D+04,0.6257D+04,0.5250D+04,0.4404D+04,
     +0.3693D+04,0.3094D+04,0.2592D+04,0.2171D+04,0.1815D+04,0.1519D+04,
     +0.1270D+04,0.1060D+04,0.8841D+03,0.7372D+03,0.6137D+03,0.5107D+03,
     +0.4242D+03,0.3520D+03,0.2917D+03,0.2412D+03,0.1991D+03,0.1641D+03,
     +0.1349D+03,0.1107D+03,0.9057D+02,0.7385D+02,0.6004D+02,0.4863D+02,
     +0.3922D+02,0.3149D+02,0.2514D+02,0.1998D+02,0.1576D+02,0.1234D+02,
     +0.9570D+01,0.7364D+01,0.5594D+01,0.4196D+01,0.3101D+01,0.2252D+01,
     +0.1600D+01,0.1108D+01,0.7436D+00,0.4809D+00,0.2962D+00,0.1713D+00,
     +0.1186D+00,0.8105D-01,0.5463D-01,0.3608D-01,0.2329D-01,0.1457D-01,
     +0.8787D-02,0.5048D-02,0.2716D-02,0.1343D-02,0.5868D-03,0.2139D-03,
     +0.5705D-04,0.8153D-05,0.1112D-05,-.8036D-13/

       DATA (XQDUM (I, 6,1),I=1, 76) /

     +0.1218D+05,0.1119D+05,0.1022D+05,0.9286D+04,0.8396D+04,0.7560D+04,
     +0.6781D+04,0.6061D+04,0.5399D+04,0.4796D+04,0.4247D+04,0.3752D+04,
     +0.3306D+04,0.2905D+04,0.2547D+04,0.2229D+04,0.1946D+04,0.1695D+04,
     +0.1474D+04,0.1279D+04,0.1108D+04,0.9575D+03,0.8255D+03,0.7113D+03,
     +0.6116D+03,0.5244D+03,0.4489D+03,0.3836D+03,0.3271D+03,0.2785D+03,
     +0.2365D+03,0.2005D+03,0.1697D+03,0.1432D+03,0.1205D+03,0.1013D+03,
     +0.8485D+02,0.7092D+02,0.5912D+02,0.4912D+02,0.4069D+02,0.3360D+02,
     +0.2765D+02,0.2265D+02,0.1848D+02,0.1503D+02,0.1215D+02,0.9766D+01,
     +0.7798D+01,0.6194D+01,0.4876D+01,0.3807D+01,0.2943D+01,0.2250D+01,
     +0.1697D+01,0.1259D+01,0.9163D+00,0.6521D+00,0.4503D+00,0.2990D+00,
     +0.2284D+00,0.1734D+00,0.1308D+00,0.9758D-01,0.7187D-01,0.5194D-01,
     +0.3671D-01,0.2518D-01,0.1656D-01,0.1032D-01,0.5933D-02,0.3032D-02,
     +0.1263D-02,0.3508D-03,0.9593D-04,0.6826D-10/

       DATA (XQDUM (I, 6,2),I=1, 76) /

     +0.3050D+04,0.3099D+04,0.3068D+04,0.2977D+04,0.2847D+04,0.2689D+04,
     +0.2515D+04,0.2333D+04,0.2149D+04,0.1967D+04,0.1791D+04,0.1624D+04,
     +0.1466D+04,0.1319D+04,0.1182D+04,0.1057D+04,0.9419D+03,0.8377D+03,
     +0.7432D+03,0.6579D+03,0.5814D+03,0.5129D+03,0.4515D+03,0.3972D+03,
     +0.3489D+03,0.3059D+03,0.2678D+03,0.2343D+03,0.2047D+03,0.1787D+03,
     +0.1557D+03,0.1356D+03,0.1180D+03,0.1025D+03,0.8893D+02,0.7705D+02,
     +0.6665D+02,0.5756D+02,0.4961D+02,0.4265D+02,0.3658D+02,0.3127D+02,
     +0.2665D+02,0.2262D+02,0.1910D+02,0.1606D+02,0.1341D+02,0.1112D+02,
     +0.9146D+01,0.7460D+01,0.6015D+01,0.4791D+01,0.3766D+01,0.2914D+01,
     +0.2215D+01,0.1650D+01,0.1201D+01,0.8547D+00,0.5919D+00,0.3982D+00,
     +0.3094D+00,0.2411D+00,0.1887D+00,0.1479D+00,0.1159D+00,0.9056D-01,
     +0.7032D-01,0.5396D-01,0.4058D-01,0.2965D-01,0.2067D-01,0.1341D-01,
     +0.7658D-02,0.3379D-02,0.1476D-02,0.1714D-06/

       DATA (XQDUM (I, 6,3),I=1, 76) /

     +0.2747D+04,0.2816D+04,0.2803D+04,0.2730D+04,0.2616D+04,0.2474D+04,
     +0.2314D+04,0.2146D+04,0.1974D+04,0.1805D+04,0.1640D+04,0.1484D+04,
     +0.1336D+04,0.1198D+04,0.1070D+04,0.9522D+03,0.8451D+03,0.7480D+03,
     +0.6603D+03,0.5813D+03,0.5106D+03,0.4476D+03,0.3914D+03,0.3419D+03,
     +0.2981D+03,0.2593D+03,0.2252D+03,0.1954D+03,0.1692D+03,0.1465D+03,
     +0.1265D+03,0.1092D+03,0.9418D+02,0.8109D+02,0.6977D+02,0.5998D+02,
     +0.5151D+02,0.4420D+02,0.3789D+02,0.3245D+02,0.2776D+02,0.2372D+02,
     +0.2024D+02,0.1725D+02,0.1466D+02,0.1245D+02,0.1054D+02,0.8887D+01,
     +0.7462D+01,0.6242D+01,0.5185D+01,0.4277D+01,0.3497D+01,0.2828D+01,
     +0.2255D+01,0.1768D+01,0.1357D+01,0.1015D+01,0.7332D+00,0.5060D+00,
     +0.3936D+00,0.3030D+00,0.2306D+00,0.1726D+00,0.1269D+00,0.9102D-01,
     +0.6344D-01,0.4257D-01,0.2715D-01,0.1623D-01,0.8813D-02,0.4161D-02,
     +0.1545D-02,0.3555D-03,0.7923D-04,0.3514D-11/

       DATA (XQDUM (I, 6,4),I=1, 76) /

     +0.3050D+04,0.3099D+04,0.3068D+04,0.2977D+04,0.2847D+04,0.2689D+04,
     +0.2515D+04,0.2333D+04,0.2149D+04,0.1967D+04,0.1791D+04,0.1624D+04,
     +0.1466D+04,0.1319D+04,0.1182D+04,0.1057D+04,0.9419D+03,0.8377D+03,
     +0.7432D+03,0.6579D+03,0.5814D+03,0.5129D+03,0.4515D+03,0.3972D+03,
     +0.3489D+03,0.3059D+03,0.2678D+03,0.2343D+03,0.2047D+03,0.1787D+03,
     +0.1557D+03,0.1356D+03,0.1180D+03,0.1025D+03,0.8893D+02,0.7705D+02,
     +0.6665D+02,0.5756D+02,0.4961D+02,0.4265D+02,0.3658D+02,0.3127D+02,
     +0.2665D+02,0.2262D+02,0.1910D+02,0.1606D+02,0.1341D+02,0.1112D+02,
     +0.9146D+01,0.7460D+01,0.6015D+01,0.4791D+01,0.3766D+01,0.2914D+01,
     +0.2215D+01,0.1650D+01,0.1201D+01,0.8547D+00,0.5919D+00,0.3982D+00,
     +0.3094D+00,0.2411D+00,0.1887D+00,0.1479D+00,0.1159D+00,0.9056D-01,
     +0.7032D-01,0.5396D-01,0.4058D-01,0.2965D-01,0.2067D-01,0.1341D-01,
     +0.7658D-02,0.3379D-02,0.1476D-02,0.1714D-06/

       DATA (XQDUM (I, 6,5),I=1, 76) /

     +0.3292D+04,0.3321D+04,0.3271D+04,0.3164D+04,0.3018D+04,0.2846D+04,
     +0.2658D+04,0.2464D+04,0.2269D+04,0.2077D+04,0.1892D+04,0.1715D+04,
     +0.1550D+04,0.1395D+04,0.1252D+04,0.1120D+04,0.9993D+03,0.8898D+03,
     +0.7905D+03,0.7008D+03,0.6203D+03,0.5481D+03,0.4832D+03,0.4259D+03,
     +0.3748D+03,0.3291D+03,0.2887D+03,0.2531D+03,0.2215D+03,0.1937D+03,
     +0.1691D+03,0.1475D+03,0.1286D+03,0.1119D+03,0.9718D+02,0.8431D+02,
     +0.7301D+02,0.6311D+02,0.5444D+02,0.4682D+02,0.4017D+02,0.3434D+02,
     +0.2925D+02,0.2480D+02,0.2092D+02,0.1756D+02,0.1463D+02,0.1209D+02,
     +0.9891D+01,0.8020D+01,0.6414D+01,0.5056D+01,0.3920D+01,0.2977D+01,
     +0.2206D+01,0.1588D+01,0.1102D+01,0.7329D+00,0.4609D+00,0.2698D+00,
     +0.1872D+00,0.1278D+00,0.8563D-01,0.5604D-01,0.3573D-01,0.2201D-01,
     +0.1304D-01,0.7353D-02,0.3882D-02,0.1890D-02,0.8181D-03,0.2997D-03,
     +0.8240D-04,0.1253D-04,0.1690D-05,-.1947D-11/

       DATA (XQDUM (I, 6,6),I=1, 76) /

     +0.8255D+05,0.6946D+05,0.5855D+05,0.4927D+05,0.4147D+05,0.3491D+05,
     +0.2938D+05,0.2473D+05,0.2081D+05,0.1751D+05,0.1473D+05,0.1239D+05,
     +0.1042D+05,0.8757D+04,0.7358D+04,0.6180D+04,0.5189D+04,0.4356D+04,
     +0.3655D+04,0.3064D+04,0.2568D+04,0.2150D+04,0.1798D+04,0.1505D+04,
     +0.1258D+04,0.1050D+04,0.8755D+03,0.7296D+03,0.6071D+03,0.5048D+03,
     +0.4188D+03,0.3472D+03,0.2874D+03,0.2373D+03,0.1956D+03,0.1609D+03,
     +0.1321D+03,0.1081D+03,0.8825D+02,0.7178D+02,0.5820D+02,0.4700D+02,
     +0.3779D+02,0.3024D+02,0.2405D+02,0.1904D+02,0.1496D+02,0.1166D+02,
     +0.8997D+01,0.6886D+01,0.5202D+01,0.3878D+01,0.2848D+01,0.2053D+01,
     +0.1447D+01,0.9938D+00,0.6606D+00,0.4228D+00,0.2574D+00,0.1468D+00,
     +0.1007D+00,0.6820D-01,0.4552D-01,0.2975D-01,0.1900D-01,0.1175D-01,
     +0.6996D-02,0.3964D-02,0.2100D-02,0.1021D-02,0.4368D-03,0.1553D-03,
     +0.4005D-04,0.5437D-05,0.7009D-06,-.3133D-13/

       DATA (XQDUM (I, 7,1),I=1, 76) /

     +0.1437D+05,0.1307D+05,0.1184D+05,0.1066D+05,0.9571D+04,0.8561D+04,
     +0.7631D+04,0.6783D+04,0.6010D+04,0.5312D+04,0.4681D+04,0.4117D+04,
     +0.3612D+04,0.3161D+04,0.2761D+04,0.2406D+04,0.2093D+04,0.1817D+04,
     +0.1575D+04,0.1362D+04,0.1175D+04,0.1013D+04,0.8702D+03,0.7474D+03,
     +0.6406D+03,0.5477D+03,0.4673D+03,0.3982D+03,0.3385D+03,0.2873D+03,
     +0.2432D+03,0.2056D+03,0.1734D+03,0.1458D+03,0.1224D+03,0.1025D+03,
     +0.8562D+02,0.7134D+02,0.5926D+02,0.4907D+02,0.4051D+02,0.3333D+02,
     +0.2732D+02,0.2230D+02,0.1812D+02,0.1467D+02,0.1181D+02,0.9451D+01,
     +0.7510D+01,0.5935D+01,0.4647D+01,0.3606D+01,0.2771D+01,0.2104D+01,
     +0.1575D+01,0.1159D+01,0.8363D+00,0.5893D+00,0.4025D+00,0.2640D+00,
     +0.1999D+00,0.1504D+00,0.1124D+00,0.8305D-01,0.6054D-01,0.4327D-01,
     +0.3022D-01,0.2045D-01,0.1325D-01,0.8117D-02,0.4574D-02,0.2281D-02,
     +0.9200D-03,0.2435D-03,0.6341D-04,0.2639D-10/

       DATA (XQDUM (I, 7,2),I=1, 76) /

     +0.4042D+04,0.3967D+04,0.3825D+04,0.3637D+04,0.3419D+04,0.3185D+04,
     +0.2943D+04,0.2702D+04,0.2466D+04,0.2240D+04,0.2025D+04,0.1824D+04,
     +0.1637D+04,0.1464D+04,0.1305D+04,0.1161D+04,0.1030D+04,0.9119D+03,
     +0.8056D+03,0.7102D+03,0.6252D+03,0.5494D+03,0.4818D+03,0.4224D+03,
     +0.3697D+03,0.3230D+03,0.2818D+03,0.2457D+03,0.2140D+03,0.1862D+03,
     +0.1618D+03,0.1404D+03,0.1218D+03,0.1055D+03,0.9120D+02,0.7878D+02,
     +0.6794D+02,0.5849D+02,0.5026D+02,0.4308D+02,0.3684D+02,0.3140D+02,
     +0.2668D+02,0.2257D+02,0.1901D+02,0.1594D+02,0.1327D+02,0.1097D+02,
     +0.8992D+01,0.7313D+01,0.5877D+01,0.4667D+01,0.3656D+01,0.2820D+01,
     +0.2136D+01,0.1586D+01,0.1151D+01,0.8158D+00,0.5630D+00,0.3773D+00,
     +0.2924D+00,0.2273D+00,0.1774D+00,0.1386D+00,0.1083D+00,0.8428D-01,
     +0.6515D-01,0.4974D-01,0.3718D-01,0.2697D-01,0.1864D-01,0.1197D-01,
     +0.6735D-02,0.2908D-02,0.1243D-02,0.1132D-06/

       DATA (XQDUM (I, 7,3),I=1, 76) /

     +0.3734D+04,0.3679D+04,0.3557D+04,0.3386D+04,0.3185D+04,0.2967D+04,
     +0.2740D+04,0.2513D+04,0.2290D+04,0.2076D+04,0.1872D+04,0.1682D+04,
     +0.1505D+04,0.1341D+04,0.1192D+04,0.1056D+04,0.9324D+03,0.8216D+03,
     +0.7222D+03,0.6332D+03,0.5541D+03,0.4839D+03,0.4215D+03,0.3670D+03,
     +0.3189D+03,0.2764D+03,0.2393D+03,0.2069D+03,0.1786D+03,0.1541D+03,
     +0.1327D+03,0.1142D+03,0.9816D+02,0.8425D+02,0.7226D+02,0.6193D+02,
     +0.5302D+02,0.4536D+02,0.3876D+02,0.3309D+02,0.2822D+02,0.2404D+02,
     +0.2045D+02,0.1737D+02,0.1472D+02,0.1246D+02,0.1051D+02,0.8837D+01,
     +0.7395D+01,0.6166D+01,0.5104D+01,0.4195D+01,0.3417D+01,0.2753D+01,
     +0.2187D+01,0.1707D+01,0.1304D+01,0.9705D+00,0.6972D+00,0.4781D+00,
     +0.3704D+00,0.2839D+00,0.2151D+00,0.1602D+00,0.1172D+00,0.8362D-01,
     +0.5795D-01,0.3864D-01,0.2448D-01,0.1451D-01,0.7806D-02,0.3644D-02,
     +0.1333D-02,0.3001D-03,0.6540D-04,0.2268D-11/

       DATA (XQDUM (I, 7,4),I=1, 76) /

     +0.4042D+04,0.3967D+04,0.3825D+04,0.3637D+04,0.3419D+04,0.3185D+04,
     +0.2943D+04,0.2702D+04,0.2466D+04,0.2240D+04,0.2025D+04,0.1824D+04,
     +0.1637D+04,0.1464D+04,0.1305D+04,0.1161D+04,0.1030D+04,0.9119D+03,
     +0.8056D+03,0.7102D+03,0.6252D+03,0.5494D+03,0.4818D+03,0.4224D+03,
     +0.3697D+03,0.3230D+03,0.2818D+03,0.2457D+03,0.2140D+03,0.1862D+03,
     +0.1618D+03,0.1404D+03,0.1218D+03,0.1055D+03,0.9120D+02,0.7878D+02,
     +0.6794D+02,0.5849D+02,0.5026D+02,0.4308D+02,0.3684D+02,0.3140D+02,
     +0.2668D+02,0.2257D+02,0.1901D+02,0.1594D+02,0.1327D+02,0.1097D+02,
     +0.8992D+01,0.7313D+01,0.5877D+01,0.4667D+01,0.3656D+01,0.2820D+01,
     +0.2136D+01,0.1586D+01,0.1151D+01,0.8158D+00,0.5630D+00,0.3773D+00,
     +0.2924D+00,0.2273D+00,0.1774D+00,0.1386D+00,0.1083D+00,0.8428D-01,
     +0.6515D-01,0.4974D-01,0.3718D-01,0.2697D-01,0.1864D-01,0.1197D-01,
     +0.6735D-02,0.2908D-02,0.1243D-02,0.1132D-06/

       DATA (XQDUM (I, 7,5),I=1, 76) /

     +0.4285D+04,0.4190D+04,0.4030D+04,0.3824D+04,0.3591D+04,0.3342D+04,
     +0.3087D+04,0.2834D+04,0.2587D+04,0.2350D+04,0.2125D+04,0.1915D+04,
     +0.1720D+04,0.1540D+04,0.1375D+04,0.1224D+04,0.1087D+04,0.9640D+03,
     +0.8529D+03,0.7531D+03,0.6640D+03,0.5845D+03,0.5134D+03,0.4509D+03,
     +0.3954D+03,0.3461D+03,0.3026D+03,0.2644D+03,0.2306D+03,0.2011D+03,
     +0.1750D+03,0.1522D+03,0.1322D+03,0.1147D+03,0.9935D+02,0.8593D+02,
     +0.7420D+02,0.6395D+02,0.5500D+02,0.4717D+02,0.4035D+02,0.3440D+02,
     +0.2921D+02,0.2470D+02,0.2077D+02,0.1738D+02,0.1443D+02,0.1189D+02,
     +0.9700D+01,0.7839D+01,0.6249D+01,0.4909D+01,0.3792D+01,0.2869D+01,
     +0.2118D+01,0.1517D+01,0.1048D+01,0.6936D+00,0.4339D+00,0.2524D+00,
     +0.1745D+00,0.1185D+00,0.7913D-01,0.5156D-01,0.3272D-01,0.2006D-01,
     +0.1183D-01,0.6630D-02,0.3479D-02,0.1682D-02,0.7220D-03,0.2618D-03,
     +0.7095D-04,0.1054D-04,0.1383D-05,-.1269D-11/

       DATA (XQDUM (I, 7,6),I=1, 76) /

     +0.8179D+05,0.6887D+05,0.5808D+05,0.4890D+05,0.4118D+05,0.3468D+05,
     +0.2921D+05,0.2460D+05,0.2071D+05,0.1743D+05,0.1466D+05,0.1234D+05,
     +0.1038D+05,0.8727D+04,0.7334D+04,0.6161D+04,0.5175D+04,0.4345D+04,
     +0.3645D+04,0.3056D+04,0.2561D+04,0.2145D+04,0.1794D+04,0.1501D+04,
     +0.1255D+04,0.1047D+04,0.8724D+03,0.7268D+03,0.6046D+03,0.5025D+03,
     +0.4167D+03,0.3452D+03,0.2856D+03,0.2357D+03,0.1941D+03,0.1596D+03,
     +0.1308D+03,0.1070D+03,0.8727D+02,0.7091D+02,0.5743D+02,0.4632D+02,
     +0.3720D+02,0.2972D+02,0.2360D+02,0.1866D+02,0.1463D+02,0.1138D+02,
     +0.8768D+01,0.6697D+01,0.5048D+01,0.3754D+01,0.2749D+01,0.1976D+01,
     +0.1389D+01,0.9506D+00,0.6296D+00,0.4013D+00,0.2431D+00,0.1379D+00,
     +0.9429D-01,0.6360D-01,0.4229D-01,0.2753D-01,0.1750D-01,0.1077D-01,
     +0.6381D-02,0.3596D-02,0.1893D-02,0.9134D-03,0.3876D-03,0.1363D-03,
     +0.3468D-04,0.4609D-05,0.5808D-06,-.2149D-13/

       DATA (XQDUM (I, 8,1),I=1, 76) /

     +0.1940D+05,0.1735D+05,0.1549D+05,0.1376D+05,0.1220D+05,0.1078D+05,
     +0.9509D+04,0.8365D+04,0.7340D+04,0.6427D+04,0.5615D+04,0.4896D+04,
     +0.4261D+04,0.3700D+04,0.3207D+04,0.2775D+04,0.2396D+04,0.2066D+04,
     +0.1778D+04,0.1527D+04,0.1310D+04,0.1121D+04,0.9573D+03,0.8171D+03,
     +0.6960D+03,0.5913D+03,0.5014D+03,0.4246D+03,0.3587D+03,0.3026D+03,
     +0.2546D+03,0.2138D+03,0.1793D+03,0.1498D+03,0.1250D+03,0.1040D+03,
     +0.8627D+02,0.7140D+02,0.5891D+02,0.4844D+02,0.3971D+02,0.3243D+02,
     +0.2638D+02,0.2136D+02,0.1722D+02,0.1382D+02,0.1103D+02,0.8739D+01,
     +0.6875D+01,0.5376D+01,0.4162D+01,0.3191D+01,0.2420D+01,0.1812D+01,
     +0.1336D+01,0.9671D+00,0.6848D+00,0.4727D+00,0.3155D+00,0.2015D+00,
     +0.1498D+00,0.1107D+00,0.8114D-01,0.5872D-01,0.4189D-01,0.2925D-01,
     +0.1991D-01,0.1311D-01,0.8231D-02,0.4866D-02,0.2629D-02,0.1245D-02,
     +0.4695D-03,0.1125D-03,0.2647D-04,0.3699D-11/

       DATA (XQDUM (I, 8,2),I=1, 76) /

     +0.6464D+04,0.6065D+04,0.5642D+04,0.5204D+04,0.4768D+04,0.4344D+04,
     +0.3938D+04,0.3553D+04,0.3193D+04,0.2860D+04,0.2552D+04,0.2271D+04,
     +0.2015D+04,0.1784D+04,0.1575D+04,0.1388D+04,0.1221D+04,0.1072D+04,
     +0.9389D+03,0.8213D+03,0.7175D+03,0.6258D+03,0.5448D+03,0.4743D+03,
     +0.4123D+03,0.3578D+03,0.3101D+03,0.2686D+03,0.2324D+03,0.2009D+03,
     +0.1734D+03,0.1496D+03,0.1290D+03,0.1110D+03,0.9539D+02,0.8189D+02,
     +0.7019D+02,0.6007D+02,0.5131D+02,0.4372D+02,0.3716D+02,0.3149D+02,
     +0.2659D+02,0.2236D+02,0.1872D+02,0.1560D+02,0.1291D+02,0.1061D+02,
     +0.8640D+01,0.6982D+01,0.5575D+01,0.4398D+01,0.3423D+01,0.2622D+01,
     +0.1973D+01,0.1455D+01,0.1048D+01,0.7377D+00,0.5053D+00,0.3360D+00,
     +0.2590D+00,0.2003D+00,0.1554D+00,0.1206D+00,0.9360D-01,0.7225D-01,
     +0.5534D-01,0.4179D-01,0.3084D-01,0.2204D-01,0.1496D-01,0.9387D-02,
     +0.5126D-02,0.2116D-02,0.8639D-03,0.4726D-07/

       DATA (XQDUM (I, 8,3),I=1, 76) /

     +0.6147D+04,0.5769D+04,0.5366D+04,0.4946D+04,0.4528D+04,0.4120D+04,
     +0.3729D+04,0.3359D+04,0.3013D+04,0.2692D+04,0.2396D+04,0.2126D+04,
     +0.1881D+04,0.1659D+04,0.1460D+04,0.1281D+04,0.1122D+04,0.9801D+03,
     +0.8545D+03,0.7435D+03,0.6458D+03,0.5599D+03,0.4843D+03,0.4187D+03,
     +0.3614D+03,0.3113D+03,0.2677D+03,0.2300D+03,0.1973D+03,0.1692D+03,
     +0.1448D+03,0.1238D+03,0.1058D+03,0.9024D+02,0.7692D+02,0.6552D+02,
     +0.5575D+02,0.4741D+02,0.4027D+02,0.3417D+02,0.2896D+02,0.2452D+02,
     +0.2073D+02,0.1750D+02,0.1474D+02,0.1240D+02,0.1039D+02,0.8680D+01,
     +0.7216D+01,0.5976D+01,0.4913D+01,0.4009D+01,0.3242D+01,0.2591D+01,
     +0.2041D+01,0.1580D+01,0.1195D+01,0.8803D+00,0.6251D+00,0.4231D+00,
     +0.3250D+00,0.2468D+00,0.1852D+00,0.1367D+00,0.9893D-01,0.6979D-01,
     +0.4779D-01,0.3145D-01,0.1963D-01,0.1144D-01,0.6037D-02,0.2751D-02,
     +0.9750D-03,0.2097D-03,0.4361D-04,0.9011D-12/

       DATA (XQDUM (I, 8,4),I=1, 76) /

     +0.6464D+04,0.6065D+04,0.5642D+04,0.5204D+04,0.4768D+04,0.4344D+04,
     +0.3938D+04,0.3553D+04,0.3193D+04,0.2860D+04,0.2552D+04,0.2271D+04,
     +0.2015D+04,0.1784D+04,0.1575D+04,0.1388D+04,0.1221D+04,0.1072D+04,
     +0.9389D+03,0.8213D+03,0.7175D+03,0.6258D+03,0.5448D+03,0.4743D+03,
     +0.4123D+03,0.3578D+03,0.3101D+03,0.2686D+03,0.2324D+03,0.2009D+03,
     +0.1734D+03,0.1496D+03,0.1290D+03,0.1110D+03,0.9539D+02,0.8189D+02,
     +0.7019D+02,0.6007D+02,0.5131D+02,0.4372D+02,0.3716D+02,0.3149D+02,
     +0.2659D+02,0.2236D+02,0.1872D+02,0.1560D+02,0.1291D+02,0.1061D+02,
     +0.8640D+01,0.6982D+01,0.5575D+01,0.4398D+01,0.3423D+01,0.2622D+01,
     +0.1973D+01,0.1455D+01,0.1048D+01,0.7377D+00,0.5053D+00,0.3360D+00,
     +0.2590D+00,0.2003D+00,0.1554D+00,0.1206D+00,0.9360D-01,0.7225D-01,
     +0.5534D-01,0.4179D-01,0.3084D-01,0.2204D-01,0.1496D-01,0.9387D-02,
     +0.5126D-02,0.2116D-02,0.8639D-03,0.4726D-07/

       DATA (XQDUM (I, 8,5),I=1, 76) /

     +0.6711D+04,0.6291D+04,0.5849D+04,0.5393D+04,0.4942D+04,0.4503D+04,
     +0.4083D+04,0.3686D+04,0.3314D+04,0.2970D+04,0.2653D+04,0.2363D+04,
     +0.2099D+04,0.1860D+04,0.1645D+04,0.1451D+04,0.1278D+04,0.1124D+04,
     +0.9861D+03,0.8640D+03,0.7561D+03,0.6607D+03,0.5763D+03,0.5026D+03,
     +0.4378D+03,0.3806D+03,0.3306D+03,0.2870D+03,0.2488D+03,0.2155D+03,
     +0.1864D+03,0.1611D+03,0.1392D+03,0.1200D+03,0.1033D+03,0.8882D+02,
     +0.7624D+02,0.6532D+02,0.5585D+02,0.4762D+02,0.4049D+02,0.3432D+02,
     +0.2898D+02,0.2435D+02,0.2035D+02,0.1693D+02,0.1397D+02,0.1144D+02,
     +0.9272D+01,0.7443D+01,0.5893D+01,0.4596D+01,0.3523D+01,0.2645D+01,
     +0.1936D+01,0.1375D+01,0.9406D+00,0.6159D+00,0.3808D+00,0.2187D+00,
     +0.1499D+00,0.1010D+00,0.6679D-01,0.4311D-01,0.2710D-01,0.1644D-01,
     +0.9588D-02,0.5311D-02,0.2750D-02,0.1310D-02,0.5524D-03,0.1959D-03,
     +0.5151D-04,0.7292D-05,0.9024D-06,-.5149D-12/

       DATA (XQDUM (I, 8,6),I=1, 76) /

     +0.8066D+05,0.6799D+05,0.5739D+05,0.4837D+05,0.4077D+05,0.3437D+05,
     +0.2897D+05,0.2441D+05,0.2057D+05,0.1732D+05,0.1458D+05,0.1228D+05,
     +0.1033D+05,0.8690D+04,0.7306D+04,0.6139D+04,0.5156D+04,0.4329D+04,
     +0.3632D+04,0.3045D+04,0.2551D+04,0.2136D+04,0.1785D+04,0.1493D+04,
     +0.1247D+04,0.1040D+04,0.8661D+03,0.7209D+03,0.5990D+03,0.4973D+03,
     +0.4119D+03,0.3408D+03,0.2815D+03,0.2320D+03,0.1907D+03,0.1565D+03,
     +0.1281D+03,0.1045D+03,0.8506D+02,0.6895D+02,0.5570D+02,0.4480D+02,
     +0.3588D+02,0.2858D+02,0.2262D+02,0.1782D+02,0.1392D+02,0.1079D+02,
     +0.8276D+01,0.6294D+01,0.4721D+01,0.3493D+01,0.2544D+01,0.1817D+01,
     +0.1269D+01,0.8623D+00,0.5665D+00,0.3579D+00,0.2147D+00,0.1204D+00,
     +0.8167D-01,0.5464D-01,0.3602D-01,0.2324D-01,0.1464D-01,0.8916D-02,
     +0.5225D-02,0.2909D-02,0.1510D-02,0.7176D-03,0.2989D-03,0.1028D-03,
     +0.2537D-04,0.3221D-05,0.3865D-06,-.9582D-14/



      data xmin/1.e-03/,xmax/.99/
      data istep/0/
      save
      if(istep.eq.0) then
      do  i=1,ix
        x(i)=log10(xco(i))
      enddo
      do  i=1,iq
        y(i)=log(q2(i))
      enddo
        istep=1
      endif
      if (strfun(1:2) .eq. 'up' ) then
        ifun =3
      else if (strfun(1:2) .eq. 'do') then
        ifun =2
      else if (strfun(1:2) .eq. 'gl') then
        ifun =1
      else if (strfun(1:2) .eq. 'sb') then
        ifun =4
      else if (strfun(1:2) .eq. 'cb') then
        ifun =5
      else if (strfun(1:2) .eq. 'bb') then
        ifun =6
      endif
      do i=1,ix
        do j=1,iq
          f(i,j)=xqdum(i,j,ifun)
        enddo
      enddo
      func=0.
      if(z.gt.xmin.and.z.lt.xmax) then
      a=log10(z)
      b=log(qstar2)
      call locate(x,ix,a,jx)
      call locate(y,iq,b,jq)
      do ijx=1,igt
        if (jx.eq.1) then
          x1a(ijx)=x(jx+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.(ix-1)) then
          x1a(ijx)=x(jx-3+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-3+ijx,jq-2+ijq)
            endif
          enddo
        else if (jx.eq.ix) then
          x1a(ijx)=x(jx-4+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-4+ijx,jq-2+ijq)
            endif
          enddo
        else
          x1a(ijx)=x(jx-2+ijx)
          do ijq=1,igt
            if (jq.eq.1) then
              x2a(ijq)=y(jq+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq+ijq)
            else if (jq.eq.(iq-1)) then
              x2a(ijq)=y(jq-3+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-3+ijq)
            else if (jq.eq.iq) then
              x2a(ijq)=y(jq-4+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-4+ijq)
            else
              x2a(ijq)=y(jq-2+ijq)
              ya(ijx,ijq)=f(jx-2+ijx,jq-2+ijq)
            endif
          enddo
        endif
      enddo
      call dpolin2(x1a,x2a,ya,4,4,a,b,yy,dy)
      func = yy
      endif
      end
